diff -pruN 0.1.17-1/debian/changelog 0.2.0-1/debian/changelog
--- 0.1.17-1/debian/changelog	2020-11-03 16:03:04.000000000 +0000
+++ 0.2.0-1/debian/changelog	2020-11-27 10:04:40.000000000 +0000
@@ -1,3 +1,12 @@
+chatty (0.2.0-1) unstable; urgency=medium
+
+  [ Evangelos Ribeiro Tzaras ]
+  * Update to version 0.2.0
+  [ Henry-Nicolas Tourneur ]
+  * Fix incorrect recommend package name (Closes: #973832)
+
+ -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Fri, 27 Nov 2020 11:04:40 +0100
+
 chatty (0.1.17-1) unstable; urgency=medium
 
   [ Evangelos Ribeiro Tzaras ]
diff -pruN 0.1.17-1/debian/control 0.2.0-1/debian/control
--- 0.1.17-1/debian/control	2020-11-03 16:03:04.000000000 +0000
+++ 0.2.0-1/debian/control	2020-11-27 10:04:40.000000000 +0000
@@ -14,8 +14,9 @@ Build-Depends:
  libebook1.2-dev,
  libfeedback-dev,
  libgtk-3-dev,
- libhandy-0.0-dev (>= 0.0.10),
+ libhandy-1-dev (>= 1.0.0),
  libpurple-dev,
+ libphonenumber-dev,
  libsqlite3-dev,
  gsettings-desktop-schemas-dev,
  meson,
@@ -31,12 +32,14 @@ Depends:
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- purple-carbons,
  purple-lurch,
  purple-mm-sms,
+ purple-xmpp-carbons,
  purple-xmpp-http-upload,
 Suggests:
  gnome-calls,
 Description: XMPP and SMS messaging
- Chatty is a chat application for XMPP and SMS using
- libpurple and Modemmanager.
+ Chatty is a GTK based chat application supporting SMS and XMPP.
+ .
+ It works on desktops but also adjusts to small screen sizes like smart phones
+ and other mobile devices.
diff -pruN 0.1.17-1/.gitlab-ci.yml 0.2.0-1/.gitlab-ci.yml
--- 0.1.17-1/.gitlab-ci.yml	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/.gitlab-ci.yml	2020-11-27 09:44:20.000000000 +0000
@@ -19,6 +19,7 @@ before_script:
   - wget -O- https://ci.puri.sm/ci-repo.key | apt-key add -
   - apt-get -y update
   - apt-get -y build-dep .
+  - apt-get -y install libgtk-3-bin xvfb
 
 build-debian-gcc-buster:
   <<: *tags
@@ -60,7 +61,7 @@ test:debian-gcc:
   script:
     - export G_DEBUG=fatal-warnings
     - export LC_ALL=C.UTF-8
-    - ninja -C _build test
+    - xvfb-run -a -s "-screen 0 1024x768x24" ninja -C _build test
     - ninja -C _build coverage
   coverage: '/^\s+lines\.+:\s+([\d.]+\%)\s+/'
 
diff -pruN 0.1.17-1/meson.build 0.2.0-1/meson.build
--- 0.1.17-1/meson.build	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/meson.build	2020-11-27 09:44:20.000000000 +0000
@@ -1,5 +1,7 @@
-project('chatty', 'c',        version: '0.1.17',
-  meson_version: '>= 0.41.0',
+project(
+  'chatty', 'c', 'cpp',
+  version: '0.2.0',
+  meson_version: '>= 0.46.0',
 )
 
 i18n = import('i18n')
diff -pruN 0.1.17-1/po/ko.po 0.2.0-1/po/ko.po
--- 0.1.17-1/po/ko.po	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/po/ko.po	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,802 @@
+# Korean translation for chatty.
+# Copyright (C) 2020 chatty's authors and contributors.
+# This file is distributed under the same license as the chatty package.
+# Seong-ho Cho <shcho@gnome.org>, 2020.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: chatty master\n"
+"Report-Msgid-Bugs-To: https://source.puri.sm/Librem5/chatty/issues\n"
+"POT-Creation-Date: 2020-09-13 03:25+0000\n"
+"PO-Revision-Date: 2020-09-13 14:05+0900\n"
+"Language-Team: Korean <gnome-kr@googlegroups.com>\n"
+"Language: ko\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=1; plural=0;\n"
+"Last-Translator: Seong-ho Cho <shcho@gnome.org>\n"
+"X-Generator: Poedit 2.3.1\n"
+
+#: data/sm.puri.Chatty.desktop.in:3 data/sm.puri.Chatty.metainfo.xml.in:6
+#: src/chatty-application.c:304 src/ui/chatty-window.ui:225
+msgid "Chats"
+msgstr "대화"
+
+#: data/sm.puri.Chatty.desktop.in:5
+msgid "sm.puri.Chatty"
+msgstr "sm.puri.Chatty"
+
+#: data/sm.puri.Chatty.desktop.in:6
+msgid "SMS and XMPP chat application"
+msgstr "SMS 및 XMPP 대화 프로그램"
+
+#: data/sm.puri.Chatty.desktop.in:7
+msgid "XMPP;SMS;chat;jabber;messaging;modem"
+msgstr "XMPP;SMS;단문;문자;chat;대화;jabber;재버;messaging;modem;모뎀;"
+
+#: data/sm.puri.Chatty.gschema.xml:7 data/sm.puri.Chatty.gschema.xml:8
+msgid "Whether the application is launching the first time"
+msgstr "프로그램을 처음 실행했는지 여부"
+
+#: data/sm.puri.Chatty.gschema.xml:13
+msgid "Country code in ISO 3166-1 alpha-2 format"
+msgstr "ISO 3166-1 alpha-2 형식의 국가 코드"
+
+#: data/sm.puri.Chatty.gschema.xml:14
+msgid "Two letter country code of the last available SIM/Network"
+msgstr "최근 존재하는 SIM/네트워크의 2문자 기반 국가 코드"
+
+#: data/sm.puri.Chatty.gschema.xml:19
+msgid "Send message read receipts"
+msgstr "메시지 읽음 상태 보내기"
+
+#: data/sm.puri.Chatty.gschema.xml:20
+msgid "Whether to send the status of the message if read"
+msgstr "메시지 읽음 상태를 보낼지 여부"
+
+#: data/sm.puri.Chatty.gschema.xml:25
+msgid "Message carbon copies"
+msgstr "메시지 참조자"
+
+#: data/sm.puri.Chatty.gschema.xml:26 src/ui/chatty-settings-dialog.ui:153
+msgid "Share chat history among devices"
+msgstr "장치간 대화 기록 공유"
+
+#: data/sm.puri.Chatty.gschema.xml:31
+msgid "Enable Message Archive Management"
+msgstr "메시지 보관 관리자 활성"
+
+#: data/sm.puri.Chatty.gschema.xml:32
+msgid "Enable MAM archive synchronization from the server"
+msgstr "서버와 MAM 보관 동기화 활성"
+
+#: data/sm.puri.Chatty.gschema.xml:37
+msgid "Send typing notifications"
+msgstr "입력 중 알림 보내기"
+
+#: data/sm.puri.Chatty.gschema.xml:38
+msgid "Whether to Send typing notifications"
+msgstr "입력중 알림을 보낼지 여부"
+
+#: data/sm.puri.Chatty.gschema.xml:43 data/sm.puri.Chatty.gschema.xml:44
+msgid "Mark offline users differently"
+msgstr "오프라인 사용자를 다르게 표시"
+
+#: data/sm.puri.Chatty.gschema.xml:49 data/sm.puri.Chatty.gschema.xml:50
+msgid "Mark Idle users differently"
+msgstr "대기중인 사용자를 다르게 표시"
+
+#: data/sm.puri.Chatty.gschema.xml:55 data/sm.puri.Chatty.gschema.xml:56
+msgid "Indicate unknown contacts"
+msgstr "알 수 없는 연락처 표시"
+
+#: data/sm.puri.Chatty.gschema.xml:61
+msgid "Convert text to emoticons"
+msgstr "텍스트를 이모티콘으로 변환"
+
+#: data/sm.puri.Chatty.gschema.xml:62
+msgid "Convert text matching emoticons as real emoticons"
+msgstr "일치하는 텍스트 이모티콘을 실제 이모티콘 그림으로 변환"
+
+#: data/sm.puri.Chatty.gschema.xml:67
+msgid "Enter key sends the message"
+msgstr "Enter키를 누르면 메시지 보내기"
+
+#: data/sm.puri.Chatty.gschema.xml:68
+msgid "Whether pressing Enter key sends the message"
+msgstr "Enter키를 눌렀을 때 메시지를 보낼지 여부"
+
+#: data/sm.puri.Chatty.gschema.xml:73
+msgid "Window maximized"
+msgstr "창 최대화"
+
+#: data/sm.puri.Chatty.gschema.xml:74
+msgid "Window maximized state"
+msgstr "창 최대화 상태"
+
+#: data/sm.puri.Chatty.gschema.xml:79
+msgid "Window size"
+msgstr "창 크기"
+
+#: data/sm.puri.Chatty.gschema.xml:80
+msgid "Window size (width, height)."
+msgstr "창 크기(너비, 높이)."
+
+#: data/sm.puri.Chatty.metainfo.xml.in:7
+msgid "A messaging application"
+msgstr "메시징 프로그램"
+
+#: data/sm.puri.Chatty.metainfo.xml.in:9
+msgid "Chats is a messaging application supporting XMPP and SMS."
+msgstr "대화는 XMPP와 SMS를 지원하는 메시징 프로그램입니다."
+
+#: data/sm.puri.Chatty.metainfo.xml.in:16
+msgid "Chats message window"
+msgstr "대화 메시지 창"
+
+#: src/chatty-application.c:68
+msgid "Show release version"
+msgstr "릴리스 버전 표시"
+
+#: src/chatty-application.c:69
+msgid "Start in daemon mode"
+msgstr "데몬 모드로 시작"
+
+#: src/chatty-application.c:70
+msgid "Disable all accounts"
+msgstr "모든 계정 비활성"
+
+#: src/chatty-application.c:71
+msgid "Enable libpurple debug messages"
+msgstr "libpurple 디버깅 메시지 활성"
+
+#: src/chatty-application.c:72
+msgid "Enable verbose libpurple debug messages"
+msgstr "방대한 libpurple 디버깅 메시지 활성"
+
+#: src/chatty-application.c:108
+#, c-format
+msgid "Authorize %s?"
+msgstr "%s 사용자를 수락합니까?"
+
+#: src/chatty-application.c:112
+msgid "Reject"
+msgstr "거절"
+
+#: src/chatty-application.c:114
+msgid "Accept"
+msgstr "수락"
+
+#: src/chatty-application.c:119
+#, c-format
+msgid "Add %s to contact list"
+msgstr "%s 계정을 연락처에 추가"
+
+#: src/chatty-application.c:142
+msgid "Contact added"
+msgstr "연락처에 추가했습니다"
+
+#: src/chatty-application.c:145
+#, c-format
+msgid "User %s has added %s to the contacts"
+msgstr "%s 사용자를 %s 연락처에 추가했습니다"
+
+#: src/chatty-application.c:165
+msgid "Login failed"
+msgstr "로그인 실패"
+
+#: src/chatty-application.c:171
+msgid "Please check ID and password"
+msgstr "ID와 암호를 확인하십시오."
+
+#: src/chatty-chat-view.c:69 src/chatty-chat-view.c:74
+msgid "This is an IM conversation."
+msgstr "인스턴트 메시징 대화입니다."
+
+#: src/chatty-chat-view.c:70 src/chatty-chat-view.c:80
+msgid "Your messages are not encrypted,"
+msgstr "메시지 암호화를 하지 않았습니다,"
+
+#: src/chatty-chat-view.c:71
+msgid "ask your counterpart to use E2EE."
+msgstr "상대방에게 E2EE 사용을 요청하십시오."
+
+#: src/chatty-chat-view.c:75
+msgid "Your messages are secured"
+msgstr "메시지를 암호화 처리했습니다"
+
+#: src/chatty-chat-view.c:76
+msgid "by end-to-end encryption."
+msgstr "(종단간 암호화 처리)."
+
+#: src/chatty-chat-view.c:79
+msgid "This is an SMS conversation."
+msgstr "SMS 대화입니다."
+
+#: src/chatty-chat-view.c:81
+msgid "and carrier rates may apply."
+msgstr "그리고 사용 요금을 청구할 수 있습니다."
+
+#. Translators: Timestamp seconds suffix
+#: src/chatty-list-row.c:73
+msgctxt "timestamp-suffix-seconds"
+msgid "s"
+msgstr "초"
+
+#. Translators: Timestamp minute suffix
+#: src/chatty-list-row.c:75
+msgctxt "timestamp-suffix-minute"
+msgid "m"
+msgstr "분"
+
+#. Translators: Timestamp minutes suffix
+#: src/chatty-list-row.c:77
+msgctxt "timestamp-suffix-minutes"
+msgid "m"
+msgstr "분"
+
+#. Translators: Timestamp hour suffix
+#: src/chatty-list-row.c:79
+msgctxt "timestamp-suffix-hour"
+msgid "h"
+msgstr "시"
+
+#. Translators: Timestamp hours suffix
+#: src/chatty-list-row.c:81
+msgctxt "timestamp-suffix-hours"
+msgid "h"
+msgstr "시간"
+
+#. Translators: Timestamp day suffix
+#: src/chatty-list-row.c:83
+msgctxt "timestamp-suffix-day"
+msgid "d"
+msgstr "일"
+
+#. Translators: Timestamp days suffix
+#: src/chatty-list-row.c:85
+msgctxt "timestamp-suffix-days"
+msgid "d"
+msgstr "일"
+
+#. Translators: Timestamp month suffix
+#: src/chatty-list-row.c:87
+msgctxt "timestamp-suffix-month"
+msgid "mo"
+msgstr "월"
+
+#. Translators: Timestamp months suffix
+#: src/chatty-list-row.c:89
+msgctxt "timestamp-suffix-months"
+msgid "mos"
+msgstr "월"
+
+#. Translators: Timestamp year suffix
+#: src/chatty-list-row.c:91
+msgctxt "timestamp-suffix-year"
+msgid "y"
+msgstr "년"
+
+#. Translators: Timestamp years suffix
+#: src/chatty-list-row.c:93
+msgctxt "timestamp-suffix-years"
+msgid "y"
+msgstr "년"
+
+# Note: 시간의 직전 몇 경과 상태 prefix.
+#. Translators: Timestamp prefix (e.g. Over 5h)
+#: src/chatty-list-row.c:195
+msgid "Over"
+msgstr "지남: "
+
+# Note: 시간의 직전 몇 경과 상태 prefix.
+#. Translators: Timestamp prefix (e.g. Almost 5h)
+#: src/chatty-list-row.c:200
+msgid "Almost"
+msgstr "직전: "
+
+#: src/chatty-list-row.c:217
+msgid "Owner"
+msgstr "소유자"
+
+#: src/chatty-list-row.c:220
+msgid "Moderator"
+msgstr "중재자"
+
+#: src/chatty-list-row.c:223
+msgid "Member"
+msgstr "구성원"
+
+#: src/chatty-manager.c:887
+#, c-format
+msgid "New message from %s"
+msgstr "%s의 새 메시지"
+
+#: src/chatty-message-row.c:89
+msgid "Copy"
+msgstr "복사"
+
+#: src/chatty-notify.c:67
+msgid "Open Message"
+msgstr "메시지 열기"
+
+#: src/chatty-notify.c:72
+msgid "Message Received"
+msgstr "메시지 받음"
+
+#: src/chatty-notify.c:78
+msgid "Message Error"
+msgstr "메시지 오류"
+
+#: src/chatty-notify.c:84
+msgid "Account Info"
+msgstr "계정 정보"
+
+#: src/chatty-notify.c:90
+msgid "Account Connected"
+msgstr "계정 연결함"
+
+#: src/chatty-purple-notify.c:44
+msgid "Close"
+msgstr "닫기"
+
+#: src/chatty-purple-request.c:186
+msgid "Save File..."
+msgstr "파일 저장..."
+
+#: src/chatty-purple-request.c:187
+msgid "Open File..."
+msgstr "파일 열기..."
+
+#: src/chatty-purple-request.c:191 src/chatty-window.c:585
+#: src/dialogs/chatty-settings-dialog.c:443
+#: src/dialogs/chatty-user-info-dialog.c:65 src/ui/chatty-dialog-join-muc.ui:16
+#: src/ui/chatty-dialog-muc-info.ui:56
+msgid "Cancel"
+msgstr "취소"
+
+#: src/chatty-purple-request.c:193
+msgid "Save"
+msgstr "저장"
+
+#: src/chatty-purple-request.c:193 src/dialogs/chatty-settings-dialog.c:442
+#: src/dialogs/chatty-user-info-dialog.c:64
+msgid "Open"
+msgstr "열기"
+
+#. TRANSLATORS: Timestamp from the last week with 24 hour time, e.g. “Tuesday 18∶42”.
+#. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
+#.
+#: src/chatty-utils.c:291
+msgid "%A %H∶%M"
+msgstr "%A %H∶%M"
+
+#. TRANSLATORS: Timestamp from the last week with 12 hour time, e.g. “Tuesday 06∶42 PM”.
+#. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
+#.
+#: src/chatty-utils.c:296
+msgid "%A %I∶%M %p"
+msgstr "%A %p %I∶%M"
+
+#. TRANSLATORS: Timestamp from more than 7 days ago, e.g. “2020-08-11”.
+#. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
+#.
+#: src/chatty-utils.c:303
+msgid "%Y-%m-%d"
+msgstr "%Y-%m-%d"
+
+#: src/chatty-window.c:103 src/chatty-window.c:108 src/chatty-window.c:113
+msgid "Choose a contact"
+msgstr "연락처 선택"
+
+#: src/chatty-window.c:104
+msgid ""
+"Select an <b>SMS</b> or <b>Instant Message</b> contact with the <b>\"+\"</b> "
+"button in the titlebar."
+msgstr ""
+"제목 표시줄의 <b>\"+\"</b> 단추로 <b>SMS</b> 또는 <b>인스턴스 메시지</b> 연락"
+"처를 선택하십시오."
+
+#: src/chatty-window.c:109
+msgid ""
+"Select an <b>Instant Message</b> contact with the \"+\" button in the "
+"titlebar."
+msgstr ""
+"제목 표시줄의 \"+\" 단추로 <b>인스턴트 메시지</b> 연락처를 선택하십시오."
+
+#: src/chatty-window.c:114
+msgid "Start a <b>SMS</b> chat with the \"+\" button in the titlebar."
+msgstr "제목 표시줄의 \"+\" 단추로 <b>SMS</b> 대화를 선택하십시오."
+
+#: src/chatty-window.c:115 src/chatty-window.c:119
+msgid ""
+"For <b>Instant Messaging</b> add or activate an account in <i>\"preferences"
+"\"</i>."
+msgstr ""
+"<i>\"기본 설정\"</i>에서 <b>인스턴트 메시지</b> 연락처를 추가하거나 활성화하"
+"십시오."
+
+#: src/chatty-window.c:118
+msgid "Start chatting"
+msgstr "대화 시작"
+
+#: src/chatty-window.c:570
+msgid "Delete chat with"
+msgstr "다음 대화 삭제"
+
+#: src/chatty-window.c:571
+msgid "This deletes the conversation history"
+msgstr "대화 기록을 지웁니다"
+
+#: src/chatty-window.c:573
+msgid "Disconnect group chat"
+msgstr "단체 대화 나가기"
+
+#: src/chatty-window.c:574
+msgid "This removes chat from chats list"
+msgstr "대화 목록에서 대화를 제거합니다"
+
+#: src/chatty-window.c:587
+msgid "Delete"
+msgstr "삭제"
+
+#: src/chatty-window.c:797
+msgid "An SMS and XMPP messaging client"
+msgstr "SMS 및 XMPP 메시지 전송 클라이언트"
+
+#: src/chatty-window.c:804
+msgid "translator-credits"
+msgstr "조성호 <shcho@gnome.org>"
+
+#: src/dialogs/chatty-muc-info-dialog.c:318
+msgid "members"
+msgstr "명"
+
+#: src/dialogs/chatty-new-chat-dialog.c:146
+msgid "Send To"
+msgstr "다음으로 보내기:"
+
+#: src/dialogs/chatty-new-chat-dialog.c:190
+#, c-format
+msgid "Error opening GNOME Contacts: %s"
+msgstr "그놈 연락처 열기 오류: %s"
+
+#: src/dialogs/chatty-settings-dialog.c:319
+msgid "Select Protocol"
+msgstr "프로토콜을 선택하십시오"
+
+#: src/dialogs/chatty-settings-dialog.c:324
+msgid "Add XMPP account"
+msgstr "XMPP 계정 추가"
+
+#: src/dialogs/chatty-settings-dialog.c:355
+msgid "connected"
+msgstr "연결함"
+
+#: src/dialogs/chatty-settings-dialog.c:357
+msgid "connecting…"
+msgstr "연결중…"
+
+#: src/dialogs/chatty-settings-dialog.c:359
+msgid "disconnected"
+msgstr "연결 끊김"
+
+#: src/dialogs/chatty-settings-dialog.c:439
+#: src/dialogs/chatty-user-info-dialog.c:61
+msgid "Set Avatar"
+msgstr "아바타 설정"
+
+#: src/dialogs/chatty-settings-dialog.c:509
+#: src/ui/chatty-settings-dialog.ui:477
+msgid "Delete Account"
+msgstr "계정 삭제"
+
+#: src/dialogs/chatty-settings-dialog.c:512
+#, c-format
+msgid "Delete account %s?"
+msgstr "%s 계정을 삭제하시겠습니까?"
+
+#: src/dialogs/chatty-user-info-dialog.c:135
+msgid "Encryption not available"
+msgstr "암호화 연결 아님"
+
+#: src/dialogs/chatty-user-info-dialog.c:173
+msgid "Encryption is not available"
+msgstr "암호화 연결중이 아닙니다"
+
+#: src/dialogs/chatty-user-info-dialog.c:175
+msgid "This chat is encrypted"
+msgstr "이 대화는 암호화 처리중입니다"
+
+#: src/dialogs/chatty-user-info-dialog.c:177
+msgid "This chat is not encrypted"
+msgstr "이 대화는 암호화 처리중이 아닙니다."
+
+#: src/dialogs/chatty-user-info-dialog.c:245
+msgid "Phone Number:"
+msgstr "전화번호:"
+
+#: src/ui/chatty-dialog-join-muc.ui:12
+msgid "New Group Chat"
+msgstr "새 단체 대화"
+
+#: src/ui/chatty-dialog-join-muc.ui:28
+msgid "Join Chat"
+msgstr "대화 참여"
+
+#: src/ui/chatty-dialog-join-muc.ui:81 src/ui/chatty-dialog-new-chat.ui:237
+msgid "Select chat account"
+msgstr "대화 계정 선택"
+
+#: src/ui/chatty-dialog-join-muc.ui:155
+msgid "Password (optional)"
+msgstr "암호 (추가)"
+
+#: src/ui/chatty-dialog-muc-info.ui:26
+msgid "Group Details"
+msgstr "단체 정보"
+
+#: src/ui/chatty-dialog-muc-info.ui:52
+msgid "Invite Contact"
+msgstr "연락처 초대"
+
+#: src/ui/chatty-dialog-muc-info.ui:69
+msgid "Invite"
+msgstr "초대"
+
+#: src/ui/chatty-dialog-muc-info.ui:166
+msgid "Room topic"
+msgstr "대화방 주제"
+
+#: src/ui/chatty-dialog-muc-info.ui:225
+msgid "Room settings"
+msgstr "대화방 설정"
+
+#: src/ui/chatty-dialog-muc-info.ui:248 src/ui/chatty-dialog-user-info.ui:209
+msgid "Notifications"
+msgstr "알림"
+
+#: src/ui/chatty-dialog-muc-info.ui:249
+msgid "Show notification badge"
+msgstr "알림 뱃지 표시"
+
+#: src/ui/chatty-dialog-muc-info.ui:265
+msgid "Status Messages"
+msgstr "상태 메시지"
+
+#: src/ui/chatty-dialog-muc-info.ui:266
+msgid "Show status messages in chat"
+msgstr "대화에 상태 메시지 표시"
+
+#: src/ui/chatty-dialog-muc-info.ui:289
+msgid "0 members"
+msgstr "0명"
+
+#: src/ui/chatty-dialog-muc-info.ui:377
+msgid "Invite Message"
+msgstr "메시지 초대"
+
+#: src/ui/chatty-dialog-new-chat.ui:26
+msgid "Start Chat"
+msgstr "대화 시작"
+
+#: src/ui/chatty-dialog-new-chat.ui:55
+msgid "New Contact"
+msgstr "새 연락처"
+
+#: src/ui/chatty-dialog-new-chat.ui:83 src/ui/chatty-window.ui:126
+msgid "Add Contact"
+msgstr "연락처 추가"
+
+#: src/ui/chatty-dialog-new-chat.ui:149
+msgid "Send To:"
+msgstr "다음으로 보내기:"
+
+#: src/ui/chatty-dialog-new-chat.ui:288
+msgid "Name (optional)"
+msgstr "성명 (추가)"
+
+#: src/ui/chatty-dialog-new-chat.ui:328 src/ui/chatty-window.ui:152
+msgid "Add to Contacts"
+msgstr "연락처에 추가"
+
+#: src/ui/chatty-dialog-user-info.ui:12 src/ui/chatty-window.ui:112
+msgid "Chat Details"
+msgstr "대화 정보"
+
+#: src/ui/chatty-dialog-user-info.ui:96
+msgid "XMPP ID"
+msgstr "XMPP ID"
+
+#: src/ui/chatty-dialog-user-info.ui:111 src/ui/chatty-dialog-user-info.ui:225
+msgid "Encryption"
+msgstr "암호화"
+
+#: src/ui/chatty-dialog-user-info.ui:126 src/ui/chatty-settings-dialog.ui:390
+msgid "Status"
+msgstr "상태"
+
+#: src/ui/chatty-dialog-user-info.ui:226
+msgid "Secure messaging using OMEMO"
+msgstr "OMEMO로 보안 대화"
+
+#: src/ui/chatty-dialog-user-info.ui:247
+msgid "Fingerprints"
+msgstr "지문키"
+
+#: src/ui/chatty-settings-dialog.ui:12 src/ui/chatty-window.ui:18
+msgid "Preferences"
+msgstr "기본 설정"
+
+#: src/ui/chatty-settings-dialog.ui:21
+msgid "Back"
+msgstr "뒤로"
+
+#: src/ui/chatty-settings-dialog.ui:41
+msgid "_Add"
+msgstr "추가(_A)"
+
+#: src/ui/chatty-settings-dialog.ui:57
+msgid "_Save"
+msgstr "저장(_S)"
+
+#: src/ui/chatty-settings-dialog.ui:91
+msgid "Accounts"
+msgstr "계정"
+
+#: src/ui/chatty-settings-dialog.ui:105
+msgid "Add new account…"
+msgstr "새 계정 추가…"
+
+#: src/ui/chatty-settings-dialog.ui:117
+msgid "Privacy"
+msgstr "개인 정보"
+
+#: src/ui/chatty-settings-dialog.ui:122
+msgid "Message Receipts"
+msgstr "메시지 수신자"
+
+#: src/ui/chatty-settings-dialog.ui:123
+msgid "Confirm received messages"
+msgstr "수신 메시지 확인"
+
+#: src/ui/chatty-settings-dialog.ui:137
+msgid "Message Archive Management"
+msgstr "메시지 보관 관리자"
+
+#: src/ui/chatty-settings-dialog.ui:138
+msgid "Sync conversations with chat server"
+msgstr "대화 서버와 대화 내용 동기화"
+
+#: src/ui/chatty-settings-dialog.ui:152
+msgid "Message Carbon Copies"
+msgstr "메시지 참조"
+
+#: src/ui/chatty-settings-dialog.ui:167
+msgid "Typing Notification"
+msgstr "입력중 알림"
+
+#: src/ui/chatty-settings-dialog.ui:168
+msgid "Send typing messages"
+msgstr "입력중 메시지 보내기"
+
+#: src/ui/chatty-settings-dialog.ui:185
+msgid "Chats List"
+msgstr "대화 목록"
+
+#: src/ui/chatty-settings-dialog.ui:190
+msgid "Indicate Offline Contacts"
+msgstr "오프라인 연락처 표시"
+
+#: src/ui/chatty-settings-dialog.ui:191
+msgid "Grey out avatars from offline contacts"
+msgstr "오프라인 연락처 아바타를 회색으로 표시"
+
+#: src/ui/chatty-settings-dialog.ui:205
+msgid "Indicate Idle Contacts"
+msgstr "대기중 연락처 표시"
+
+#: src/ui/chatty-settings-dialog.ui:206
+msgid "Blur avatars from idle contacts"
+msgstr "대기중 연락처의 아바타를 흐리게 표시"
+
+#: src/ui/chatty-settings-dialog.ui:220
+msgid "Indicate Unknown Contacts"
+msgstr "알 수 없는 연락처 표시"
+
+#: src/ui/chatty-settings-dialog.ui:221
+msgid "Color unknown contact ID red"
+msgstr "알 수 없는 연락처 ID를 적색으로 표시"
+
+#: src/ui/chatty-settings-dialog.ui:238
+msgid "Editor"
+msgstr "편집기"
+
+#: src/ui/chatty-settings-dialog.ui:243
+msgid "Graphical Emoticons"
+msgstr "그래픽 이모티콘"
+
+#: src/ui/chatty-settings-dialog.ui:244
+msgid "Convert ASCII emoticons"
+msgstr "ASCII 이모티콘 변환"
+
+#: src/ui/chatty-settings-dialog.ui:258
+msgid "Return = Send Message"
+msgstr "Return = 메시지 보내기"
+
+#: src/ui/chatty-settings-dialog.ui:259
+msgid "Send message with return key"
+msgstr "리턴키로 메시지 보내기"
+
+#: src/ui/chatty-settings-dialog.ui:328
+msgid "Account ID"
+msgstr "계정 ID"
+
+#: src/ui/chatty-settings-dialog.ui:361
+msgid "Protocol"
+msgstr "프로토콜"
+
+#: src/ui/chatty-settings-dialog.ui:419 src/ui/chatty-settings-dialog.ui:716
+msgid "Password"
+msgstr "암호"
+
+#: src/ui/chatty-settings-dialog.ui:494
+msgid "Own Fingerprint"
+msgstr "보유 지문키"
+
+#: src/ui/chatty-settings-dialog.ui:520
+msgid "Other Devices"
+msgstr "기타 장치"
+
+#: src/ui/chatty-settings-dialog.ui:604
+msgid "XMPP"
+msgstr "XMPP"
+
+#: src/ui/chatty-settings-dialog.ui:618
+msgid "Matrix"
+msgstr "매트릭스"
+
+#: src/ui/chatty-settings-dialog.ui:633
+msgid "Telegram"
+msgstr "텔레그램"
+
+#: src/ui/chatty-settings-dialog.ui:691
+msgid "Provider"
+msgstr "공급자"
+
+#: src/ui/chatty-window.ui:31
+msgid "About Chats"
+msgstr "대화 정보"
+
+#: src/ui/chatty-window.ui:59
+msgid "New Message…"
+msgstr "새 메시지…"
+
+#: src/ui/chatty-window.ui:72
+msgid "New Group Message…"
+msgstr "새 단체 메시지…"
+
+#: src/ui/chatty-window.ui:85
+msgid "New Bulk SMS…"
+msgstr "새 단체 SMS…"
+
+#: src/ui/chatty-window.ui:177
+msgid "Leave Chat"
+msgstr "대화 나가기"
+
+#: src/ui/chatty-window.ui:190
+msgid "Delete Chat"
+msgstr "대화 삭제"
+
+#: src/users/chatty-contact.c:313
+msgid "Mobile: "
+msgstr "모바일: "
+
+#: src/users/chatty-contact.c:315
+msgid "Work: "
+msgstr "직장: "
+
+#: src/users/chatty-contact.c:317
+msgid "Other: "
+msgstr "기타: "
diff -pruN 0.1.17-1/po/LINGUAS 0.2.0-1/po/LINGUAS
--- 0.1.17-1/po/LINGUAS	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/po/LINGUAS	2020-11-27 09:44:20.000000000 +0000
@@ -10,6 +10,7 @@ fur
 hu
 it
 ja
+ko
 la
 pl
 pt
diff -pruN 0.1.17-1/po/uk.po 0.2.0-1/po/uk.po
--- 0.1.17-1/po/uk.po	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/po/uk.po	2020-11-27 09:44:20.000000000 +0000
@@ -7,8 +7,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: purism-chatty\n"
 "Report-Msgid-Bugs-To: https://source.puri.sm/Librem5/chatty/issues\n"
-"POT-Creation-Date: 2020-08-17 15:25+0000\n"
-"PO-Revision-Date: 2020-08-17 19:15+0300\n"
+"POT-Creation-Date: 2020-11-12 15:25+0000\n"
+"PO-Revision-Date: 2020-11-13 15:33+0200\n"
 "Last-Translator: Yuri Chornoivan <yurchor@ukr.net>\n"
 "Language-Team: Ukrainian <trans-uk@lists.fedoraproject.org>\n"
 "Language: uk\n"
@@ -20,7 +20,7 @@ msgstr ""
 "=4 && (n%100<10 || n%100>=20) ? 1 : 2)\n"
 
 #: data/sm.puri.Chatty.desktop.in:3 data/sm.puri.Chatty.metainfo.xml.in:6
-#: src/chatty-application.c:304 src/ui/chatty-window.ui:224
+#: src/chatty-application.c:304 src/ui/chatty-window.ui:225
 msgid "Chats"
 msgstr "Спілкування"
 
@@ -224,77 +224,66 @@ msgstr "і оператор може с
 
 #. Translators: Timestamp seconds suffix
 #: src/chatty-list-row.c:73
-#| msgid "s"
 msgctxt "timestamp-suffix-seconds"
 msgid "s"
 msgstr "с"
 
 #. Translators: Timestamp minute suffix
 #: src/chatty-list-row.c:75
-#| msgid "m"
 msgctxt "timestamp-suffix-minute"
 msgid "m"
 msgstr "хв"
 
 #. Translators: Timestamp minutes suffix
 #: src/chatty-list-row.c:77
-#| msgid "m"
 msgctxt "timestamp-suffix-minutes"
 msgid "m"
 msgstr "хв"
 
 #. Translators: Timestamp hour suffix
 #: src/chatty-list-row.c:79
-#| msgid "h"
 msgctxt "timestamp-suffix-hour"
 msgid "h"
 msgstr "г"
 
 #. Translators: Timestamp hours suffix
 #: src/chatty-list-row.c:81
-#| msgid "h"
 msgctxt "timestamp-suffix-hours"
 msgid "h"
 msgstr "г"
 
 #. Translators: Timestamp day suffix
 #: src/chatty-list-row.c:83
-#| msgid "d"
 msgctxt "timestamp-suffix-day"
 msgid "d"
 msgstr "д"
 
 #. Translators: Timestamp days suffix
 #: src/chatty-list-row.c:85
-#| msgid "d"
 msgctxt "timestamp-suffix-days"
 msgid "d"
 msgstr "д"
 
 #. Translators: Timestamp month suffix
 #: src/chatty-list-row.c:87
-#| msgid "mo"
 msgctxt "timestamp-suffix-month"
 msgid "mo"
 msgstr "м"
 
 #. Translators: Timestamp months suffix
 #: src/chatty-list-row.c:89
-#| msgid "mos"
 msgctxt "timestamp-suffix-months"
 msgid "mos"
 msgstr "міс"
 
 #. Translators: Timestamp year suffix
 #: src/chatty-list-row.c:91
-#| msgid "y"
 msgctxt "timestamp-suffix-year"
 msgid "y"
 msgstr "р"
 
 #. Translators: Timestamp years suffix
 #: src/chatty-list-row.c:93
-#| msgid "y"
 msgctxt "timestamp-suffix-years"
 msgid "y"
 msgstr "р"
@@ -321,32 +310,32 @@ msgstr "Модератор"
 msgid "Member"
 msgstr "Член"
 
-#: src/chatty-manager.c:879
+#: src/chatty-manager.c:899
 #, c-format
 msgid "New message from %s"
 msgstr "Нове повідомлення від %s"
 
-#: src/chatty-message-row.c:89
+#: src/chatty-message-row.c:94
 msgid "Copy"
 msgstr "Копіювати"
 
-#: src/chatty-notify.c:68
+#: src/chatty-notify.c:67
 msgid "Open Message"
 msgstr "Відкрити повідомлення"
 
-#: src/chatty-notify.c:73
+#: src/chatty-notify.c:72
 msgid "Message Received"
 msgstr "Надійшло повідомлення"
 
-#: src/chatty-notify.c:79
+#: src/chatty-notify.c:78
 msgid "Message Error"
 msgstr "Помилка повідомлення"
 
-#: src/chatty-notify.c:85
+#: src/chatty-notify.c:84
 msgid "Account Info"
 msgstr "Дані щодо облікового запису"
 
-#: src/chatty-notify.c:91
+#: src/chatty-notify.c:90
 msgid "Account Connected"
 msgstr "Обліковий запис з'єднано"
 
@@ -362,8 +351,8 @@ msgstr "Зберегти файл…"
 msgid "Open File..."
 msgstr "Відкрити файл…"
 
-#: src/chatty-purple-request.c:191 src/chatty-window.c:609
-#: src/dialogs/chatty-settings-dialog.c:447
+#: src/chatty-purple-request.c:191 src/chatty-window.c:600
+#: src/dialogs/chatty-settings-dialog.c:443
 #: src/dialogs/chatty-user-info-dialog.c:66 src/ui/chatty-dialog-join-muc.ui:16
 #: src/ui/chatty-dialog-muc-info.ui:56
 msgid "Cancel"
@@ -373,7 +362,7 @@ msgstr "Скасувати"
 msgid "Save"
 msgstr "Зберегти"
 
-#: src/chatty-purple-request.c:193 src/dialogs/chatty-settings-dialog.c:446
+#: src/chatty-purple-request.c:193 src/dialogs/chatty-settings-dialog.c:442
 #: src/dialogs/chatty-user-info-dialog.c:65
 msgid "Open"
 msgstr "Відкрити"
@@ -381,22 +370,21 @@ msgstr "Відкрити"
 #. TRANSLATORS: Timestamp from the last week with 24 hour time, e.g. “Tuesday 18∶42”.
 #. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
 #.
-#: src/chatty-utils.c:298
+#: src/chatty-utils.c:299
 msgid "%A %H∶%M"
 msgstr "%a %H∶%M"
 
 #. TRANSLATORS: Timestamp from the last week with 12 hour time, e.g. “Tuesday 06∶42 PM”.
 #. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
 #.
-#: src/chatty-utils.c:303
-#| msgid "%A %I:%M %p"
+#: src/chatty-utils.c:304
 msgid "%A %I∶%M %p"
 msgstr "%a %I∶%M %p"
 
 #. TRANSLATORS: Timestamp from more than 7 days ago, e.g. “2020-08-11”.
 #. See https://developer.gnome.org/glib/stable/glib-GDateTime.html#g-date-time-format
 #.
-#: src/chatty-utils.c:310
+#: src/chatty-utils.c:311
 msgid "%Y-%m-%d"
 msgstr "%d-%m-%Y"
 
@@ -437,31 +425,31 @@ msgstr ""
 msgid "Start chatting"
 msgstr "Почати спілкування"
 
-#: src/chatty-window.c:592
-msgid "Disconnect group chat"
-msgstr "Від'єднатися від групового спілкування"
-
-#: src/chatty-window.c:593
-msgid "This removes chat from chats list"
-msgstr "У результаті спілкування буде вилучено зі списку спілкувань"
-
-#: src/chatty-window.c:597
+#: src/chatty-window.c:585
 msgid "Delete chat with"
 msgstr "Вилучити спілкування з"
 
-#: src/chatty-window.c:598
+#: src/chatty-window.c:586
 msgid "This deletes the conversation history"
 msgstr "У результаті буде вилучено журнал спілкування"
 
-#: src/chatty-window.c:611
+#: src/chatty-window.c:588
+msgid "Disconnect group chat"
+msgstr "Від'єднатися від групового спілкування"
+
+#: src/chatty-window.c:589
+msgid "This removes chat from chats list"
+msgstr "У результаті спілкування буде вилучено зі списку спілкувань"
+
+#: src/chatty-window.c:602
 msgid "Delete"
 msgstr "Вилучити"
 
-#: src/chatty-window.c:839
+#: src/chatty-window.c:812
 msgid "An SMS and XMPP messaging client"
 msgstr "Клієнт обміну повідомленнями SMS і XMPP"
 
-#: src/chatty-window.c:846
+#: src/chatty-window.c:819
 msgid "translator-credits"
 msgstr "Юрій Чорноіван <yurchor@ukr.net>, 2020"
 
@@ -469,11 +457,11 @@ msgstr "Юрій Чорноіван <yur
 msgid "members"
 msgstr "учасники"
 
-#: src/dialogs/chatty-new-chat-dialog.c:134
+#: src/dialogs/chatty-new-chat-dialog.c:152
 msgid "Send To"
 msgstr "Надіслати"
 
-#: src/dialogs/chatty-new-chat-dialog.c:178
+#: src/dialogs/chatty-new-chat-dialog.c:196
 #, c-format
 msgid "Error opening GNOME Contacts: %s"
 msgstr "Помилка під час спроби відкрити «Контакти» GNOME: %s"
@@ -498,17 +486,17 @@ msgstr "З'єднання…"
 msgid "disconnected"
 msgstr "від'єднано"
 
-#: src/dialogs/chatty-settings-dialog.c:443
+#: src/dialogs/chatty-settings-dialog.c:439
 #: src/dialogs/chatty-user-info-dialog.c:62
 msgid "Set Avatar"
 msgstr "Встановити аватар"
 
-#: src/dialogs/chatty-settings-dialog.c:513
+#: src/dialogs/chatty-settings-dialog.c:509
 #: src/ui/chatty-settings-dialog.ui:477
 msgid "Delete Account"
 msgstr "Вилучити запис"
 
-#: src/dialogs/chatty-settings-dialog.c:516
+#: src/dialogs/chatty-settings-dialog.c:512
 #, c-format
 msgid "Delete account %s?"
 msgstr "Вилучити запис %s?"
@@ -541,7 +529,7 @@ msgstr "Нове групове спіл
 msgid "Join Chat"
 msgstr "Долучитися до спілкування"
 
-#: src/ui/chatty-dialog-join-muc.ui:81 src/ui/chatty-dialog-new-chat.ui:237
+#: src/ui/chatty-dialog-join-muc.ui:81 src/ui/chatty-dialog-new-chat.ui:298
 msgid "Select chat account"
 msgstr "Виберіть обліковий запис"
 
@@ -601,7 +589,7 @@ msgstr "Почати спілкуван
 msgid "New Contact"
 msgstr "Створити контакт"
 
-#: src/ui/chatty-dialog-new-chat.ui:83 src/ui/chatty-window.ui:125
+#: src/ui/chatty-dialog-new-chat.ui:83 src/ui/chatty-window.ui:126
 msgid "Add Contact"
 msgstr "Додати контакт"
 
@@ -609,15 +597,25 @@ msgstr "Додати контакт"
 msgid "Send To:"
 msgstr "Надіслати:"
 
-#: src/ui/chatty-dialog-new-chat.ui:288
+#: src/ui/chatty-dialog-new-chat.ui:225
+msgid "No Search Results"
+msgstr "Нічого не знайдено"
+
+#: src/ui/chatty-dialog-new-chat.ui:238
+msgid "Try different search, or type a valid number to create new chat"
+msgstr ""
+"Спробуйте інший критерій пошуку або введіть коректне число, щоб розпочати"
+" нове спілкування"
+
+#: src/ui/chatty-dialog-new-chat.ui:349
 msgid "Name (optional)"
 msgstr "Назва (необов’язково):"
 
-#: src/ui/chatty-dialog-new-chat.ui:328 src/ui/chatty-window.ui:151
+#: src/ui/chatty-dialog-new-chat.ui:389 src/ui/chatty-window.ui:152
 msgid "Add to Contacts"
 msgstr "Додати до контактів"
 
-#: src/ui/chatty-dialog-user-info.ui:12 src/ui/chatty-window.ui:111
+#: src/ui/chatty-dialog-user-info.ui:12 src/ui/chatty-window.ui:112
 msgid "Chat Details"
 msgstr "Параметри спілкування"
 
@@ -785,34 +783,34 @@ msgstr "Провайдер"
 msgid "About Chats"
 msgstr "Про «Спілкування»"
 
-#: src/ui/chatty-window.ui:58
+#: src/ui/chatty-window.ui:59
 msgid "New Message…"
 msgstr "Нове повідомлення…"
 
-#: src/ui/chatty-window.ui:71
+#: src/ui/chatty-window.ui:72
 msgid "New Group Message…"
 msgstr "Нове групове повідомлення…"
 
-#: src/ui/chatty-window.ui:84
+#: src/ui/chatty-window.ui:85
 msgid "New Bulk SMS…"
 msgstr "Нове пакетне SMS…"
 
-#: src/ui/chatty-window.ui:176
+#: src/ui/chatty-window.ui:177
 msgid "Leave Chat"
 msgstr "Полишити спілкування"
 
-#: src/ui/chatty-window.ui:189
+#: src/ui/chatty-window.ui:190
 msgid "Delete Chat"
 msgstr "Вилучити спілкування"
 
-#: src/users/chatty-contact.c:313
+#: src/users/chatty-contact.c:315
 msgid "Mobile: "
 msgstr "Мобільний: "
 
-#: src/users/chatty-contact.c:315
+#: src/users/chatty-contact.c:317
 msgid "Work: "
 msgstr "Робочий: "
 
-#: src/users/chatty-contact.c:317
+#: src/users/chatty-contact.c:319
 msgid "Other: "
 msgstr "Інший: "
diff -pruN 0.1.17-1/README.md 0.2.0-1/README.md
--- 0.1.17-1/README.md	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/README.md	2020-11-27 09:44:20.000000000 +0000
@@ -18,7 +18,7 @@ For an explicit list of dependencies che
 [debian/control](https://source.puri.sm/Librem5/chatty/blob/master/debian/control#5)
 file.
 
-Libhandy (libhandy-0.0-dev) is available in [PureOS][0] and  Debian's
+Libhandy (libhandy-1-dev) is available in [PureOS][0] and  Debian's
 [experimental distribution][1].  If you don't want to fetch it from there you
 can [build it from souce][2].
 
@@ -115,6 +115,6 @@ If you don't have an XMPP account yet an
 - XEP-0313: Message Archive Management
 - XEP-0363: HTTP File Upload
 
-[0]: http://software.pureos.net/search_pkg?term=libhandy-0.0-dev
-[1]: https://packages.debian.org/search?keywords=libhandy-0.0-dev
+[0]: http://software.pureos.net/search_pkg?term=libhandy-1-dev
+[1]: https://packages.debian.org/search?keywords=libhandy-1-dev
 [2]: https://source.puri.sm/Librem5/libhandy
diff -pruN 0.1.17-1/src/chatty-application.c 0.2.0-1/src/chatty-application.c
--- 0.1.17-1/src/chatty-application.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-application.c	2020-11-27 09:44:20.000000000 +0000
@@ -24,6 +24,7 @@
 #define G_LOG_DOMAIN "chatty-application"
 
 #include <glib/gi18n.h>
+#include <handy.h>
 
 #include "chatty-config.h"
 #include "chatty-window.h"
@@ -301,6 +302,8 @@ chatty_application_startup (GApplication
 
   G_APPLICATION_CLASS (chatty_application_parent_class)->startup (application);
 
+  hdy_init ();
+
   g_set_application_name (_("Chats"));
 
   lfb_init (CHATTY_APP_ID, NULL);
@@ -311,7 +314,7 @@ chatty_application_startup (GApplication
 
   self->css_provider = gtk_css_provider_new ();
   gtk_css_provider_load_from_resource (self->css_provider,
-                                       "/sm/puri/chatty/css/style.css");
+                                       "/sm/puri/Chatty/css/style.css");
 
   g_action_map_add_action_entries (G_ACTION_MAP (self), app_entries,
                                    G_N_ELEMENTS (app_entries), self);
diff -pruN 0.1.17-1/src/chatty-chat-view.c 0.2.0-1/src/chatty-chat-view.c
--- 0.1.17-1/src/chatty-chat-view.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-chat-view.c	2020-11-27 09:44:20.000000000 +0000
@@ -366,16 +366,12 @@ chat_view_message_row_new (ChattyMessage
 {
   GtkWidget *row;
   ChattyProtocol protocol;
-  gboolean is_im = TRUE;
 
   g_assert (CHATTY_IS_MESSAGE (message));
   g_assert (CHATTY_IS_CHAT_VIEW (self));
 
-  if (self->message_type == CHATTY_MSG_TYPE_MUC)
-    is_im = FALSE;
-
   protocol = chatty_item_get_protocols (CHATTY_ITEM (self->chat));
-  row = chatty_message_row_new (message, protocol, is_im);
+  row = chatty_message_row_new (message, protocol, chatty_chat_is_im (self->chat));
   chatty_message_row_set_alias (CHATTY_MESSAGE_ROW (row),
                                 chatty_message_get_user_alias (message));
 
@@ -703,7 +699,8 @@ chat_view_send_message_button_clicked_cb
     }
 
     if (protocol == CHATTY_PROTOCOL_MATRIX ||
-        protocol == CHATTY_PROTOCOL_XMPP)
+        protocol == CHATTY_PROTOCOL_XMPP ||
+        protocol == CHATTY_PROTOCOL_TELEGRAM)
       escaped = purple_markup_escape_text (message, -1);
 
     if (conv && purple_conversation_get_type (conv) == PURPLE_CONV_TYPE_IM) {
@@ -893,7 +890,7 @@ chatty_chat_view_class_init (ChattyChatV
   widget_class->map = chatty_chat_view_map;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-chat-view.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyChatView, message_list);
diff -pruN 0.1.17-1/src/chatty-enums.h 0.2.0-1/src/chatty-enums.h
--- 0.1.17-1/src/chatty-enums.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-enums.h	2020-11-27 09:44:20.000000000 +0000
@@ -25,6 +25,22 @@ typedef enum
 } ChattyStatus;
 
 /**
+ * ChattyIdType:
+ *
+ * The type of ID used.  This can be different
+ * from protocol.  Say, a user may use a phone
+ * number to log in to a matrix account.
+ */
+typedef enum
+{
+  CHATTY_ID_UNKNOWN,
+  CHATTY_ID_PHONE,
+  CHATTY_ID_EMAIL,
+  CHATTY_ID_MATRIX,
+  CHATTY_ID_XMPP
+} ChattyIdType;
+
+/**
  * ChattyProtocol:
  *
  * Protocols supported/implemented by #ChattyUser
@@ -100,3 +116,17 @@ typedef enum
   CHATTY_STATUS_SENDING_FAILED,
   CHATTY_STATUS_DELIVERY_FAILED
 } ChattyMsgStatus;
+
+typedef enum
+{
+  CHATTY_MESSAGE_UNKNOWN,
+  CHATTY_MESSAGE_TEXT,
+  CHATTY_MESSAGE_HTML,
+  CHATTY_MESSAGE_HTML_ESCAPED,
+  CHATTY_MESSAGE_MATRIX_HTML,
+  CHATTY_MESSAGE_LOCATION,
+  CHATTY_MESSAGE_FILE,
+  CHATTY_MESSAGE_IMAGE,
+  CHATTY_MESSAGE_VIDEO,
+  chatty_message_AUDIO,
+} ChattyMsgType;
diff -pruN 0.1.17-1/src/chatty.gresource.xml 0.2.0-1/src/chatty.gresource.xml
--- 0.1.17-1/src/chatty.gresource.xml	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty.gresource.xml	2020-11-27 09:44:20.000000000 +0000
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <gresources>
-  <gresource prefix="/sm/puri/chatty">
+  <gresource prefix="/sm/puri/Chatty">
     <file>ui/chatty-list-row.ui</file>
     <file>ui/chatty-chat-view.ui</file>
     <file>ui/chatty-contact-row.ui</file>
@@ -11,11 +11,8 @@
     <file>ui/chatty-dialog-muc-info.ui</file>
     <file>ui/chatty-dialog-user-info.ui</file>
     <file>ui/chatty-window.ui</file>
-    <file>icons/ui/send-symbolic.svg</file>
-    <file>icons/ui/xmpp-logo.svg</file>
-    <file>icons/ui/matrix-logo.svg</file>
-    <file>icons/ui/eye-not-looking-symbolic.svg</file>
-    <file>icons/ui/eye-open-negative-filled-symbolic.svg</file>
+    <file>icons/eye-not-looking-symbolic.svg</file>
+    <file>icons/eye-open-negative-filled-symbolic.svg</file>
     <file>css/style.css</file>
   </gresource>
 </gresources>
diff -pruN 0.1.17-1/src/chatty-history.c 0.2.0-1/src/chatty-history.c
--- 0.1.17-1/src/chatty-history.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-history.c	2020-11-27 09:44:20.000000000 +0000
@@ -11,23 +11,6 @@
 
 #define G_LOG_DOMAIN "chatty-history"
 
-#define CHAT_ID_IDX         1
-#define CHAT_TIMESTAMP_IDX  2
-#define CHAT_DIRECTION_IDX  3
-#define CHAT_ACCOUNT_IDX    4
-#define CHAT_ROOM_IDX       5
-#define CHAT_WHO_IDX        6
-#define CHAT_UID_IDX        7
-#define CHAT_MESSAGE_IDX    8
-
-#define IM_ID_IDX         1
-#define IM_TIMESTAMP_IDX  2
-#define IM_DIRECTION_IDX  3
-#define IM_ACCOUNT_IDX    4
-#define IM_WHO_IDX        5
-#define IM_UID_IDX        6
-#define IM_MESSAGE_IDX    7
-
 #ifdef HAVE_CONFIG_H
 # include "config.h"
 #endif
@@ -35,8 +18,52 @@
 #include <sqlite3.h>
 
 #include "chatty-utils.h"
+#include "chatty-settings.h"
 #include "chatty-history.h"
 
+#define STRING(arg) STRING_VALUE(arg)
+#define STRING_VALUE(arg) #arg
+
+/* increment when DB changes */
+#define HISTORY_VERSION 1
+
+/* Shouldn't be modified, new values should be appended */
+#define CHATTY_ID_UNKNOWN_VALUE 0
+#define CHATTY_ID_PHONE_VALUE   1
+#define CHATTY_ID_EMAIL_VALUE   2
+#define CHATTY_ID_XMPP_VALUE    3
+#define CHATTY_ID_MATRIX_VALUE  4
+#define CHATTY_ID_SIP_VALUE     5
+#define CHATTY_ID_ICCID_VALUE   6
+
+/* Shouldn't be modified, new values should be appended */
+#define PROTOCOL_UNKNOWN   0
+#define PROTOCOL_SMS       1
+#define PROTOCOL_MMS       2
+#define PROTOCOL_XMPP      3
+#define PROTOCOL_MATRIX    4
+#define PROTOCOL_TELEGRAM  5
+#define PROTOCOL_SIP       6
+
+/* Chat thread type */
+#define THREAD_DIRECT_CHAT 0
+#define THREAD_GROUP_CHAT  1
+
+/* Shouldn't be modified, new values should be appended */
+#define MESSAGE_TYPE_UNKNOWN       0
+#define MESSAGE_TYPE_TEXT          1
+#define MESSAGE_TYPE_HTML_ESCAPED  2
+#define MESSAGE_TYPE_HTML          3
+#define MESSAGE_TYPE_MATRIX_HTML   4
+#define MESSAGE_TYPE_URL           6
+#define MESSAGE_TYPE_LOCATION      7
+#define MESSAGE_TYPE_FILE          8
+#define MESSAGE_TYPE_IMAGE         9
+#define MESSAGE_TYPE_VIDEO         10
+#define MESSAGE_TYPE_AUDIO         11
+/* Temporary until the link is parsed */
+#define MESSAGE_TYPE_LINK          20
+
 struct _ChattyHistory
 {
   GObject      parent_instance;
@@ -44,6 +71,7 @@ struct _ChattyHistory
   GAsyncQueue *queue;
   GThread     *worker_thread;
   sqlite3     *db;
+  char        *db_path;
 };
 
 /*
@@ -91,6 +119,86 @@ history_direction_to_value (ChattyMsgDir
   }
 }
 
+static int
+history_protocol_to_value (ChattyProtocol protocol)
+{
+  switch (protocol) {
+  case CHATTY_PROTOCOL_SMS:
+    return PROTOCOL_SMS;
+
+  case CHATTY_PROTOCOL_MMS:
+    return PROTOCOL_MMS;
+
+  case CHATTY_PROTOCOL_MATRIX:
+    return PROTOCOL_MATRIX;
+
+  case CHATTY_PROTOCOL_XMPP:
+    return PROTOCOL_XMPP;
+
+  case CHATTY_PROTOCOL_TELEGRAM:
+    return PROTOCOL_TELEGRAM;
+
+  case CHATTY_PROTOCOL_ANY:
+  case CHATTY_PROTOCOL_NONE:
+  case CHATTY_PROTOCOL_CALL:
+  case CHATTY_PROTOCOL_DELTA:
+  case CHATTY_PROTOCOL_THREEPL:
+  default:
+    g_return_val_if_reached (0);
+  }
+}
+
+static int
+history_protocol_to_type_value (ChattyProtocol protocol)
+{
+  switch (protocol) {
+  case CHATTY_PROTOCOL_SMS:
+  case CHATTY_PROTOCOL_MMS:
+  case CHATTY_PROTOCOL_TELEGRAM:
+    return CHATTY_ID_PHONE_VALUE;
+
+  case CHATTY_PROTOCOL_MATRIX:
+    return CHATTY_ID_MATRIX_VALUE;
+
+  case CHATTY_PROTOCOL_XMPP:
+    return CHATTY_ID_XMPP_VALUE;
+
+  case CHATTY_PROTOCOL_CALL:
+  case CHATTY_PROTOCOL_ANY:
+  case CHATTY_PROTOCOL_NONE:
+  case CHATTY_PROTOCOL_DELTA:
+  case CHATTY_PROTOCOL_THREEPL:
+  default:
+    g_return_val_if_reached (0);
+  }
+}
+
+#if 0
+static int
+id_type_to_value (ChattyIdType type)
+{
+  switch (type) {
+  case CHATTY_ID_UNKNOWN:
+    return CHATTY_ID_UNKNOWN_VALUE;
+
+  case CHATTY_ID_PHONE:
+    return CHATTY_ID_PHONE_VALUE;
+
+  case CHATTY_ID_EMAIL:
+    return CHATTY_ID_EMAIL_VALUE;
+
+  case CHATTY_ID_MATRIX:
+    return CHATTY_ID_MATRIX_VALUE;
+
+  case CHATTY_ID_XMPP:
+    return CHATTY_ID_XMPP_VALUE;
+
+  default:
+    g_return_val_if_reached (0);
+  }
+}
+#endif
+
 static void
 warn_if_sql_error (int         status,
                    const char *message)
@@ -125,12 +233,163 @@ history_bind_int (sqlite3_stmt *statemen
   warn_if_sql_error (status, message);
 }
 
+
 static int
-chatty_history_create_chat_schema (ChattyHistory *self,
-                                   GTask         *task)
+chatty_history_get_db_version (ChattyHistory *self,
+                               GTask         *task)
+{
+  sqlite3_stmt *stmt;
+  int status, version = -1;
+
+  g_assert (CHATTY_IS_HISTORY (self));
+  g_assert (G_IS_TASK (task));
+  g_assert (g_thread_self () == self->worker_thread);
+  g_assert (self->db);
+
+  sqlite3_prepare_v2 (self->db, "PRAGMA user_version;", -1, &stmt, NULL);
+  status = sqlite3_step (stmt);
+
+  if (status == SQLITE_ROW)
+    version = sqlite3_column_int (stmt, 0);
+  else
+    g_task_return_new_error (task,
+                             G_IO_ERROR,
+                             G_IO_ERROR_FAILED,
+                             "Error getting database version errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+  sqlite3_finalize (stmt);
+
+  return version;
+}
+
+static gboolean
+chatty_history_create_schema (ChattyHistory *self,
+                              GTask         *task)
 {
+  char *error = NULL;
   const char *sql;
+  sqlite3 *db;
+  int status;
+
+  g_assert (CHATTY_IS_HISTORY (self));
+  g_assert (G_IS_TASK (task));
+  g_assert (g_thread_self () == self->worker_thread);
+  g_assert (self->db);
+
+  /* XXX: SELECT * FROM files sounds better, WHERE file.id != x feels better too.
+   * So what to name? file or files?
+   */
+  sql = "BEGIN TRANSACTION;"
+    "CREATE TABLE IF NOT EXISTS files ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "name TEXT NOT NULL, "
+    "url TEXT, "
+    "path TEXT, "
+    "mime_type TEXT, "
+    "size INTEGER);"
+
+    "CREATE TABLE IF NOT EXISTS media ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "file_id INTEGER NOT NULL UNIQUE, "
+    "thumbnail_id INTEGER REFERENCES media(id), "
+    "width INTEGER, "
+    "height INTEGER, "
+    "FOREIGN KEY(file_id) REFERENCES files(id));"
+
+    /* TODO: Someday */
+    /* "CREATE TABLE IF NOT EXISTS devices (" */
+    /* "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, " */
+    /* "device TEXT NOT NULL UNIQUE, " */
+    /* "name TEXT);" */
+
+    "CREATE TABLE IF NOT EXISTS users ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "username TEXT NOT NULL, "
+    "alias TEXT, "
+    "avatar_id INTEGER REFERENCES media(id), "
+    "type INTEGER NOT NULL, "
+    /* For phone numbers */
+    "UNIQUE (username, type));"
+
+    "CREATE TABLE IF NOT EXISTS accounts ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "user_id INTEGER NOT NULL REFERENCES users(id), "
+    "password TEXT, "
+    "enabled INTEGER DEFAULT 0, "
+    "protocol INTEGER NOT NULL, "
+    "UNIQUE (user_id, protocol));"
+
+    "INSERT OR IGNORE INTO users(username,type) VALUES "
+    "('SMS'," STRING (CHATTY_ID_PHONE_VALUE) "),"
+    "('MMS'," STRING (CHATTY_ID_PHONE_VALUE) ");"
+
+    "INSERT OR IGNORE INTO accounts(user_id,protocol) "
+    "SELECT users.id,"
+    "CASE "
+    "WHEN users.username='SMS' "
+    "THEN " STRING (PROTOCOL_SMS) " "
+    "ELSE " STRING (PROTOCOL_MMS) " "
+    "END "
+    "FROM users;"
+
+    "CREATE TABLE IF NOT EXISTS threads ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "name TEXT NOT NULL, "
+    "alias TEXT, "
+    "avatar_id INTEGER REFERENCES media(id), "
+    "account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE, "
+    "type INTEGER NOT NULL, "
+    "encrypted INTEGER DEFAULT 0, "
+    "UNIQUE (name, account_id, type));"
+
+    "CREATE TABLE IF NOT EXISTS thread_members ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE, "
+    "user_id INTEGER NOT NULL REFERENCES users(id), "
+    "UNIQUE (thread_id, user_id));"
+
+    "CREATE TABLE IF NOT EXISTS messages ("
+    "id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "
+    "uid TEXT NOT NULL, "
+    "thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE, "
+    "sender_id INTEGER REFERENCES users(id), "
+    "user_alias TEXT, "
+    "body TEXT NOT NULL, "
+    "body_type INTEGER NOT NULL, "
+    "direction INTEGER NOT NULL, "
+    "time INTEGER NOT NULL, "
+    "status INTEGER, "
+    "encrypted INTEGER DEFAULT 0, "
+    "UNIQUE (uid, thread_id, body, time));"
+
+    /* Alter threads after the messages table is created */
+    "ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);"
+
+    "COMMIT;";
+
+  status = sqlite3_exec (self->db, sql, NULL, NULL, &error);
+
+  if (status == SQLITE_OK)
+    return TRUE;
+
+  db = g_steal_pointer (&self->db);
+  sqlite3_close (db);
+  g_task_return_new_error (task,
+                           G_IO_ERROR,
+                           G_IO_ERROR_FAILED,
+                           "Error creating tables. errno: %d, desc: %s. %s",
+                           status, sqlite3_errstr (status), error);
+  sqlite3_free (error);
+
+  return FALSE;
+}
+
+static gboolean
+chatty_history_update_version (ChattyHistory *self,
+                               GTask         *task)
+{
   char *error = NULL;
+  const char *sql;
   int status;
 
   g_assert (CHATTY_IS_HISTORY (self));
@@ -138,93 +397,955 @@ chatty_history_create_chat_schema (Chatt
   g_assert (g_thread_self () == self->worker_thread);
   g_assert (self->db);
 
-  sql = "CREATE TABLE IF NOT EXISTS chatty_chat("  \
-    "id                 INTEGER     NOT NULL    PRIMARY KEY AUTOINCREMENT," \
-    "timestamp          INTEGER     NOT_NULL," \
-    "direction          INTEGER     NOT NULL," \
-    "account            TEXT        NOT NULL," \
-    "room               TEXT        NOT_NULL," \
-    "who                TEXT,"  \
-    "uid                TEXT        NOT_NULL," \
-    "message            TEXT," \
-    "UNIQUE (timestamp, message)"
-    ");";
+  sql = "PRAGMA user_version = " STRING (HISTORY_VERSION) ";";
 
   status = sqlite3_exec (self->db, sql, NULL, NULL, &error);
 
-  if (status != SQLITE_OK) {
+  if (status == SQLITE_OK)
+    return TRUE;
+
+  g_task_return_new_error (task,
+                           G_IO_ERROR,
+                           G_IO_ERROR_FAILED,
+                           "Error setting db version. errno: %d, desc: %s. %s",
+                           status, sqlite3_errstr (status), error);
+  sqlite3_free (error);
+
+  return FALSE;
+}
+
+static int
+insert_or_ignore_user (ChattyHistory  *self,
+                       ChattyProtocol  protocol,
+                       const char     *who,
+                       GTask          *task)
+{
+  g_autofree char *phone = NULL;
+  sqlite3_stmt *stmt;
+  int status, id = 0;
+
+  if (!who || !*who)
+    return 0;
+
+  if (protocol & (CHATTY_PROTOCOL_SMS | CHATTY_PROTOCOL_MMS | CHATTY_PROTOCOL_TELEGRAM)) {
+    char *country;
+
+    country = g_object_get_data (G_OBJECT (task), "country-code");
+    phone = chatty_utils_check_phonenumber (who, country);
+  }
+
+  sqlite3_prepare_v2 (self->db,
+                      "INSERT OR IGNORE INTO users(username,type) "
+                      "VALUES(?,?);",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, phone ? phone : who, "binding when adding phone number");
+  history_bind_int (stmt, 2, history_protocol_to_type_value (protocol), "binding when adding phone number");
+
+  sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  /* We can't use last_row_id as we may ignore the last insert */
+  sqlite3_prepare_v2 (self->db,
+                      "SELECT users.id FROM users "
+                      "WHERE users.username=? AND type=?;",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, phone ? phone : who, "binding when getting users");
+  history_bind_int (stmt, 2, history_protocol_to_type_value (protocol), "binding when getting users");
+  status = sqlite3_step (stmt);
+
+  if (status == SQLITE_ROW)
+    id = sqlite3_column_int (stmt, 0);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_ROW)
     g_task_return_new_error (task,
                              G_IO_ERROR,
                              G_IO_ERROR_FAILED,
-                             "Error creating chatty_im table. errno: %d, desc: %s. %s",
-                             status, sqlite3_errstr (status), error);
-    return status;
-  }
+                             "Error inserting into users. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+  return id;
+}
 
-  // The archiving entity is room jid, uid may only be unique within entity scope
-  sql = "CREATE UNIQUE INDEX IF NOT EXISTS chatty_chat_room_uid ON chatty_chat(room, uid);";
-  status = sqlite3_exec (self->db, sql, NULL, NULL, &error);
+static int
+insert_or_ignore_account (ChattyHistory  *self,
+                          ChattyProtocol  protocol,
+                          int             user_id,
+                          GTask          *task)
+{
+  sqlite3_stmt *stmt;
+  int status, id = 0;
+
+  if (!user_id)
+    g_return_val_if_reached (0);
 
-  if (status != SQLITE_OK) {
+  sqlite3_prepare_v2 (self->db,
+                      "INSERT OR IGNORE INTO accounts(user_id,protocol) "
+                      "VALUES(?,?);",
+                      -1, &stmt, NULL);
+  history_bind_int (stmt, 1, user_id, "binding when adding account");
+  history_bind_int (stmt, 2, history_protocol_to_value (protocol), "binding when adding account");
+  sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  /* We can't use last_row_id as we may ignore the last insert */
+  sqlite3_prepare_v2 (self->db,
+                      "SELECT accounts.id FROM accounts "
+                      "WHERE user_id=? AND protocol=?;",
+                      -1, &stmt, NULL);
+  history_bind_int (stmt, 1, user_id, "binding when getting account");
+  history_bind_int (stmt, 2, history_protocol_to_value (protocol), "binding when getting account");
+  status = sqlite3_step (stmt);
+
+  if (status == SQLITE_ROW)
+    id = sqlite3_column_int (stmt, 0);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_ROW)
     g_task_return_new_error (task,
                              G_IO_ERROR,
                              G_IO_ERROR_FAILED,
-                             "Error creating chatty_im table. errno: %d, desc: %s. %s",
-                             status, sqlite3_errstr (status), error);
-  }
-
-  return status;
+                             "Error inserting into users. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+  return id;
 }
 
+static int
+get_thread_id (ChattyHistory *self,
+               ChattyChat    *chat)
+{
+  sqlite3_stmt *stmt;
+  int status, id = 0;
+
+  sqlite3_prepare_v2 (self->db,
+                      "SELECT threads.id FROM threads "
+                      "INNER JOIN accounts "
+                      "ON accounts.id=account_id "
+                      "INNER JOIN users "
+                      "ON users.username=? AND accounts.user_id=users.id "
+                      "AND threads.name=? AND threads.type=?;",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, chatty_chat_get_username (chat), "binding when getting thread");
+  history_bind_text (stmt, 2, chatty_chat_get_chat_name (chat), "binding when getting thread");
+  history_bind_int (stmt, 3, chatty_chat_is_im (chat) ? THREAD_DIRECT_CHAT : THREAD_GROUP_CHAT,
+                    "binding when adding phone number");
+  status = sqlite3_step (stmt);
+
+  if (status == SQLITE_ROW)
+    id = sqlite3_column_int (stmt, 0);
+  sqlite3_finalize (stmt);
+
+  return id;
+}
 
 static int
-chatty_history_create_im_schema (ChattyHistory *self,
-                                 GTask         *task)
+insert_or_ignore_thread (ChattyHistory *self,
+                         ChattyChat    *chat,
+                         GTask         *task)
 {
-  const char *sql;
-  char *error = NULL;
-  int status;
+  sqlite3_stmt *stmt;
+  int user_id, account_id;
+  int status, id = 0;
 
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
   g_assert (g_thread_self () == self->worker_thread);
   g_assert (self->db);
 
-  sql = "CREATE TABLE IF NOT EXISTS chatty_im("  \
-    "id                 INTEGER     NOT NULL    PRIMARY KEY AUTOINCREMENT," \
-    "timestamp          INTEGER     NOT_NULL,"  \
-    "direction          INTEGER     NOT NULL," \
-    "account            TEXT        NOT_NULL," \
-    "who                TEXT        NOT_NULL," \
-    "uid                TEXT        NOT_NULL," \
-    "message            TEXT,"                 \
-    "UNIQUE (timestamp, message)"
-    ");";
+  user_id = insert_or_ignore_user (self,
+                                   chatty_item_get_protocols (CHATTY_ITEM (chat)),
+                                   chatty_chat_get_username (chat),
+                                   task);
+  if (!user_id)
+    return 0;
 
-  status = sqlite3_exec (self->db, sql, NULL, NULL, &error);
+  account_id = insert_or_ignore_account (self,
+                                         chatty_item_get_protocols (CHATTY_ITEM (chat)),
+                                         user_id, task);
+
+  if (!account_id)
+    return 0;
+
+  sqlite3_prepare_v2 (self->db,
+                      "INSERT INTO threads(name,alias,account_id,type) "
+                      "VALUES(?,?,?,?);",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, chatty_chat_get_chat_name (chat), "binding when adding thread");
+  history_bind_text (stmt, 2, chatty_chat_get_chat_name (chat), "binding when adding thread");
+  history_bind_int (stmt, 3, account_id, "binding when adding thread");
+  history_bind_int (stmt, 4, chatty_chat_is_im (chat) ? THREAD_DIRECT_CHAT : THREAD_GROUP_CHAT,
+                    "binding when adding thread");
+  sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  /* We can't use last_row_id as we may ignore the last insert */
+  sqlite3_prepare_v2 (self->db,
+                      "SELECT threads.id FROM threads "
+                      "WHERE name=? AND account_id=? AND type=?;",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, chatty_chat_get_chat_name (chat), "binding when getting thread");
+  history_bind_int (stmt, 2, account_id, "binding when getting thread");
+  history_bind_int (stmt, 3, chatty_chat_is_im (chat) ? THREAD_DIRECT_CHAT : THREAD_GROUP_CHAT,
+                    "binding when getting thread");
+  status = sqlite3_step (stmt);
+
+  if (status == SQLITE_ROW)
+    id = sqlite3_column_int (stmt, 0);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_ROW)
+    g_task_return_new_error (task,
+                             G_IO_ERROR,
+                             G_IO_ERROR_FAILED,
+                             "Error inserting into users. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+  return id;
+}
+
+static void
+chatty_history_backup (ChattyHistory *self)
+{
+  g_autoptr(GFile) backup_db = NULL;
+  g_autoptr(GFile) old_db = NULL;
+  g_autofree char *backup_name = NULL;
+  g_autoptr(GError) error = NULL;
+
+  backup_name = g_strdup_printf ("%s.%ld", self->db_path, time (NULL));
+  g_info ("Copying database for backup");
+
+  old_db = g_file_new_for_path (self->db_path);
+  backup_db = g_file_new_for_path (backup_name);
+  g_file_copy (old_db, backup_db, G_FILE_COPY_NONE, NULL, NULL, NULL, &error);
+  g_info ("Copying database complete");
+
+  if (error &&
+      !g_error_matches (error, G_IO_ERROR, G_IO_ERROR_NOT_FOUND) &&
+      !g_error_matches (error, G_IO_ERROR, G_IO_ERROR_EXISTS))
+    g_critical ("Error creating DB backup: %s", error->message);
+}
+
+static gboolean
+history_add_phone_user (ChattyHistory *self,
+                        GTask         *task,
+                        const char    *username,
+                        const char    *alias)
+{
+  sqlite3_stmt *stmt;
+  int status;
+
+  sqlite3_prepare_v2 (self->db, "INSERT OR IGNORE INTO users(username,alias,type) "
+                      "VALUES(?,?,"STRING(CHATTY_ID_PHONE_VALUE)");",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, username, "binding when adding user");
+  history_bind_text (stmt, 2, alias, "binding when adding user");
+  status = sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_DONE)
+    g_task_return_new_error (task,
+                             G_IO_ERROR,
+                             G_IO_ERROR_FAILED,
+                             "Error inserting into accounts. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+
+  return status == SQLITE_DONE;
+}
+
+static gboolean
+history_add_phone_account (ChattyHistory *self,
+                           GTask         *task,
+                           const char    *account,
+                           int            protocol)
+{
+  sqlite3_stmt *stmt;
+  int status;
 
-  if (status != SQLITE_OK) {
+  sqlite3_prepare_v2 (self->db, "INSERT OR IGNORE INTO accounts(user_id,protocol)"
+                      "VALUES((SELECT users.id FROM users WHERE username=?),?);",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, account, "binding when adding account");
+  history_bind_int (stmt, 2, protocol, "binding when adding account");
+  status = sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_DONE)
     g_task_return_new_error (task,
                              G_IO_ERROR,
                              G_IO_ERROR_FAILED,
-                             "Error creating chatty_im table. errno: %d, desc: %s. %s",
-                             status, sqlite3_errstr (status), error);
-    return status;
+                             "Error inserting into accounts. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+
+  return status == SQLITE_DONE;
+}
+
+static gboolean
+history_add_thread (ChattyHistory *self,
+                    GTask         *task,
+                    const char    *account,
+                    const char    *room,
+                    const char    *alias,
+                    int            chat_type)
+{
+  sqlite3_stmt *stmt;
+  int status;
+
+  sqlite3_prepare_v2 (self->db, "INSERT OR IGNORE INTO threads(name,alias,account_id,type) "
+                      "SELECT ?,?,accounts.id,? "
+                      "FROM users "
+                      "INNER JOIN accounts ON accounts.user_id=users.id "
+                      "AND users.username=?;",
+                      -1, &stmt, NULL);
+
+  history_bind_text (stmt, 1, room, "binding when adding thread");
+  history_bind_text (stmt, 2, alias, "binding when adding thread");
+  history_bind_int (stmt, 3, chat_type, "binding when adding thread");
+  history_bind_text (stmt, 4, account, "binding when adding thread");
+  status = sqlite3_step (stmt);
+  sqlite3_finalize (stmt);
+
+  if (status != SQLITE_DONE)
+    g_task_return_new_error (task,
+                             G_IO_ERROR,
+                             G_IO_ERROR_FAILED,
+                             "Error inserting into accounts. errno: %d, desc: %s",
+                             status, sqlite3_errstr (status));
+
+  return status == SQLITE_DONE;
+}
+
+static gboolean
+chatty_history_migrate_db_to_v1 (ChattyHistory *self,
+                                 GTask         *task)
+{
+  char *error = NULL;
+  int status;
+
+  g_assert (CHATTY_IS_HISTORY (self));
+  g_assert (G_IS_TASK (task));
+  g_assert (g_thread_self () == self->worker_thread);
+
+  chatty_history_backup (self);
+
+  if (!chatty_history_create_schema (self, task))
+    return FALSE;
+
+  status = sqlite3_exec (self->db,
+                         "BEGIN TRANSACTION;"
+
+                         /*** Users ***/
+                         /* XMPP IM accounts */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT account," STRING(CHATTY_ID_XMPP_VALUE) " FROM chatty_im "
+                         /* A Rough match for XMPP accounts */
+                         "WHERE chatty_im.account GLOB '[^@+]*' "
+                         "AND chatty_im.account!='SMS' "
+                         "AND chatty_im.who GLOB '[^@+]*@*';"
+
+                         /* XMPP MUC accounts */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT account," STRING(CHATTY_ID_XMPP_VALUE) " FROM chatty_chat "
+                         /* A Rough match for XMPP accounts */
+                         "WHERE chatty_chat.account GLOB '[^@+]*' "
+                         "AND chatty_chat.room GLOB '[^@+]*@*';"
+
+                         /* SMS account */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT account," STRING(CHATTY_ID_PHONE_VALUE) " FROM chatty_im "
+                         "WHERE account='SMS';"
+
+                         /* Matrix accounts */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT account," STRING(CHATTY_ID_MATRIX_VALUE) " FROM chatty_chat "
+                         /* A Rough match for Matrix chat */
+                         "WHERE chatty_chat.room GLOB '!?*:?*' "
+                         "AND chatty_chat.account NOT GLOB '?*@?*' "
+                         "AND chatty_chat.account NOT GLOB '+?*' "
+                         "AND chatty_chat.account!='SMS';"
+
+                         /* XMPP IM users */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT substr(who,0,"
+                         "CASE "
+                         "WHEN instr(who, '/') > 0 THEN instr(who, '/') "
+                         "ELSE length(who) + 1 "
+                         "END),"
+                         STRING(CHATTY_ID_XMPP_VALUE) " FROM chatty_im "
+                         /* A Rough match for XMPP users */
+                         "WHERE chatty_im.account GLOB '[^@+]*' "
+                         "AND chatty_im.account!='SMS' "
+                         "AND chatty_im.who GLOB '[^@]*@*';"
+
+                         /* XMPP MUC users */
+                         "INSERT OR IGNORE INTO users(username,type) "
+                         "SELECT DISTINCT "
+                         /* A Rough match for XMPP users */
+                         "CASE "
+                         "  WHEN chatty_chat.who LIKE chatty_chat.room || '/%' THEN chatty_chat.who "
+                         "  WHEN chatty_chat.who LIKE '%/%' THEN substr(who,0,instr(who, '/')) "
+                         "  ELSE chatty_chat.who "
+                         "END,"
+                         STRING(CHATTY_ID_XMPP_VALUE) " FROM chatty_chat "
+                         "WHERE chatty_chat.account GLOB '[^@+]*' "
+                         "AND chatty_chat.who GLOB '[^@]*@*' "
+                         "AND chatty_chat.room GLOB '[^@]*@*';"
+
+                         /* Matrix chat users */
+                         "INSERT OR IGNORE INTO users (username,type) "
+                         "SELECT DISTINCT who,"
+                         STRING(CHATTY_ID_MATRIX_VALUE) " FROM chatty_chat "
+                         /* A Rough match for users that are not regular phone numbers */
+                         "WHERE chatty_chat.room GLOB '!?*:?*' "
+                         "AND chatty_chat.who GLOB '@?*:?*' "
+                         /* Skip possible Telegram accounts */
+                         "AND chatty_chat.account NOT GLOB '+[0-9]*';"
+
+                         /*** Accounts ***/
+                         /* We have exactly one account for SMS */
+                         "INSERT OR IGNORE INTO accounts(user_id,protocol,enabled) "
+                         "SELECT DISTINCT users.id," STRING(PROTOCOL_SMS) ",1 FROM users "
+                         "WHERE users.username='SMS';"
+
+                         /* XMPP IM accounts */
+                         "INSERT OR IGNORE INTO accounts(user_id,protocol) "
+                         "SELECT DISTINCT users.id," STRING(PROTOCOL_XMPP) " FROM users "
+                         "INNER JOIN chatty_im "
+                         "ON chatty_im.account=users.username "
+                         "AND users.type='" STRING(CHATTY_ID_XMPP_VALUE) "';"
+
+                         /* XMPP MUC accounts */
+                         "INSERT OR IGNORE INTO accounts(user_id,protocol) "
+                         "SELECT DISTINCT users.id," STRING(PROTOCOL_XMPP) " FROM users "
+                         "INNER JOIN chatty_chat "
+                         "ON chatty_chat.account=users.username "
+                         "AND users.type=" STRING(CHATTY_ID_XMPP_VALUE) ";"
+
+                         /* XMPP MUC accounts */
+                         "INSERT OR IGNORE INTO accounts(user_id,protocol) "
+                         "SELECT DISTINCT users.id," STRING(PROTOCOL_MATRIX) " FROM users "
+                         "INNER JOIN chatty_chat "
+                         "ON chatty_chat.account=users.username "
+                         "AND users.type=" STRING(CHATTY_ID_MATRIX_VALUE) ";"
+
+                         /*** Threads ***/
+                         /* XMPP IM chats */
+                         "INSERT OR IGNORE INTO threads(name,account_id,type) "
+                         "SELECT DISTINCT substr(who,0,"
+                         "CASE "
+                         "WHEN instr(who, '/') > 0 THEN instr(who, '/') "
+                         "ELSE length(who) + 1 "
+                         "END),"
+                         "accounts.id," STRING(THREAD_DIRECT_CHAT) " "
+                         "FROM chatty_im "
+                         "INNER JOIN accounts "
+                         "  ON accounts.user_id=users.id "
+                         "INNER JOIN users "
+                         "  ON users.username=chatty_im.account "
+                         "WHERE users.type=" STRING(CHATTY_ID_XMPP_VALUE) ";"
+
+                         /* XMPP MUC chats */
+                         "INSERT OR IGNORE INTO threads(name,account_id,type) "
+                         "SELECT DISTINCT room,"
+                         "accounts.id," STRING(THREAD_GROUP_CHAT) " "
+                         "FROM chatty_chat "
+                         "INNER JOIN accounts "
+                         "  ON accounts.user_id=users.id "
+                         "INNER JOIN users "
+                         "  ON users.username=chatty_chat.account "
+                         "WHERE users.type=" STRING(CHATTY_ID_XMPP_VALUE) ";"
+
+                         /* Matrix chats */
+                         "INSERT OR IGNORE INTO threads(name,account_id,type) "
+                         "SELECT DISTINCT room,accounts.id," STRING(THREAD_GROUP_CHAT) " "
+                         "FROM chatty_chat "
+                         "INNER JOIN accounts "
+                         "  ON accounts.user_id=users.id "
+                         "INNER JOIN users "
+                         "  ON users.username=chatty_chat.account "
+                         "WHERE users.type=" STRING(CHATTY_ID_MATRIX_VALUE) ";"
+
+                         /* Telegram IM chats */
+                         "INSERT OR IGNORE INTO threads(name,account_id,type) "
+                         "SELECT DISTINCT who,accounts.id," STRING(THREAD_DIRECT_CHAT) " "
+                         "FROM chatty_im "
+                         "INNER JOIN accounts "
+                         "  ON accounts.user_id=users.id "
+                         "INNER JOIN users "
+                         "  ON users.username=chatty_im.account "
+                         "WHERE chatty_im.account!='SMS' AND users.type=" STRING(CHATTY_ID_PHONE_VALUE) ";"
+
+                         /* Telegram MUC chats */
+                         "INSERT OR IGNORE INTO threads(name,account_id,type) "
+                         "SELECT DISTINCT room,accounts.id," STRING(THREAD_GROUP_CHAT) " "
+                         "FROM chatty_chat "
+                         "INNER JOIN accounts "
+                         "  ON accounts.user_id=users.id "
+                         "INNER JOIN users "
+                         "  ON users.username=chatty_chat.account "
+                         "WHERE users.type=" STRING(CHATTY_ID_PHONE_VALUE) ";"
+
+                         /*** Thread Members ***/
+                         /* XMPP IM chat members */
+                         "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                         "SELECT DISTINCT threads.id,u.id FROM chatty_im "
+                         "INNER JOIN threads "
+                         "ON chatty_im.who LIKE threads.name || '%' "
+                         "INNER JOIN users As a "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN accounts "
+                         "ON accounts.user_id=a.id AND a.username=chatty_im.account "
+                         "AND a.type=" STRING(CHATTY_ID_XMPP_VALUE) " "
+                         "INNER JOIN users AS u "
+                         "ON chatty_im.who LIKE u.username || '%';"
+
+                         /* XMPP MUC members */
+                         "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                         "SELECT DISTINCT threads.id,u.id FROM chatty_chat "
+                         "INNER JOIN threads "
+                         "ON chatty_chat.room=threads.name "
+                         "INNER JOIN accounts "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN users AS a "
+                         "ON accounts.user_id=a.id AND a.username=chatty_chat.account "
+                         "AND a.type=" STRING(CHATTY_ID_XMPP_VALUE) " "
+                         "INNER JOIN users AS u "
+                         "ON chatty_chat.who=u.username "
+                         "OR chatty_chat.who LIKE u.username || '/%' "
+                         "OR chatty_chat.who LIKE chatty_chat.room || '/' || u.username "
+                         "WHERE chatty_chat.direction!=-1;"
+
+                         /* Matrix chat members */
+                         "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                         "SELECT DISTINCT threads.id,u.id FROM chatty_chat "
+                         "INNER JOIN threads "
+                         "ON chatty_chat.room=threads.name "
+                         "INNER JOIN users As a "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN accounts "
+                         "ON accounts.user_id=a.id AND a.username=chatty_chat.account "
+                         "AND a.type=" STRING(CHATTY_ID_MATRIX_VALUE) " "
+                         "INNER JOIN users AS u "
+                         "ON u.username NOT NULL AND chatty_chat.who=u.username;"
+
+                         /*** Messages ***/
+                         /* XMPP IM messages */
+                         "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                         /* Always assume HTML */
+                         "SELECT DISTINCT uid,threads.id,u.id,message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                         "FROM chatty_im "
+                         "INNER JOIN threads "
+                         "ON chatty_im.who LIKE threads.name || '%' "
+                         "INNER JOIN users As a "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN accounts "
+                         "ON accounts.user_id=a.id AND a.username=chatty_im.account "
+                         "INNER JOIN users AS u "
+                         "ON chatty_im.who LIKE u.username || '%' "
+                         "WHERE chatty_im.account GLOB '[^@]*@*' "
+                         "ORDER BY timestamp ASC, chatty_im.id ASC;"
+
+                         /* XMPP MUC chat messages */
+                         "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                         /* Always assume HTML */
+                         "SELECT DISTINCT uid,threads.id,"
+                         "CASE "
+                         "WHEN chatty_chat.direction=-1 THEN a.id "
+                         "WHEN chatty_chat.who=NULL THEN NULL "
+                         "ELSE u.id "
+                         "END,"
+                         "message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                         "FROM chatty_chat "
+                         "INNER JOIN threads "
+                         "ON chatty_chat.room LIKE threads.name || '%' "
+                         "INNER JOIN accounts "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN users As a "
+                         "ON accounts.user_id=a.id AND a.username=chatty_chat.account "
+                         "LEFT JOIN users AS u "
+                         "ON chatty_chat.who=u.username "
+                         "OR chatty_chat.who LIKE u.username || '/%' "
+                         "OR chatty_chat.who LIKE chatty_chat.room || '/' || u.username "
+                         "WHERE chatty_chat.account GLOB '[^@]*@*' "
+                         "ORDER BY timestamp ASC, chatty_chat.id ASC;"
+
+                         /* Matrix chat messages */
+                         "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                         /* Always assume HTML */
+                         "SELECT DISTINCT uid,threads.id,"
+                         "CASE "
+                         "WHEN chatty_chat.direction=-1 AND chatty_chat.who=NULL THEN a.id "
+                         "WHEN chatty_chat.direction=-1 THEN u.id "
+                         "WHEN chatty_chat.who=NULL THEN NULL "
+                         "ELSE u.id "
+                         "END,"
+                         "message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                         "FROM chatty_chat "
+                         "INNER JOIN threads "
+                         "ON chatty_chat.room=threads.name "
+                         "INNER JOIN accounts "
+                         "ON threads.account_id=accounts.id "
+                         "INNER JOIN users As a "
+                         "ON accounts.user_id=a.id AND a.username=chatty_chat.account "
+                         "LEFT JOIN users AS u "
+                         "ON chatty_chat.who=u.username "
+                         "WHERE chatty_chat.room GLOB '!?*:?*' "
+                         "AND chatty_chat.who IS NULL or chatty_chat.who GLOB '@?*:?*' "
+                         "ORDER BY timestamp ASC, chatty_chat.id ASC;"
+
+                         "COMMIT;",
+                         NULL, NULL, &error);
+
+  if (!e_phone_number_is_supported ())
+    g_debug ("Not compiled with libphonenumber");
+
+  if (status == SQLITE_OK) {
+    sqlite3_stmt *stmt;
+
+    /* Get all numbers in international format */
+    status = sqlite3_prepare_v2 (self->db,
+                                 /* Telegram IM */
+                                 "SELECT DISTINCT account,who FROM chatty_im "
+                                 "WHERE account GLOB '+[0-9]*[^@]*[0-9]';",
+                                 -1, &stmt, NULL);
+    if (status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "BEGIN TRANSACTION;", NULL, NULL, &error);
+
+    while (sqlite3_step (stmt) == SQLITE_ROW) {
+      g_autofree char *account_number = NULL;
+      g_autofree char *sender_number = NULL;
+      sqlite3_stmt *insert_stmt = NULL;
+      const char *account, *sender;
+
+      account = (gpointer)sqlite3_column_text (stmt, 0);
+      sender = (gpointer)sqlite3_column_text (stmt, 1);
+
+      account_number = chatty_utils_check_phonenumber (account, NULL);
+      sender_number  = chatty_utils_check_phonenumber (sender, NULL);
+
+      if (!history_add_phone_user (self, task,
+                                   account_number ? account_number : account,
+                                   !account_number ? account: NULL))
+        return FALSE;
+
+      /* Fill in accounts */
+      if (!history_add_phone_account (self, task,
+                                      account_number ? account_number : account,
+                                      g_strcmp0 (account, "SMS") == 0 ? PROTOCOL_SMS : PROTOCOL_TELEGRAM))
+        return FALSE;
+
+      if (!history_add_phone_user (self, task,
+                                   sender_number ? sender_number : sender,
+                                   !sender_number ? sender: NULL))
+        return FALSE;
+
+      if (!history_add_thread (self, task,
+                               account_number ? account_number : account,
+                               sender_number ? sender_number : sender,
+                               !sender_number ? sender: NULL,
+                               THREAD_DIRECT_CHAT))
+        return FALSE;
+
+      /* Fill in messages */
+      sqlite3_prepare_v2 (self->db,
+                          "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                          "SELECT DISTINCT uid,threads.id,u.id,message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                          "FROM chatty_im "
+                          "INNER JOIN threads "
+                          "ON threads.name=? AND chatty_im.who=? "
+                          "INNER JOIN accounts "
+                          "ON threads.account_id=accounts.id "
+                          "INNER JOIN users AS a "
+                          "ON accounts.user_id=a.id AND a.username=? AND chatty_im.account=? "
+                          "INNER JOIN users as u "
+                          "ON u.username=? "
+                          "ORDER BY timestamp ASC, chatty_im.id ASC;",
+                          -1, &insert_stmt, NULL);
+
+      history_bind_text (insert_stmt, 1, sender_number ? sender_number : sender, "binding when adding message");
+      history_bind_text (insert_stmt, 2, sender, "binding when adding message");
+      history_bind_text (insert_stmt, 3, account_number ? account_number : account, "binding when adding message");
+      history_bind_text (insert_stmt, 4, account, "binding when adding message");
+      history_bind_text (insert_stmt, 5, sender_number ? sender_number : sender, "binding when adding message");
+      status = sqlite3_step (insert_stmt);
+      sqlite3_finalize (insert_stmt);
+    }
+
+    sqlite3_exec (self->db,
+                  "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                  "SELECT DISTINCT threads.id,u.id FROM threads "
+                  "INNER JOIN users AS u "
+                  "ON threads.name=u.username "
+                  "AND u.type="STRING(CHATTY_ID_PHONE_VALUE) ";",
+                  NULL, NULL, &error);
+
+    if (status == SQLITE_DONE || status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "COMMIT;", NULL, NULL, &error);
+
+    sqlite3_finalize (stmt);
   }
 
-  // The archiving entity is bare jid, uid may only be unique within entity scope
-  sql = "CREATE UNIQUE INDEX IF NOT EXISTS chatty_im_acc_uid ON chatty_im(account, uid);";
-  status = sqlite3_exec (self->db, sql, NULL, NULL, &error);
+  if (status == SQLITE_OK) {
+    sqlite3_stmt *stmt;
+    status = sqlite3_prepare_v2 (self->db,
+                                 /* Telegram Chats */
+                                 "SELECT DISTINCT account,who,room FROM chatty_chat "
+                                 "WHERE account GLOB '+[0-9]*[^@:.]*[0-9]';",
+                                 -1, &stmt, NULL);
+
+    if (status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "BEGIN TRANSACTION;", NULL, NULL, &error);
+
+    while (sqlite3_step (stmt) == SQLITE_ROW) {
+      g_autofree char *account_number = NULL;
+      g_autofree char *sender_number = NULL;
+      sqlite3_stmt *insert_stmt = NULL;
+      const char *account, *sender, *room;
+
+      account = (gpointer)sqlite3_column_text (stmt, 0);
+      sender = (gpointer)sqlite3_column_text (stmt, 1);
+      room = (gpointer)sqlite3_column_text (stmt, 2);
+
+      account_number = chatty_utils_check_phonenumber (account, NULL);
+      sender_number  = chatty_utils_check_phonenumber (sender, NULL);
+
+      if (!history_add_phone_user (self, task,
+                                   account_number ? account_number : account,
+                                   !account_number ? account: NULL))
+        return FALSE;
+
+      /* Fill in accounts */
+      if (!history_add_phone_account (self, task,
+                                      account_number ? account_number : account,
+                                      g_strcmp0 (account, "SMS") == 0 ? PROTOCOL_SMS : PROTOCOL_TELEGRAM))
+        return FALSE;
+
+      if (sender &&
+          !history_add_phone_user (self, task,
+                                   sender_number ? sender_number : sender,
+                                   !sender_number ? sender: NULL))
+        return FALSE;
+
+      if (!history_add_thread (self, task,
+                               account_number ? account_number : account,
+                               room, room, THREAD_GROUP_CHAT))
+        return FALSE;
+
+      /* Fill in messages with no author */
+      sqlite3_prepare_v2 (self->db,
+                          "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                          "SELECT DISTINCT uid,threads.id,"
+                          "CASE "
+                          "WHEN chatty_chat.direction=-1 THEN a.id "
+                          "WHEN chatty_chat.who=NULL THEN NULL "
+                          "END,"
+                          "message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                          "FROM chatty_chat "
+                          "INNER JOIN threads "
+                          "ON threads.name=chatty_chat.room AND threads.name=? "
+                          "INNER JOIN accounts "
+                          "ON threads.account_id=accounts.id "
+                          "INNER JOIN users AS a "
+                          "ON accounts.user_id=a.id AND a.username=? AND chatty_chat.account=? "
+                          "AND chatty_chat.who IS NULL "
+                          "ORDER BY timestamp ASC, chatty_chat.id ASC;",
+                          -1, &insert_stmt, NULL);
+
+      history_bind_text (insert_stmt, 1, room, "binding when adding message");
+      history_bind_text (insert_stmt, 2, account_number ? account_number : account, "binding when adding message");
+      history_bind_text (insert_stmt, 3, account, "binding when adding message");
+      status = sqlite3_step (insert_stmt);
+      sqlite3_finalize (insert_stmt);
+
+      /* Fill in messages with author */
+      sqlite3_prepare_v2 (self->db,
+                          "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                          "SELECT DISTINCT uid,threads.id,u.id,"
+                          "message," STRING(MESSAGE_TYPE_HTML_ESCAPED) ",timestamp,direction "
+                          "FROM chatty_chat "
+                          "INNER JOIN threads "
+                          "ON threads.name=chatty_chat.room AND threads.name=? "
+                          "INNER JOIN accounts "
+                          "ON threads.account_id=accounts.id "
+                          "INNER JOIN users AS a "
+                          "ON accounts.user_id=a.id AND a.username=? AND chatty_chat.account=? "
+                          "INNER JOIN users as u "
+                          "ON u.username=? AND chatty_chat.who=? "
+                          "AND chatty_chat.who NOT NULL "
+                          "AND chatty_chat.direction!=-1 "
+                          "ORDER BY timestamp ASC, chatty_chat.id ASC;",
+                          -1, &insert_stmt, NULL);
+
+      history_bind_text (insert_stmt, 1, room, "binding when adding threads");
+      history_bind_text (insert_stmt, 2, account_number ? account_number : account, "binding when adding phone number");
+      history_bind_text (insert_stmt, 3, account, "binding when adding phone number");
+      history_bind_text (insert_stmt, 4, sender_number ? sender_number : sender, "binding when adding threads");
+      history_bind_text (insert_stmt, 5, sender, "binding when adding threads");
+      status = sqlite3_step (insert_stmt);
+      sqlite3_finalize (insert_stmt);
+
+      /* Fill in chat thread members */
+      sqlite3_prepare_v2 (self->db, "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                          "SELECT DISTINCT threads.id,u.id FROM threads "
+                          "INNER JOIN accounts "
+                          "ON threads.account_id=accounts.id "
+                          "INNER JOIN users AS a "
+                          "ON accounts.user_id=a.id AND a.username=? "
+                          "INNER JOIN chatty_chat "
+                          "ON chatty_chat.account=? "
+                          "AND threads.name=chatty_chat.room AND threads.name=? "
+                          "INNER JOIN users AS u "
+                          "ON u.type=" STRING(CHATTY_ID_PHONE_VALUE) " "
+                          "AND u.username=? AND chatty_chat.who=?;",
+                          -1, &insert_stmt, NULL);
+
+      history_bind_text (insert_stmt, 1, account_number ? account_number : account, "binding when adding thread member");
+      history_bind_text (insert_stmt, 2, account, "binding when adding thread member");
+      history_bind_text (insert_stmt, 3, room, "binding when adding thread member");
+      history_bind_text (insert_stmt, 4, sender_number ? sender_number : sender, "binding when adding thread member");
+      history_bind_text (insert_stmt, 5, sender, "binding when adding thread member");
+      status = sqlite3_step (insert_stmt);
+      sqlite3_finalize (insert_stmt);
+    }
+
+    sqlite3_exec (self->db,
+                  "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                  "SELECT DISTINCT threads.id,u.id FROM threads "
+                  "INNER JOIN users AS u "
+                  "ON threads.name=u.username "
+                  "AND u.type="STRING(CHATTY_ID_PHONE_VALUE) ";",
+                  NULL, NULL, &error);
+
+    if (status == SQLITE_DONE || status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "COMMIT;", NULL, NULL, &error);
+
+    sqlite3_finalize (stmt);
+  }
+
+  if (status == SQLITE_OK) {
+    sqlite3_stmt *stmt;
+    status = sqlite3_prepare_v2 (self->db,
+                                 /* SMS users with phone numbers sorted */
+                                 "SELECT DISTINCT generated.who FROM "
+                                 "(SELECT who,id FROM chatty_im WHERE account='SMS' ORDER BY id ASC) "
+                                 "AS generated ORDER BY generated.id;",
+                                 -1, &stmt, NULL);
+
+    if (status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "BEGIN TRANSACTION;", NULL, NULL, &error);
+
+    while (sqlite3_step (stmt) == SQLITE_ROW) {
+      g_autofree char *sender_number = NULL;
+      sqlite3_stmt *insert_stmt = NULL;
+      const char *sender, *country;
+
+      sender = (gpointer)sqlite3_column_text (stmt, 0);
+      country = g_object_get_data (G_OBJECT (task), "country-code");
+
+      sender_number  = chatty_utils_check_phonenumber (sender, country);
+
+      history_add_phone_user (self, task,
+                              sender_number ? sender_number : sender,
+                              NULL);
+
+      history_add_thread (self, task, "SMS",
+                          sender_number ? sender_number : sender,
+                          sender, THREAD_DIRECT_CHAT);
+
+      /* Fill in messages with no author */
+      sqlite3_prepare_v2 (self->db, "INSERT OR IGNORE INTO messages(uid,thread_id,sender_id,body,body_type,time,direction) "
+                          "SELECT DISTINCT uid,threads.id,u.id,message," STRING(MESSAGE_TYPE_TEXT) ",timestamp,direction "
+                          "FROM chatty_im "
+                          "INNER JOIN threads "
+                          "ON threads.name=? AND chatty_im.who=? "
+                          "INNER JOIN accounts "
+                          "ON threads.account_id=accounts.id "
+                          "INNER JOIN users AS a "
+                          "ON accounts.user_id=a.id AND a.username=chatty_im.account "
+                          "AND chatty_im.account='SMS' "
+                          "INNER JOIN users as u "
+                          "ON u.username=? "
+                          "ORDER BY timestamp ASC, chatty_im.id ASC;",
+                          -1, &insert_stmt, NULL);
+
+      history_bind_text (insert_stmt, 1, sender_number ? sender_number : sender, "binding when adding message");
+      history_bind_text (insert_stmt, 2, sender, "binding when adding message");
+      history_bind_text (insert_stmt, 3, sender_number ? sender_number : sender, "binding when adding message");
+      status = sqlite3_step (insert_stmt);
+      sqlite3_finalize (insert_stmt);
+    }
+
+    sqlite3_exec (self->db,
+                  "INSERT OR IGNORE INTO thread_members(thread_id,user_id) "
+                  "SELECT DISTINCT threads.id,u.id FROM threads "
+                  "INNER JOIN users AS u "
+                  "ON threads.name=u.username "
+                  "AND u.type="STRING(CHATTY_ID_PHONE_VALUE) ";",
+                  NULL, NULL, &error);
+
+    if (status == SQLITE_DONE || status == SQLITE_OK)
+      status = sqlite3_exec (self->db, "COMMIT;", NULL, NULL, &error);
+
+    sqlite3_finalize (stmt);
+  }
+
+  /* Drop old tables */
+  if (status == SQLITE_OK)
+    status = sqlite3_exec (self->db,
+                           "BEGIN TRANSACTION;"
+                           "DROP TABLE chatty_chat;"
+                           "DROP TABLE chatty_im;"
+                           "COMMIT;", NULL, NULL, &error);
+
+  if (status == SQLITE_OK || status == SQLITE_DONE) {
+    /* Update user_version pragma */
+    if (!chatty_history_update_version (self, task))
+      return FALSE;
+    return TRUE;
+  }
+
+  g_task_return_new_error (task,
+                           G_IO_ERROR,
+                           G_IO_ERROR_FAILED,
+                           "Error setting db version. errno: %d, desc: %s. %s",
+                           status, sqlite3_errstr (status), error);
+  sqlite3_free (error);
 
-  if (status != SQLITE_OK) {
+  return FALSE;
+}
+
+static gboolean
+chatty_history_migrate (ChattyHistory *self,
+                        GTask         *task)
+{
+  int version;
+
+  g_assert (CHATTY_IS_HISTORY (self));
+  g_assert (G_IS_TASK (task));
+  g_assert (g_thread_self () == self->worker_thread);
+  g_assert (self->db);
+
+  version = chatty_history_get_db_version (self, task);
+
+  if (version == HISTORY_VERSION)
+    return TRUE;
+
+  switch (version) {
+  case -1:  /* Error */
+    return FALSE;
+
+  case 0:
+    if (!chatty_history_migrate_db_to_v1 (self, task))
+      return FALSE;
+    break;
+
+  default:
     g_task_return_new_error (task,
                              G_IO_ERROR,
                              G_IO_ERROR_FAILED,
-                             "Error creating chatty_im table. errno: %d, desc: %s. %s",
-                             status, sqlite3_errstr (status), error);
+                             "Failed to migrate from version %d, unknown version",
+                             version);
+    return FALSE;
   }
 
-  return status;
+  return TRUE;
 }
 
 static void
@@ -235,6 +1356,7 @@ history_open_db (ChattyHistory *self,
   g_autofree char *db_path = NULL;
   sqlite3 *db;
   int status;
+  gboolean db_exists;
 
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
@@ -247,26 +1369,29 @@ history_open_db (ChattyHistory *self,
   g_assert (file_name && *file_name);
 
   g_mkdir_with_parents (dir, S_IRWXU);
-  db_path = g_build_filename (dir, file_name, NULL);
+  self->db_path = g_build_filename (dir, file_name, NULL);
 
-  status = sqlite3_open (db_path, &db);
+  db_exists = g_file_test (self->db_path, G_FILE_TEST_EXISTS);
+  status = sqlite3_open (self->db_path, &db);
 
   if (status == SQLITE_OK) {
     self->db = db;
-    status = chatty_history_create_chat_schema (self, task);
 
-    if (status == SQLITE_OK)
-      status = chatty_history_create_im_schema (self, task);
+    if (db_exists) {
+      if (!chatty_history_migrate (self, task))
+        return;
+    } else {
+      if (!chatty_history_create_schema (self, task))
+        return;
+
+      if (!chatty_history_update_version (self, task))
+        return;
+    }
 
-    if (status == SQLITE_OK)
-      g_task_return_boolean (task, TRUE);
+    sqlite3_exec (self->db, "PRAGMA foreign_keys = ON;", NULL, NULL, NULL);
+    g_task_return_boolean (task, TRUE);
   } else {
-    sqlite3_close (db);
-    g_task_return_new_error (task,
-                             G_IO_ERROR,
-                             G_IO_ERROR_FAILED,
-                             "Database could not be opened. errno: %d, desc: %s",
-                             status, sqlite3_errstr (status));
+    g_task_return_boolean (task, FALSE);
   }
 }
 
@@ -314,37 +1439,30 @@ history_close_db (ChattyHistory *self,
 static guint
 get_id_for_message (ChattyHistory *self,
                     ChattyChat    *chat,
-                    ChattyMessage *message)
+                    ChattyMessage *message,
+                    int           *thread_id)
 {
-  const char *uuid, *who;
+  const char *uuid;
   sqlite3_stmt *stmt;
   int status;
   guint id = INT_MAX;
 
-  if (!CHATTY_IS_MESSAGE (message) || !CHATTY_IS_CHAT (chat))
-    return id;
-
   g_assert (g_thread_self () == self->worker_thread);
+  g_assert (thread_id);
 
-  uuid = chatty_message_get_uid (message);
+  *thread_id = get_thread_id (self, chat);
 
-  if (!uuid || !*uuid)
+  if (!CHATTY_IS_MESSAGE (message) || !CHATTY_IS_CHAT (chat) || !*thread_id)
     return id;
 
-  if (chatty_chat_is_im (chat))
-    who = chatty_chat_get_username (chat);
-  else
-    who = chatty_chat_get_chat_name (chat);
-
-  if (chatty_chat_is_im (chat))
-    status = sqlite3_prepare_v2 (self->db, "SELECT id FROM chatty_im WHERE uid=(?) AND account=(?)", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "SELECT id FROM chatty_chat WHERE uid=(?) AND room=(?)", -1, &stmt, NULL);
+  uuid = chatty_message_get_uid (message);
 
-  warn_if_sql_error (status, "preparing to get id");
+  if (!uuid || !*uuid)
+    return id;
 
-  history_bind_text (stmt, 1, uuid, "binding when getting id");
-  history_bind_text (stmt, 2, who, "binding when getting id");
+  sqlite3_prepare_v2 (self->db, "SELECT id FROM messages WHERE thread_id=? AND uid=?", -1, &stmt, NULL);
+  history_bind_int (stmt, 1, *thread_id, "binding when getting id");
+  history_bind_text (stmt, 2, uuid, "binding when getting id");
 
   status = sqlite3_step (stmt);
   warn_if_sql_error (status, "finding message for id");
@@ -360,11 +1478,11 @@ get_id_for_message (ChattyHistory *self,
 static GPtrArray *
 get_messages_before_id (ChattyHistory *self,
                         ChattyChat    *chat,
+                        int            thread_id,
                         guint          since_id,
                         guint          limit)
 {
   GPtrArray *messages = NULL;
-  const char *chat_name, *account;
   sqlite3_stmt *stmt;
   int status;
 
@@ -373,22 +1491,17 @@ get_messages_before_id (ChattyHistory *s
   g_assert (g_thread_self () == self->worker_thread);
   g_assert (limit != 0);
 
-  account = chatty_chat_get_username (chat);
-  chat_name = chatty_chat_get_chat_name (chat);
-
-  if (chatty_chat_is_im (chat))
-    status = sqlite3_prepare_v2 (self->db, "SELECT timestamp,direction,message,uid FROM chatty_im "
-                                 "WHERE account=(?) AND who=(?) AND id < (?) AND message != \"\" ORDER BY timestamp DESC, id DESC LIMIT (?)", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "SELECT timestamp,direction,message,uid,who FROM chatty_chat "
-                                 "WHERE account=(?) AND room=(?) AND id < (?) AND message != \"\" ORDER BY timestamp DESC, id DESC LIMIT (?)", -1, &stmt, NULL);
-
-  warn_if_sql_error (status, "preparing to get messages");
-
-  history_bind_text (stmt, 1, account, "binding when getting messages");
-  history_bind_text (stmt, 2, chat_name, "binding when getting messages");
-  history_bind_int (stmt, 3, since_id, "binding when getting messages");
-  history_bind_int (stmt, 4, limit, "binding when getting messages");
+  status = sqlite3_prepare_v2 (self->db, "SELECT time,direction,body,uid,users.username FROM messages "
+                               "LEFT JOIN users "
+                               "ON messages.sender_id=users.id "
+                               "WHERE thread_id=? "
+                               "AND messages.id < ? "
+                               "AND body NOT NULL AND body !='' "
+                               "ORDER BY time DESC, messages.id DESC LIMIT ?;",
+                               -1, &stmt, NULL);
+  history_bind_int (stmt, 1, thread_id, "binding when getting messages");
+  history_bind_int (stmt, 2, since_id, "binding when getting messages");
+  history_bind_int (stmt, 3, limit, "binding when getting messages");
 
   while (sqlite3_step (stmt) == SQLITE_ROW) {
     ChattyMessage *message;
@@ -428,6 +1541,7 @@ history_get_messages (ChattyHistory *sel
   ChattyChat *chat;
   guint since_id;
   guint limit;
+  int thread_id;
 
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
@@ -448,8 +1562,8 @@ history_get_messages (ChattyHistory *sel
   g_assert (!start || CHATTY_IS_MESSAGE (start));
   g_assert (CHATTY_IS_CHAT (chat));
 
-  since_id = get_id_for_message (self, chat, start);
-  messages = get_messages_before_id (self, chat, since_id, limit);
+  since_id = get_id_for_message (self, chat, start, &thread_id);
+  messages = get_messages_before_id (self, chat, thread_id, since_id, limit);
   g_task_return_pointer (task, messages, (GDestroyNotify)g_ptr_array_unref);
 }
 
@@ -460,8 +1574,9 @@ history_add_message (ChattyHistory *self
   ChattyMessage *message;
   ChattyChat *chat;
   sqlite3_stmt *stmt;
-  const char *account, *who, *uid, *msg;
+  const char *who, *uid, *msg;
   ChattyMsgDirection direction;
+  int thread_id = 0, sender_id = 0;
   int status, dir;
   time_t time_stamp;
 
@@ -481,7 +1596,6 @@ history_add_message (ChattyHistory *self
   g_assert (CHATTY_IS_CHAT (chat));
   g_assert (CHATTY_IS_MESSAGE (message));
 
-  account = chatty_chat_get_username (chat);
   who = chatty_message_get_user_name (message);
   uid = chatty_message_get_uid (message);
   msg = chatty_message_get_text (message);
@@ -489,32 +1603,35 @@ history_add_message (ChattyHistory *self
   direction = chatty_message_get_msg_direction (message);
   dir = history_direction_to_value (direction);
 
-  if (chatty_chat_is_im (chat))
-    status = sqlite3_prepare_v2 (self->db, "INSERT INTO chatty_im VALUES (?, ?, ?, ?, ?, ?, ?)", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "INSERT INTO chatty_chat VALUES (?, ?, ?, ?, ?, ?, ?, ?)", -1, &stmt, NULL);
-
-  warn_if_sql_error (status, "preparing statement when adding message");
+  /* TODO: check if this is good */
+  if (!who || !*who) {
+    if (direction == CHATTY_DIRECTION_OUT)
+      who = chatty_chat_get_username (chat);
+    else if (direction == CHATTY_DIRECTION_IN && chatty_chat_is_im (chat))
+      who = chatty_chat_get_chat_name (chat);
+  }
 
-  if (chatty_chat_is_im (chat)) {
-    history_bind_text (stmt, IM_ACCOUNT_IDX, account, "binding when adding IM message");
-    history_bind_text (stmt, IM_WHO_IDX, who, "binding when adding IM message");
-    history_bind_text (stmt, IM_UID_IDX, uid, "binding when adding IM message");
-    history_bind_text (stmt, IM_MESSAGE_IDX, msg, "binding when adding IM message");
-    history_bind_int (stmt, IM_TIMESTAMP_IDX, time_stamp, "binding when adding IM message");
-    history_bind_int (stmt, IM_DIRECTION_IDX, dir, "binding when adding IM message");
-  } else {
-    const char *room;
+  thread_id = insert_or_ignore_thread (self, chat, task);
+  if (!thread_id)
+    return;
 
-    room = chatty_chat_get_chat_name (chat);
-    history_bind_text (stmt, CHAT_ACCOUNT_IDX, account, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_ROOM_IDX, room, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_WHO_IDX, who, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_UID_IDX, uid, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_MESSAGE_IDX, msg, "binding when adding CHAT message");
-    history_bind_int (stmt, CHAT_TIMESTAMP_IDX, time_stamp, "binding when adding CHAT message");
-    history_bind_int (stmt, CHAT_DIRECTION_IDX, dir, "binding when adding CHAT message");
-  }
+  sender_id = insert_or_ignore_user (self, chatty_item_get_protocols (CHATTY_ITEM (chat)), who, task);
+  sqlite3_prepare_v2 (self->db,
+                      "INSERT INTO messages(uid,thread_id,sender_id,body,body_type,direction,time) "
+                      "VALUES(?1,?2,?3,?4,?5,?6,?7);",
+                      -1, &stmt, NULL);
+
+  history_bind_text (stmt, 1, uid, "binding when adding message");
+  history_bind_int (stmt, 2, thread_id, "binding when adding message");
+  if (sender_id)
+    history_bind_int (stmt, 3, sender_id, "binding when adding message");
+  history_bind_text (stmt, 4, msg, "binding when adding message");
+  if (chatty_item_get_protocols (CHATTY_ITEM (chat)) == CHATTY_PROTOCOL_SMS)
+    history_bind_int (stmt, 5, MESSAGE_TYPE_TEXT, "binding when adding message");
+  else
+    history_bind_int (stmt, 5, MESSAGE_TYPE_HTML_ESCAPED, "binding when adding message");
+  history_bind_int (stmt, 6, dir, "binding when adding message");
+  history_bind_int (stmt, 7, time_stamp, "binding when adding message");
 
   status = sqlite3_step (stmt);
   sqlite3_finalize (stmt);
@@ -562,15 +1679,20 @@ history_delete_chat (ChattyHistory *self
 
   account = chatty_chat_get_username (chat);
 
-  if (chatty_chat_is_im (chat))
-    status = sqlite3_prepare_v2 (self->db, "DELETE FROM chatty_im WHERE account=(?) AND who=(?)", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "DELETE FROM chatty_chat WHERE account=(?) AND room=(?)", -1, &stmt, NULL);
-
-  warn_if_sql_error (status, "preparing statement when deleting chat");
-
-  history_bind_text (stmt, 1, account, "binding when deleting message");
-  history_bind_text (stmt, 2, chat_name, "binding when deleting message");
+  status = sqlite3_prepare_v2 (self->db,
+                               "DELETE FROM threads "
+                               "WHERE threads.type=? AND threads.name=? "
+                               "AND threads.account_id IN ("
+                               "SELECT accounts.id FROM accounts "
+                               "INNER JOIN users "
+                               "ON accounts.id=threads.account_id "
+                               "AND users.id=accounts.user_id AND users.username=?);",
+                               -1, &stmt, NULL);
+
+  history_bind_int (stmt, 1, chatty_chat_is_im (chat) ? THREAD_DIRECT_CHAT : THREAD_GROUP_CHAT,
+                    "binding when deleting thread");
+  history_bind_text (stmt, 2, chat_name, "binding when deleting thread");
+  history_bind_text (stmt, 3, account, "binding when deleting thread");
 
   status = sqlite3_step (stmt);
   sqlite3_finalize (stmt);
@@ -595,17 +1717,18 @@ history_get_chat_timestamp (ChattyHistor
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
 
-  status = sqlite3_prepare_v2 (self->db, "SELECT timestamp FROM chatty_chat WHERE uid=(?) AND room=(?) LIMIT 1", -1, &stmt, NULL);
-  warn_if_sql_error (status, "preparing statement when getting timestamp");
-
   uuid = g_object_get_data (G_OBJECT (task), "uuid");
   room = g_object_get_data (G_OBJECT (task), "room");
 
   g_assert (uuid);
   g_assert (room);
 
-  history_bind_text (stmt, 1, uuid, "binding when getting timestamp");
-  history_bind_text (stmt, 2, room, "binding when getting timestamp");
+  sqlite3_prepare_v2 (self->db, "SELECT time FROM messages "
+                      "INNER JOIN threads "
+                      "ON threads.name=? "
+                      "WHERE uid=? LIMIT 1;", -1, &stmt, NULL);
+  history_bind_text (stmt, 1, room, "binding when getting timestamp");
+  history_bind_text (stmt, 2, uuid, "binding when getting timestamp");
 
   if (sqlite3_step (stmt) == SQLITE_ROW)
     timestamp = sqlite3_column_int (stmt, 0);
@@ -627,14 +1750,20 @@ history_get_im_timestamp (ChattyHistory
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
 
-  status = sqlite3_prepare_v2 (self->db, "SELECT timestamp FROM chatty_im WHERE uid=(?) AND account=(?) LIMIT 1", -1, &stmt, NULL);
-  warn_if_sql_error (status, "preparing statement when getting timestamp");
-
   uuid = g_object_get_data (G_OBJECT (task), "uuid");
   account = g_object_get_data (G_OBJECT (task), "account");
 
-  history_bind_text (stmt, 1, uuid, "binding when getting timestamp");
-  history_bind_text (stmt, 2, account, "binding when getting timestamp");
+  sqlite3_prepare_v2 (self->db, "SELECT time FROM messages "
+                      "INNER JOIN threads "
+                      "ON threads.account_id=accounts.id "
+                      "INNER JOIN accounts "
+                      "ON accounts.user_id=users.id "
+                      "INNER JOIN users "
+                      "ON users.id=accounts.user_id AND users.username=? "
+                      "WHERE messages.uid=? LIMIT 1",
+                      -1, &stmt, NULL);
+  history_bind_text (stmt, 1, account, "binding when getting timestamp");
+  history_bind_text (stmt, 2, uuid, "binding when getting timestamp");
 
   if (sqlite3_step (stmt) == SQLITE_ROW)
     timestamp = sqlite3_column_int (stmt, 0);
@@ -656,14 +1785,21 @@ history_get_last_message_time (ChattyHis
   g_assert (CHATTY_IS_HISTORY (self));
   g_assert (G_IS_TASK (task));
 
-  status = sqlite3_prepare_v2 (self->db, "SELECT max(timestamp),max(id) FROM chatty_chat WHERE account=(?) AND room=(?)", -1, &stmt, NULL);
-  warn_if_sql_error (status, "preparing statement when getting timestamp");
-
   account = g_object_get_data (G_OBJECT (task), "account");
   room = g_object_get_data (G_OBJECT (task), "room");
 
-  history_bind_text (stmt, 1, account, "binding when getting timestamp");
-  history_bind_text (stmt, 2, room, "binding when getting timestamp");
+  status = sqlite3_prepare_v2 (self->db,
+                               "SELECT max(time),messages.id FROM messages "
+                               "INNER JOIN threads "
+                               "ON threads.name=? AND messages.thread_id=threads.id "
+                               "INNER JOIN accounts "
+                               "ON accounts.id=threads.account_id "
+                               "INNER JOIN users "
+                               "ON users.id=accounts.user_id AND users.username=? "
+                               "ORDER BY messages.id DESC LIMIT 1;",
+                               -1, &stmt, NULL);
+  history_bind_text (stmt, 1, room, "binding when getting timestamp");
+  history_bind_text (stmt, 2, account, "binding when getting timestamp");
 
   if (sqlite3_step (stmt) == SQLITE_ROW)
     timestamp = sqlite3_column_int (stmt, 0);
@@ -693,19 +1829,23 @@ history_exists (ChattyHistory *self,
   g_assert (account);
   g_assert (room || who);
 
-  if (who)
-    status = sqlite3_prepare_v2 (self->db, "SELECT timestamp FROM chatty_im WHERE account=(?) AND who=(?) LIMIT 1", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "SELECT timestamp FROM chatty_chat WHERE account=(?) AND room=(?) LIMIT 1", -1, &stmt, NULL);
-
-  warn_if_sql_error (status, "preparing statement when getting timestamp");
-
-  history_bind_text (stmt, 1, account, "binding when getting timestamp");
+  sqlite3_prepare_v2 (self->db,
+                      "SELECT time FROM messages "
+                      "INNER JOIN threads "
+                      "ON threads.name=? "
+                      "INNER JOIN accounts "
+                      "ON threads.account_id=accounts.id "
+                      "INNER JOIN users "
+                      "ON users.id=accounts.user_id AND users.username=? "
+                      "WHERE messages.thread_id=threads.id LIMIT 1;",
+                      -1, &stmt, NULL);
 
-  if (who)
-    history_bind_text (stmt, 2, who, "binding when getting timestamp");
+  if (room)
+    history_bind_text (stmt, 1, room, "binding when getting timestamp");
   else
-    history_bind_text (stmt, 2, room, "binding when getting timestamp");
+    history_bind_text (stmt, 1, who, "binding when getting timestamp");
+
+  history_bind_text (stmt, 2, account, "binding when getting timestamp");
 
   if (sqlite3_step (stmt) == SQLITE_ROW)
     found = TRUE;
@@ -716,67 +1856,6 @@ history_exists (ChattyHistory *self,
   g_task_return_boolean (task, found);
 }
 
-static void
-history_add_raw_message (ChattyHistory *self,
-                         GTask         *task)
-{
-  const char *account, *room, *who, *msg, *uid;
-  sqlite3_stmt *stmt;
-  int status, time_stamp, direction;
-  PurpleConversationType type;
-
-  g_assert (CHATTY_IS_HISTORY (self));
-  g_assert (G_IS_TASK (task));
-
-  if (!self->db) {
-    g_task_return_new_error (task,
-                             G_IO_ERROR, G_IO_ERROR_FAILED,
-                             "Error: Database not opened");
-    return;
-  }
-
-  account = g_object_get_data (G_OBJECT (task), "account");
-  room = g_object_get_data (G_OBJECT (task), "room");
-  type = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (task), "type"));
-  who = g_object_get_data (G_OBJECT (task), "who");
-  msg = g_object_get_data (G_OBJECT (task), "message");
-  uid = g_object_get_data (G_OBJECT (task), "uid");
-  time_stamp = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (task), "time"));
-  direction = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (task), "dir"));
-
-  g_assert (account);
-  g_assert (uid);
-
-  if (type == PURPLE_CONV_TYPE_CHAT)
-    status = sqlite3_prepare_v2 (self->db, "INSERT INTO chatty_chat VALUES (?, ?, ?, ?, ?, ?, ?, ?)", -1, &stmt, NULL);
-  else
-    status = sqlite3_prepare_v2 (self->db, "INSERT INTO chatty_im VALUES (?, ?, ?, ?, ?, ?, ?)", -1, &stmt, NULL);
-
-  warn_if_sql_error (status, "preparing statement when adding raw message");
-
-  if (type == PURPLE_CONV_TYPE_CHAT) {
-    history_bind_text (stmt, CHAT_ACCOUNT_IDX, account, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_ROOM_IDX, room, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_WHO_IDX, who, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_UID_IDX, uid, "binding when adding CHAT message");
-    history_bind_text (stmt, CHAT_MESSAGE_IDX, msg, "binding when adding CHAT message");
-    history_bind_int (stmt, CHAT_TIMESTAMP_IDX, time_stamp, "binding when adding CHAT message");
-    history_bind_int (stmt, CHAT_DIRECTION_IDX, direction, "binding when adding CHAT message");
-  } else {
-    history_bind_text (stmt, IM_ACCOUNT_IDX, account, "binding when adding IM message");
-    history_bind_text (stmt, IM_WHO_IDX, who, "binding when adding IM message");
-    history_bind_text (stmt, IM_UID_IDX, uid, "binding when adding IM message");
-    history_bind_text (stmt, IM_MESSAGE_IDX, msg, "binding when adding IM message");
-    history_bind_int (stmt, IM_TIMESTAMP_IDX, time_stamp, "binding when adding IM message");
-    history_bind_int (stmt, IM_DIRECTION_IDX, direction, "binding when adding IM message");
-  }
-
-  status = sqlite3_step (stmt);
-  sqlite3_finalize (stmt);
-
-  g_task_return_boolean (task, status == SQLITE_DONE);
-}
-
 static gpointer
 chatty_history_worker (gpointer user_data)
 {
@@ -819,6 +1898,7 @@ chatty_history_finalize (GObject *object
     g_warning ("Database not closed");
 
   g_clear_pointer (&self->queue, g_async_queue_unref);
+  g_free (self->db_path);
 
   G_OBJECT_CLASS (chatty_history_parent_class)->finalize (object);
 }
@@ -878,6 +1958,7 @@ chatty_history_open_async (ChattyHistory
                            gpointer             user_data)
 {
   GTask *task;
+  const char *country;
 
   g_return_if_fail (CHATTY_IS_HISTORY (self));
   g_return_if_fail (dir || !*dir);
@@ -893,11 +1974,13 @@ chatty_history_open_async (ChattyHistory
                                         chatty_history_worker,
                                         self);
 
+  country = chatty_settings_get_country_iso_code (chatty_settings_get_default ());
   task = g_task_new (self, NULL, callback, user_data);
   g_task_set_source_tag (task, chatty_history_open_async);
   g_task_set_task_data (task, history_open_db, NULL);
   g_object_set_data_full (G_OBJECT (task), "dir", dir, g_free);
   g_object_set_data_full (G_OBJECT (task), "file-name", g_strdup (file_name), g_free);
+  g_object_set_data_full (G_OBJECT (task), "country-code", g_strdup (country), g_free);
 
   g_async_queue_push (self->queue, task);
 }
@@ -1494,13 +2577,12 @@ chatty_history_chat_exists (const char *
 /**
  * chatty_history_add_message:
  * @account: a valid account name
- * @room: A room name or %NULL for IM chats
+ * @chat: A #ChattyChat
  * @who: A user name or %NULL
  * @message The chat message to store
  * @uid: (inout): A pointer to uid string for the @message
  * @flags: A #PurpleMessageFlags
  * @time_stamp: A unix time
- * @type: A #PurpleConversationType
  *
  * Store a message to database.  If @flags has
  * %PURPLE_MESSAGE_NO_LOG set, this method returns
@@ -1514,59 +2596,15 @@ chatty_history_chat_exists (const char *
  * %FALSE otherwise.
  */
 gboolean
-chatty_history_add_message (const char              *account,
-                            const char              *room,
-                            const char              *who,
-                            const char              *message,
-                            char                   **uid,
-                            PurpleMessageFlags       flags,
-                            time_t                   time_stamp,
-                            PurpleConversationType   type)
+chatty_history_add_message (ChattyChat    *chat,
+                            ChattyMessage *message)
 {
   ChattyHistory *self;
   g_autoptr(GTask) task = NULL;
-  int dir = 0;
-
-  g_return_val_if_fail (account, FALSE);
-  g_return_val_if_fail (uid, FALSE);
-
-  if (type == PURPLE_CONV_TYPE_CHAT)
-    g_return_val_if_fail (room, FALSE);
-
-  if (type == PURPLE_CONV_TYPE_IM)
-    g_return_val_if_fail (who, FALSE);
 
   self = chatty_history_get_default ();
-  g_return_val_if_fail (self->db, FALSE);
-
-  /* Don’t save if marked so */
-  if (flags & PURPLE_MESSAGE_NO_LOG)
-    return FALSE;
-
-  /* direction of message */
-  if (flags & PURPLE_MESSAGE_SYSTEM)
-    dir = 0;
-  else if (flags & PURPLE_MESSAGE_RECV)
-    dir = 1;
-  else if (flags & PURPLE_MESSAGE_SEND)
-    dir = -1;
-
-  if (!*uid)
-    *uid = g_uuid_string_random ();
-
   task = g_task_new (NULL, NULL, NULL, NULL);
-  g_object_ref (task);
-  g_task_set_task_data (task, history_add_raw_message, NULL);
-  g_object_set_data_full (G_OBJECT (task), "account", g_strdup (account), g_free);
-  g_object_set_data_full (G_OBJECT (task), "room", g_strdup (room), g_free);
-  g_object_set_data_full (G_OBJECT (task), "who", g_strdup (who), g_free);
-  g_object_set_data_full (G_OBJECT (task), "message", g_strdup (message), g_free);
-  g_object_set_data_full (G_OBJECT (task), "uid", g_strdup (*uid), g_free);
-  g_object_set_data (G_OBJECT (task), "dir", GINT_TO_POINTER (dir));
-  g_object_set_data (G_OBJECT (task), "time", GINT_TO_POINTER (time_stamp));
-  g_object_set_data (G_OBJECT (task), "type", GINT_TO_POINTER (type));
-
-  g_async_queue_push (self->queue, task);
+  chatty_history_add_message_async (self, chat, message, finish_cb, task);
 
   /* Wait until the task is completed */
   while (!g_task_get_completed (task))
diff -pruN 0.1.17-1/src/chatty-history.h 0.2.0-1/src/chatty-history.h
--- 0.1.17-1/src/chatty-history.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-history.h	2020-11-27 09:44:20.000000000 +0000
@@ -78,13 +78,7 @@ gboolean       chatty_history_im_exists
                                                    const char            *who);
 gboolean       chatty_history_chat_exists         (const char            *account,
                                                    const char            *room);
-gboolean       chatty_history_add_message         (const char            *account,
-                                                   const char            *room,
-                                                   const char            *who,
-                                                   const char            *message,
-                                                   char                 **uid,
-                                                   PurpleMessageFlags     flags,
-                                                   time_t                 time_stamp,
-                                                   PurpleConversationType type);
+gboolean       chatty_history_add_message         (ChattyChat            *chat,
+                                                   ChattyMessage         *message);
 
 G_END_DECLS
diff -pruN 0.1.17-1/src/chatty-list-row.c 0.2.0-1/src/chatty-list-row.c
--- 0.1.17-1/src/chatty-list-row.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-list-row.c	2020-11-27 09:44:20.000000000 +0000
@@ -328,7 +328,7 @@ chatty_list_row_class_init (ChattyListRo
   object_class->finalize = chatty_list_row_finalize;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-list-row.ui");
   gtk_widget_class_bind_template_child (widget_class, ChattyListRow, avatar);
   gtk_widget_class_bind_template_child (widget_class, ChattyListRow, title);
diff -pruN 0.1.17-1/src/chatty-manager.c 0.2.0-1/src/chatty-manager.c
--- 0.1.17-1/src/chatty-manager.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-manager.c	2020-11-27 09:44:20.000000000 +0000
@@ -111,6 +111,8 @@ static GHashTable *ui_info = NULL;
 #define PURPLE_GLIB_READ_COND  (G_IO_IN | G_IO_HUP | G_IO_ERR)
 #define PURPLE_GLIB_WRITE_COND (G_IO_OUT | G_IO_HUP | G_IO_ERR | G_IO_NVAL)
 
+static void manager_update_protocols (ChattyManager *self);
+
 static int
 manager_sort_chat_item (ChattyChat *a,
                         ChattyChat *b,
@@ -209,8 +211,10 @@ manager_load_messages_cb (GObject      *
       model = chatty_chat_get_messages (item);
 
       /* If at least one message is loaded, don’t add again. */
-      if (g_list_model_get_n_items (model) == 0)
+      if (g_list_model_get_n_items (model) == 0) {
         chatty_pp_chat_prepend_messages (CHATTY_PP_CHAT (item), messages);
+        manager_update_protocols (self);
+      }
     }
 
   } else if (error && !g_error_matches (error, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
@@ -832,7 +836,21 @@ chatty_conv_write_conversation (PurpleCo
 
     pcm.who = chatty_utils_jabber_id_strip(who);
   } else {
-    pcm.who = chatty_pp_chat_get_buddy_name (CHATTY_PP_CHAT (chat), who);
+    ChattyProtocol protocol;
+
+    protocol = chatty_item_get_protocols (CHATTY_ITEM (chat));
+
+    if (protocol == CHATTY_PROTOCOL_MATRIX ||
+        protocol == CHATTY_PROTOCOL_XMPP)
+      pcm.who = chatty_pp_chat_get_buddy_name (CHATTY_PP_CHAT (chat), who);
+    else
+      pcm.who = g_strdup (who);
+
+    if (protocol == CHATTY_PROTOCOL_XMPP &&
+        !g_str_has_prefix (pcm.who, conv->name)) {
+      g_autofree char *temp = pcm.who;
+      pcm.who = chatty_utils_jabber_id_strip (pcm.who);
+    }
   }
 
   // No reason to go further if we ignore system/status
@@ -851,27 +869,12 @@ chatty_conv_write_conversation (PurpleCo
 
   // If anyone wants to suppress archiving - feel free to set NO_LOG flag
   purple_signal_emit (chatty_manager_get_default (),
-                      "conversation-write", account, &pcm, &uuid, type);
+                      "conversation-write", conv, &pcm, &uuid, type);
   g_debug("Posting message id:%s flags:%d type:%d from:%s",
           uuid, pcm.flags, type, pcm.who);
 
-  /*
-   * This is default fallback history handler.  Other plugins may
-   * intercept “conversation-write” and suppress it if they handle
-   * history on their own (eg. MAM).  If %PURPLE_MESSAGE_NO_LOG is
-   * set in @flags, it won't be saved to database.
-   */
-  if (!(pcm.flags & PURPLE_MESSAGE_NO_LOG)) {
-    const char *chat_name;
-
-    chat_name = pcm.who;
-
-    if (chatty_chat_is_im (chat))
-      chat_name = chatty_chat_get_chat_name (chat);
-
-    chatty_history_add_message (account->username, pcm.alias, chat_name,
-                                pcm.what, &uuid, pcm.flags, pcm.when, type);
-    }
+  if (!uuid)
+    uuid = g_uuid_string_random ();
 
   if (*message != '\0') {
 
@@ -923,10 +926,32 @@ chatty_conv_write_conversation (PurpleCo
       chatty_pp_chat_append_message (CHATTY_PP_CHAT (chat), chat_message);
     }
 
+    if (chat_message && pcm.who && !(flags & PURPLE_MESSAGE_SEND))
+      chatty_message_set_user_name (chat_message, pcm.who);
+
+    /*
+     * This is default fallback history handler.  Other plugins may
+     * intercept “conversation-write” and suppress it if they handle
+     * history on their own (eg. MAM).  If %PURPLE_MESSAGE_NO_LOG is
+     * set in @flags, it won't be saved to database.
+     */
+    if (!(pcm.flags & PURPLE_MESSAGE_NO_LOG) && chat_message)
+      chatty_history_add_message (chat, chat_message);
+
     chatty_chat_set_unread_count (chat, chatty_chat_get_unread_count (chat) + 1);
     gtk_sorter_changed (self->chat_sorter, GTK_SORTER_ORDER_TOTAL);
   }
 
+  if (chat) {
+    GListModel *messages;
+
+    messages = chatty_chat_get_messages (chat);
+
+    /* The first message was added, notify so that chat list in main window updates */
+    if (g_list_model_get_n_items (messages) == 1)
+      manager_update_protocols (self);
+  }
+
   g_free (pcm.who);
   g_free (pcm.what);
   g_free (pcm.alias);
@@ -1073,6 +1098,7 @@ manager_buddy_added_cb (PurpleBuddy   *p
                         ChattyManager *self)
 {
   g_autoptr(ChattyChat) chat = NULL;
+  PurpleConversation *conv;
   ChattyPpAccount *account;
   ChattyPpBuddy *buddy;
   ChattyContact *contact;
@@ -1096,7 +1122,19 @@ manager_buddy_added_cb (PurpleBuddy   *p
   contact = chatty_eds_find_by_number (self->chatty_eds, id);
   chatty_pp_buddy_set_contact (buddy, contact);
 
-  chat = (ChattyChat *)chatty_pp_chat_new_im_chat (pp_account, pp_buddy);
+  conv = purple_find_conversation_with_account (PURPLE_CONV_TYPE_IM,
+                                                pp_buddy->name,
+                                                pp_account);
+  if (conv)
+    chat = conv->ui_data;
+
+  if (chat) {
+    g_object_ref (chat);
+    chatty_pp_chat_set_purple_conv (CHATTY_PP_CHAT (chat), conv);
+  } else {
+    chat = (ChattyChat *)chatty_pp_chat_new_im_chat (pp_account, pp_buddy);
+  }
+
   chatty_history_get_messages_async (chatty_history_get_default (), chat, NULL, 1,
                                      manager_load_messages_cb,
                                      g_object_ref (self));
@@ -1342,6 +1380,10 @@ auto_join_chat_cb (gpointer data)
         prpl_info = PURPLE_PLUGIN_PROTOCOL_INFO(purple_find_prpl (purple_account_get_protocol_id (account)));
         components = purple_chat_get_components (chat);
         chat_name = prpl_info->get_chat_name(components);
+
+        if (!chat_name || !*chat_name)
+          continue;
+
         chatty_conv_add_history_since_component(components, account->username, chat_name);
 
         serv_join_chat (purple_account_get_connection (account),
@@ -1675,7 +1717,7 @@ chatty_manager_initialize_libpurple (Cha
                           purple_marshal_VOID__POINTER_POINTER_POINTER_UINT,
                           NULL, 4,
                           purple_value_new(PURPLE_TYPE_SUBTYPE,
-                                           PURPLE_SUBTYPE_ACCOUNT),
+                                           PURPLE_SUBTYPE_CONVERSATION),
                           purple_value_new (PURPLE_TYPE_BOXED,
                                             "PurpleConvMessage *"),
                           purple_value_new(PURPLE_TYPE_POINTER),
diff -pruN 0.1.17-1/src/chatty-message-row.c 0.2.0-1/src/chatty-message-row.c
--- 0.1.17-1/src/chatty-message-row.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-message-row.c	2020-11-27 09:44:20.000000000 +0000
@@ -193,7 +193,7 @@ chatty_message_row_class_init (ChattyMes
   object_class->dispose = chatty_message_row_dispose;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-message-row.ui");
   gtk_widget_class_bind_template_child (widget_class, ChattyMessageRow, revealer);
   gtk_widget_class_bind_template_child (widget_class, ChattyMessageRow, content_grid);
diff -pruN 0.1.17-1/src/chatty-phone-utils.cpp 0.2.0-1/src/chatty-phone-utils.cpp
--- 0.1.17-1/src/chatty-phone-utils.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/src/chatty-phone-utils.cpp	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,54 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*- */
+/* chatty-phone-utils.cpp
+ *
+ * Copyright (C) 2020 Purism SPC
+ *
+ * Author(s):
+ *   Mohammed Sadiq <sadiq@sadiqpk.org>
+ *
+ * SPDX-License-Identifier: GPL-3.0-or-later
+ */
+
+#define G_LOG_DOMAIN "chatty-phone-utils"
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <phonenumbers/phonenumberutil.h>
+
+#include "chatty-phone-utils.h"
+
+using i18n::phonenumbers::PhoneNumber;
+using i18n::phonenumbers::PhoneNumberUtil;
+
+
+gboolean
+chatty_phone_utils_is_valid (const char *number,
+                             const char *country_code)
+{
+  PhoneNumberUtil *util = PhoneNumberUtil::GetInstance ();
+  PhoneNumber phone_number;
+
+  if (!number || !*number ||
+      !country_code || strlen (country_code) != 2)
+    return FALSE;
+
+  if (util->Parse (number, country_code, &phone_number) == PhoneNumberUtil::NO_PARSING_ERROR)
+    return util->IsValidNumber (phone_number);
+
+  return FALSE;
+}
+
+gboolean
+chatty_phone_utils_is_possible (const char *number,
+                                const char *country_code)
+{
+  PhoneNumberUtil *util = PhoneNumberUtil::GetInstance ();
+
+  if (!number || !*number ||
+      !country_code || strlen (country_code) != 2)
+    return FALSE;
+
+  return util->IsPossibleNumberForString (number, country_code);
+}
diff -pruN 0.1.17-1/src/chatty-phone-utils.h 0.2.0-1/src/chatty-phone-utils.h
--- 0.1.17-1/src/chatty-phone-utils.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/src/chatty-phone-utils.h	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,23 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*- */
+/* chatty-phone-utils.h
+ *
+ * Copyright (C) 2020 Purism SPC
+ *
+ * Author(s):
+ *   Mohammed Sadiq <sadiq@sadiqpk.org>
+ *
+ * SPDX-License-Identifier: GPL-3.0-or-later
+ */
+
+#pragma once
+
+#include <glib.h>
+
+G_BEGIN_DECLS
+
+gboolean     chatty_phone_utils_is_valid      (const char *number,
+                                               const char *country_code);
+gboolean     chatty_phone_utils_is_possible   (const char *number,
+                                               const char *country_code);
+G_END_DECLS
+
diff -pruN 0.1.17-1/src/chatty-pp-chat.c 0.2.0-1/src/chatty-pp-chat.c
--- 0.1.17-1/src/chatty-pp-chat.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-pp-chat.c	2020-11-27 09:44:20.000000000 +0000
@@ -473,6 +473,18 @@ chatty_pp_chat_get_name (ChattyItem *ite
 
   g_assert (CHATTY_IS_PP_CHAT (self));
 
+  /* If available, return locally saved contact name for SMS chats */
+  if (self->buddy &&
+      chatty_item_get_protocols (CHATTY_ITEM (item)) == CHATTY_PROTOCOL_SMS) {
+    PurpleBlistNode *node;
+
+    node = PURPLE_BLIST_NODE (self->buddy);
+
+    if (node->ui_data &&
+        chatty_pp_buddy_get_contact (node->ui_data))
+      return chatty_item_get_name (node->ui_data);
+  }
+
   if (self->pp_chat)
     name = purple_chat_get_name (self->pp_chat);
   else if (self->buddy)
diff -pruN 0.1.17-1/src/chatty-utils.c 0.2.0-1/src/chatty-utils.c
--- 0.1.17-1/src/chatty-utils.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-utils.c	2020-11-27 09:44:20.000000000 +0000
@@ -9,55 +9,246 @@
 #include <glib/gi18n.h>
 #include "chatty-manager.h"
 #include "chatty-settings.h"
+#include "chatty-phone-utils.h"
 #include "chatty-utils.h"
 #include <libebook-contacts/libebook-contacts.h>
 #include <gdesktop-enums.h>
 
 
-static const char *avatar_colors[] = {
-  "E57373", "F06292", "BA68C8", "9575CD",
-  "7986CB", "64B5F6", "4FC3F7", "4DD0E1",
-  "4DB6AC", "81C784", "AED581", "DCE775",
-  "FFD54F", "FFB74D", "FF8A65", "A1887F"
-};
+#define DIGITS      "0123456789"
+#define ASCII_CAPS  "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+#define ASCII_SMALL "abcdefghijklmnopqrstuvwxyz"
+
+/*
+ * matrix_id_is_valid:
+ * @name: A string
+ * @prefix: The allowed prefix
+ *
+ * Check if @name is a valid username
+ * or channel name
+ *
+ * @prefix should be one of ‘#’ or ‘@’.
+ *
+ * See https://matrix.org/docs/spec/appendices#id12
+ */
+static gboolean
+matrix_id_is_valid (const char *name,
+                    char        prefix)
+{
+  guint len;
+
+  if (!name || !*name)
+    return FALSE;
+
+  if (prefix != '@' && prefix != '#')
+    return FALSE;
+
+  if (*(name + 1) == ':')
+    return FALSE;
+
+  if (prefix == '@' && *name != '@')
+    return FALSE;
+
+  /* Group name can have '#' or '!' (Group id) as prefix */
+  if (prefix == '#' && *name != '#' && *name != '!')
+    return FALSE;
 
+  len = strlen (name);
 
-char* 
-chatty_utils_check_phonenumber (const char *phone_number)
+  if (len > 255)
+    return FALSE;
+
+  if (strspn (name + 1, DIGITS ASCII_CAPS ASCII_SMALL ":._=/-") != len - 1)
+    return FALSE;
+
+  if (len >= 4 &&
+      *(name + len - 1) != ':' &&
+      !strchr (name + 1, prefix) &&
+      strchr (name, ':'))
+    return TRUE;
+
+  return FALSE;
+}
+
+char *
+chatty_utils_check_phonenumber (const char *phone_number,
+                                const char *country)
 {
-  ChattySettings *settings;
   EPhoneNumber      *number;
-  g_autofree char   *stripped = NULL;
+  g_autofree char   *raw = NULL;
+  char              *stripped;
   char              *result;
   g_autoptr(GError)  err = NULL;
 
+  g_debug ("%s number %s", G_STRLOC, phone_number);
+
   if (!phone_number || !*phone_number)
     return NULL;
 
-  stripped = g_uri_unescape_string (phone_number, NULL);
+  raw = g_uri_unescape_string (phone_number, NULL);
 
-  settings = chatty_settings_get_default ();
-  number = e_phone_number_from_string (stripped,
-                                       chatty_settings_get_country_iso_code (settings),
-                                       &err);
-
-  if (!number || !e_phone_number_is_supported ()) {
-    g_debug ("%s %s: %s", __func__, phone_number, err->message);
-
-    result = NULL;
-  } else {
-    if (g_strrstr (phone_number, "+")) {
-      result = e_phone_number_to_string (number, E_PHONE_NUMBER_FORMAT_E164);
-    } else {
-      result = e_phone_number_to_string (number, E_PHONE_NUMBER_FORMAT_NATIONAL);
-    }
+  if (g_str_has_prefix (raw, "sms:"))
+    stripped = raw + strlen ("sms:");
+  else
+    stripped = raw;
+
+  /* Skip sms:// */
+  while (*stripped == '/')
+    stripped++;
+
+  if (strspn (stripped, "+()- 0123456789") != strlen (stripped))
+    return NULL;
+
+  if (!e_phone_number_is_supported ()) {
+    g_warning ("evolution-data-server built without libphonenumber support");
+    return NULL;
+  }
+
+  number = e_phone_number_from_string (stripped, country, &err);
+
+  if (!number) {
+    g_debug ("Error parsing ‘%s’ for country ‘%s’: %s", phone_number, country, err->message);
+
+    return NULL;
   }
 
+  if (*phone_number != '+' &&
+      !chatty_phone_utils_is_valid (phone_number, country))
+    result = e_phone_number_to_string (number, E_PHONE_NUMBER_FORMAT_NATIONAL);
+  else
+    result = e_phone_number_to_string (number, E_PHONE_NUMBER_FORMAT_E164);
+
   e_phone_number_free (number);
 
   return result;
 }
 
+/**
+ * chatty_utils_username_is_valid:
+ * @name: A string
+ * @protocol: A #ChattyProtocol flag
+ *
+ * Check if @name is a valid username for the given
+ * @protocol(s). Please note that only rudimentary
+ * checks are done for the validation process.
+ *
+ * Currently, %CHATTY_PROTOCOL_XMPP, %CHATTY_PROTOCOL_SMS
+ * and %CHATTY_PROTOCOL_MATRIX or their combinations are
+ * supported for @protocol.
+ *
+ * Returns: A #ChattyProtocol with all valid protocols
+ * set.
+ */
+ChattyProtocol
+chatty_utils_username_is_valid (const char     *name,
+                                ChattyProtocol  protocol)
+{
+  ChattyProtocol valid = 0;
+  guint len;
+
+  if (!name)
+    return valid;
+
+  len = strlen (name);
+  if (len < 3)
+    return valid;
+
+  if (protocol & CHATTY_PROTOCOL_XMPP) {
+    const char *at_char, *at_char_end;
+
+    at_char = strchr (name, '@');
+    at_char_end = strrchr (name, '@');
+
+    /* Consider valid if @name has only one ‘@’ and @name
+     * doesn’t start nor end with a ‘@’
+     * See https://xmpp.org/rfcs/rfc3920.html#addressing
+     */
+    /* XXX: We are ignoring one valid case.  ie, domain alone
+     * or domain/resource */
+    if (at_char &&
+        /* Should not begin with ‘@’ */
+        *name != '@' &&
+        /* should not end with ‘@’ */
+        *(at_char + 1) &&
+        /* We require exact one ‘@’ */
+        at_char == at_char_end)
+      valid |= CHATTY_PROTOCOL_XMPP;
+  }
+
+  if (protocol & CHATTY_PROTOCOL_MATRIX) {
+    if (matrix_id_is_valid (name, '@'))
+      valid |= CHATTY_PROTOCOL_MATRIX;
+  }
+
+  if (protocol & CHATTY_PROTOCOL_TELEGRAM && *name == '+') {
+    /* country code doesn't matter as we use international format numbers */
+    if (chatty_phone_utils_is_valid (name, "US"))
+      valid |= CHATTY_PROTOCOL_TELEGRAM;
+  }
+
+  if (protocol & CHATTY_PROTOCOL_SMS && len < 20) {
+    const char *end;
+    guint end_len;
+
+    end = name;
+    if (*end == '+')
+      end++;
+
+    end_len = strspn (end, "0123456789- ()");
+
+    if (*name == '+')
+      end_len++;
+
+    if (end_len == len)
+      valid |= CHATTY_PROTOCOL_SMS;
+  }
+
+  return valid;
+}
+
+/**
+ * chatty_utils_groupname_is_valid:
+ * @name: A string
+ * @protocol: A #ChattyProtocol flag
+ *
+ * Check if @name is a valid group name for the given
+ * @protocol(s).  Please note that only rudimentary checks
+ * are done for the validation process.
+ *
+ * Currently %CHATTY_PROTOCOL_XMPP and %CHATTY_PROTOCOL_MATRIX
+ * or their combinations are supported for @protocol.
+ *
+ * Returns: A #ChattyProtocol with all valid protocols
+ * set.
+ */
+ChattyProtocol
+chatty_utils_groupname_is_valid (const char     *name,
+                                 ChattyProtocol  protocol)
+{
+  ChattyProtocol valid = 0;
+  guint len;
+
+  if (!name)
+    return valid;
+
+  len = strlen (name);
+  if (len < 3)
+    return valid;
+
+  if (protocol & CHATTY_PROTOCOL_XMPP) {
+    if (chatty_utils_username_is_valid (name, CHATTY_PROTOCOL_XMPP))
+      valid |= CHATTY_PROTOCOL_XMPP;
+  }
+
+  if (protocol & CHATTY_PROTOCOL_MATRIX) {
+    /* Consider valid if @name starts with ‘#’ and has only one
+     * ‘#’, has ‘:’, and has atleast 4 chars*/
+    if (matrix_id_is_valid (name, '#'))
+      valid |= CHATTY_PROTOCOL_MATRIX;
+  }
+
+  return valid;
+}
 
 char *
 chatty_utils_jabber_id_strip (const char *name)
@@ -234,20 +425,6 @@ chatty_utils_create_fingerprint_row (con
   return GTK_WIDGET(row);
 }
 
-const char *
-chatty_utils_get_color_for_str (const char *str)
-{
-  guint hash;
-
-  if (!str)
-    str = "";
-
-  hash = g_str_hash (str);
-
-  return avatar_colors[hash % G_N_ELEMENTS (avatar_colors)];
-}
-
-
 char *
 chatty_utils_get_human_time (time_t unix_time)
 {
@@ -328,3 +505,18 @@ chatty_utils_get_conv_blist_node (Purple
   }
   return node;
 }
+
+ChattyMsgDirection
+chatty_utils_direction_from_flag (PurpleMessageFlags flag)
+{
+  if (flag & PURPLE_MESSAGE_SYSTEM)
+    return CHATTY_DIRECTION_SYSTEM;
+
+  if (flag & PURPLE_MESSAGE_SEND)
+    return CHATTY_DIRECTION_OUT;
+
+  if (flag & PURPLE_MESSAGE_RECV)
+    return CHATTY_DIRECTION_IN;
+
+  g_return_val_if_reached (CHATTY_DIRECTION_UNKNOWN);
+}
diff -pruN 0.1.17-1/src/chatty-utils.h 0.2.0-1/src/chatty-utils.h
--- 0.1.17-1/src/chatty-utils.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-utils.h	2020-11-27 09:44:20.000000000 +0000
@@ -18,15 +18,20 @@
 #define SECONDS_PER_DAY    86400.0
 
 char *chatty_utils_jabber_id_strip (const char *name);
-char *chatty_utils_check_phonenumber (const char *phone_number);
+char *chatty_utils_check_phonenumber (const char *phone_number,
+                                      const char *country);
+ChattyProtocol chatty_utils_username_is_valid  (const char     *name,
+                                                ChattyProtocol  protocol);
+ChattyProtocol chatty_utils_groupname_is_valid (const char     *name,
+                                                ChattyProtocol  protocol);
 gboolean chatty_utils_get_item_position (GListModel *list,
                                          gpointer    item,
                                          guint      *position);
 gboolean chatty_utils_remove_list_item  (GListStore *store,
                                          gpointer    item);
 GtkWidget* chatty_utils_create_fingerprint_row (const char *fp, guint id);
-const char *chatty_utils_get_color_for_str (const char *str);
 char       *chatty_utils_get_human_time (time_t unix_time);
 PurpleBlistNode *chatty_utils_get_conv_blist_node (PurpleConversation *conv);
+ChattyMsgDirection   chatty_utils_direction_from_flag   (PurpleMessageFlags flag);
 
 #endif
diff -pruN 0.1.17-1/src/chatty-window.c 0.2.0-1/src/chatty-window.c
--- 0.1.17-1/src/chatty-window.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/chatty-window.c	2020-11-27 09:44:20.000000000 +0000
@@ -88,7 +88,6 @@ struct _ChattyWindow
 G_DEFINE_TYPE (ChattyWindow, chatty_window, GTK_TYPE_APPLICATION_WINDOW)
 
 
-static void chatty_update_header (ChattyWindow *self);
 static void chatty_window_show_new_muc_dialog (ChattyWindow *self);
 
 
@@ -214,7 +213,7 @@ window_chat_changed_cb (ChattyWindow *se
   model = chatty_manager_get_chat_list (self->manager);
   has_child = g_list_model_get_n_items (model) > 0;
 
-  gtk_widget_set_sensitive (self->header_sub_menu_button, has_child);
+  gtk_widget_set_sensitive (self->header_sub_menu_button, !!self->selected_item);
 
   /*
    * When the items are re-arranged, the selection will be lost.
@@ -308,7 +307,7 @@ window_chat_name_matches (ChattyItem   *
       return FALSE;
   }
 
-  if (hdy_leaflet_get_fold (HDY_LEAFLET (self->header_box)) == HDY_FOLD_FOLDED) {
+  if (hdy_leaflet_get_folded (HDY_LEAFLET (self->header_box))) {
     GListModel *message_list;
     guint n_items;
 
@@ -408,18 +407,6 @@ window_chat_row_activated_cb (GtkListBox
   chatty_window_open_item (self, self->selected_item);
 }
 
-
-static void
-header_visible_child_cb (GObject      *sender,
-                         GParamSpec   *pspec,
-                         ChattyWindow *self)
-{
-  g_assert (CHATTY_IS_WINDOW (self));
-
-  chatty_update_header (self);
-}
-
-
 static void
 window_search_changed_cb (ChattyWindow *self,
                           GtkEntry     *entry)
@@ -437,14 +424,14 @@ notify_fold_cb (GObject      *sender,
                 GParamSpec   *pspec,
                 ChattyWindow *self)
 {
-  HdyFold fold = hdy_leaflet_get_fold (HDY_LEAFLET (self->header_box));
+  gboolean folded = hdy_leaflet_get_folded (HDY_LEAFLET (self->header_box));
 
-  if (fold == HDY_FOLD_FOLDED)
+  if (folded)
     gtk_list_box_set_selection_mode (GTK_LIST_BOX (self->chats_listbox), GTK_SELECTION_NONE);
   else
     gtk_list_box_set_selection_mode (GTK_LIST_BOX (self->chats_listbox), GTK_SELECTION_SINGLE);
 
-  if (fold == HDY_FOLD_FOLDED) {
+  if (folded) {
     window_set_item (self, NULL);
     hdy_leaflet_set_visible_child_name (HDY_LEAFLET (self->content_box), "sidebar");
   } else if (self->selected_item) {
@@ -454,7 +441,6 @@ notify_fold_cb (GObject      *sender,
   }
 
   gtk_filter_changed (self->chat_filter, GTK_FILTER_CHANGE_DIFFERENT);
-  chatty_update_header (self);
 }
 
 
@@ -546,22 +532,6 @@ chatty_window_chat_list_select_first (Ch
   }
 }
 
-
-static void
-chatty_update_header (ChattyWindow *self)
-{
-  GtkWidget *header_child = hdy_leaflet_get_visible_child (HDY_LEAFLET (self->header_box));
-  HdyFold fold = hdy_leaflet_get_fold (HDY_LEAFLET (self->header_box));
-
-  g_assert (CHATTY_IS_WINDOW (self));
-  g_assert (header_child == NULL || GTK_IS_HEADER_BAR (header_child));
-
-  hdy_header_group_set_focus (HDY_HEADER_GROUP (self->header_group), 
-                              fold == HDY_FOLD_FOLDED ? 
-                              GTK_HEADER_BAR (header_child) : NULL);
-}
-
-
 static void
 window_delete_buddy_clicked_cb (ChattyWindow *self)
 {
@@ -685,14 +655,16 @@ window_add_contact_clicked_cb (ChattyWin
 
     who = purple_buddy_get_name (buddy);
 
-    number = chatty_utils_check_phonenumber (who);
+    number = chatty_utils_check_phonenumber (who, chatty_settings_get_country_iso_code (self->settings));
 
     if (number)
       contact = chatty_eds_find_by_number (chatty_eds, number);
 
-    if (contact)
+    if (!contact)
       chatty_dbus_gc_write_contact (who, number);
   }
+
+  gtk_widget_hide (self->menu_add_contact_button);
 }
 
 
@@ -715,7 +687,7 @@ window_add_in_contacts_clicked_cb (Chatt
   contact = purple_buddy_get_contact (buddy);
   alias = purple_contact_get_alias (contact);
 
-  number = chatty_utils_check_phonenumber (who);
+  number = chatty_utils_check_phonenumber (who, chatty_settings_get_country_iso_code (self->settings));
 
   chatty_dbus_gc_write_contact (alias, number);
 }
@@ -989,7 +961,7 @@ chatty_window_class_init (ChattyWindowCl
   widget_class->unmap = chatty_window_unmap;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-window.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyWindow, sub_header_label);
@@ -1033,7 +1005,6 @@ chatty_window_class_init (ChattyWindowCl
   gtk_widget_class_bind_template_callback (widget_class, window_add_in_contacts_clicked_cb);
   gtk_widget_class_bind_template_callback (widget_class, window_leave_chat_clicked_cb);
   gtk_widget_class_bind_template_callback (widget_class, window_delete_buddy_clicked_cb);
-  gtk_widget_class_bind_template_callback (widget_class, header_visible_child_cb);
   gtk_widget_class_bind_template_callback (widget_class, window_search_changed_cb);
   gtk_widget_class_bind_template_callback (widget_class, window_chat_row_activated_cb);
   gtk_widget_class_bind_template_callback (widget_class, chatty_window_show_new_muc_dialog);
@@ -1097,7 +1068,7 @@ chatty_window_set_uri (ChattyWindow *sel
   if (!purple_account_is_connected (account))
     return;
 
-  who = chatty_utils_check_phonenumber (uri);
+  who = chatty_utils_check_phonenumber (uri, chatty_settings_get_country_iso_code (self->settings));
 
   chatty_eds = chatty_manager_get_eds (self->manager);
   contact = chatty_eds_find_by_number (chatty_eds, who);
@@ -1107,6 +1078,19 @@ chatty_window_set_uri (ChattyWindow *sel
   else
     alias = who;
 
+  if (!who) {
+    GtkWidget *dialog;
+
+    dialog = gtk_message_dialog_new (GTK_WINDOW (self),
+                                     GTK_DIALOG_MODAL,
+                                     GTK_MESSAGE_WARNING,
+                                     GTK_BUTTONS_CLOSE,
+                                     _("“%s” is not a valid phone number"), uri);
+    gtk_dialog_run (GTK_DIALOG (dialog));
+    gtk_widget_destroy (dialog);
+
+    return;
+  }
   g_return_if_fail (who != NULL);
 
   buddy = purple_find_buddy (account, who);
diff -pruN 0.1.17-1/src/dialogs/chatty-muc-info-dialog.c 0.2.0-1/src/dialogs/chatty-muc-info-dialog.c
--- 0.1.17-1/src/dialogs/chatty-muc-info-dialog.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-muc-info-dialog.c	2020-11-27 09:44:20.000000000 +0000
@@ -16,13 +16,14 @@
 #include "chatty-icons.h"
 #include "chatty-list-row.h"
 #include "chatty-manager.h"
+#include "chatty-utils.h"
 #include "purple.h"
 #include "chatty-muc-info-dialog.h"
 
 
 struct _ChattyMucInfoDialog
 {
-  HdyDialog  parent_instance;
+  GtkDialog  parent_instance;
 
   GtkWidget *button_back;
   GtkWidget *button_invite_contact;
@@ -53,7 +54,7 @@ struct _ChattyMucInfoDialog
 };
 
 
-G_DEFINE_TYPE (ChattyMucInfoDialog, chatty_muc_info_dialog, HDY_TYPE_DIALOG)
+G_DEFINE_TYPE (ChattyMucInfoDialog, chatty_muc_info_dialog, GTK_TYPE_DIALOG)
 
 
 static void chatty_muc_set_topic (ChattyMucInfoDialog *self);
@@ -330,7 +331,7 @@ chatty_muc_info_dialog_class_init (Chatt
   GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-dialog-muc-info.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyMucInfoDialog, button_back);
@@ -369,10 +370,6 @@ static void
 chatty_muc_info_dialog_init (ChattyMucInfoDialog *self)
 {
   gtk_widget_init_template (GTK_WIDGET(self));
-
-  gtk_list_box_set_header_func (GTK_LIST_BOX(self->list_muc_settings),
-                                hdy_list_box_separator_header,
-                                NULL, NULL);
 }
 
 
diff -pruN 0.1.17-1/src/dialogs/chatty-muc-info-dialog.h 0.2.0-1/src/dialogs/chatty-muc-info-dialog.h
--- 0.1.17-1/src/dialogs/chatty-muc-info-dialog.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-muc-info-dialog.h	2020-11-27 09:44:20.000000000 +0000
@@ -7,13 +7,12 @@
 
 #pragma once
 
-#define HANDY_USE_UNSTABLE_API
 #include <handy.h>
 
 G_BEGIN_DECLS
 
 #define CHATTY_TYPE_MUC_INFO_DIALOG (chatty_muc_info_dialog_get_type())
-G_DECLARE_FINAL_TYPE (ChattyMucInfoDialog, chatty_muc_info_dialog, CHATTY, MUC_INFO_DIALOG, HdyDialog)
+G_DECLARE_FINAL_TYPE (ChattyMucInfoDialog, chatty_muc_info_dialog, CHATTY, MUC_INFO_DIALOG, GtkDialog)
 
 
 GtkWidget *chatty_muc_info_dialog_new      (GtkWindow           *parent_window);
diff -pruN 0.1.17-1/src/dialogs/chatty-new-chat-dialog.c 0.2.0-1/src/dialogs/chatty-new-chat-dialog.c
--- 0.1.17-1/src/dialogs/chatty-new-chat-dialog.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-new-chat-dialog.c	2020-11-27 09:44:20.000000000 +0000
@@ -38,7 +38,7 @@ static void chatty_new_chat_name_check (
 
 struct _ChattyNewChatDialog
 {
-  HdyDialog  parent_instance;
+  GtkDialog  parent_instance;
 
   GtkWidget *chats_listbox;
   GtkWidget *new_contact_row;
@@ -54,6 +54,10 @@ struct _ChattyNewChatDialog
   GtkWidget *add_in_contacts_button;
   GtkWidget *dummy_prefix_radio;
 
+  GtkWidget *contact_list_stack;
+  GtkWidget *contact_list_view;
+  GtkWidget *empty_search_view;
+
   GtkSliceListModel  *slice_model;
   GtkFilter *filter;
   char      *search_str;
@@ -70,7 +74,7 @@ struct _ChattyNewChatDialog
 };
 
 
-G_DEFINE_TYPE (ChattyNewChatDialog, chatty_new_chat_dialog, HDY_TYPE_DIALOG)
+G_DEFINE_TYPE (ChattyNewChatDialog, chatty_new_chat_dialog, GTK_TYPE_DIALOG)
 
 
 static gboolean
@@ -274,6 +278,11 @@ contact_search_entry_changed_cb (ChattyN
   account = purple_accounts_find ("SMS", "prpl-mm-sms");
   valid = valid && purple_account_is_connected (account);
   gtk_widget_set_visible (self->new_contact_row, valid);
+
+  if (valid || g_list_model_get_n_items (G_LIST_MODEL (self->slice_model)) > 0)
+    gtk_stack_set_visible_child (GTK_STACK (self->contact_list_stack), self->contact_list_view);
+  else
+    gtk_stack_set_visible_child (GTK_STACK (self->contact_list_stack), self->empty_search_view);
 }
 
 static void
@@ -411,7 +420,7 @@ chatty_new_chat_add_account_to_list (Cha
 
   g_return_if_fail (CHATTY_IS_NEW_CHAT_DIALOG (self));
 
-  row = hdy_action_row_new ();
+  row = HDY_ACTION_ROW (hdy_action_row_new ());
   g_object_set_data (G_OBJECT (row),
                      "row-account",
                      (gpointer)account);
@@ -441,7 +450,7 @@ chatty_new_chat_add_account_to_list (Cha
                      (gpointer)prefix_radio_button);
 
   hdy_action_row_add_prefix (row, GTK_WIDGET (prefix_radio_button ));
-  hdy_action_row_set_title (row, chatty_account_get_username (CHATTY_ACCOUNT (account)));
+  hdy_preferences_row_set_title (HDY_PREFERENCES_ROW (row), chatty_account_get_username (CHATTY_ACCOUNT (account)));
 
   gtk_container_add (GTK_CONTAINER (self->accounts_list), GTK_WIDGET (row));
 
@@ -554,7 +563,7 @@ chatty_new_chat_dialog_class_init (Chatt
   widget_class->show = chatty_new_chat_dialog_show;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-dialog-new-chat.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, new_chat_stack);
@@ -570,6 +579,10 @@ chatty_new_chat_dialog_class_init (Chatt
   gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, add_contact_button);
   gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, add_in_contacts_button);
 
+  gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, contact_list_stack);
+  gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, contact_list_view);
+  gtk_widget_class_bind_template_child (widget_class, ChattyNewChatDialog, empty_search_view);
+
   gtk_widget_class_bind_template_callback (widget_class, back_button_clicked_cb);
   gtk_widget_class_bind_template_callback (widget_class, edit_contact_button_clicked_cb);
   gtk_widget_class_bind_template_callback (widget_class, contact_stroll_edge_reached_cb);
@@ -592,10 +605,6 @@ chatty_new_chat_dialog_init (ChattyNewCh
   gtk_widget_init_template (GTK_WIDGET (self));
   self->cancellable = g_cancellable_new ();
 
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->accounts_list),
-                                hdy_list_box_separator_header,
-                                NULL, NULL);
-
   self->dummy_prefix_radio = gtk_radio_button_new_from_widget (GTK_RADIO_BUTTON (NULL));
 
   self->manager = g_object_ref (chatty_manager_get_default ());
diff -pruN 0.1.17-1/src/dialogs/chatty-new-chat-dialog.h 0.2.0-1/src/dialogs/chatty-new-chat-dialog.h
--- 0.1.17-1/src/dialogs/chatty-new-chat-dialog.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-new-chat-dialog.h	2020-11-27 09:44:20.000000000 +0000
@@ -7,7 +7,6 @@
 
 #pragma once
 
-#define HANDY_USE_UNSTABLE_API
 #include <handy.h>
 
 #include "users/chatty-item.h"
@@ -15,7 +14,7 @@
 G_BEGIN_DECLS
 
 #define CHATTY_TYPE_NEW_CHAT_DIALOG (chatty_new_chat_dialog_get_type())
-G_DECLARE_FINAL_TYPE (ChattyNewChatDialog, chatty_new_chat_dialog, CHATTY, NEW_CHAT_DIALOG, HdyDialog)
+G_DECLARE_FINAL_TYPE (ChattyNewChatDialog, chatty_new_chat_dialog, CHATTY, NEW_CHAT_DIALOG, GtkDialog)
 
 
 GtkWidget *chatty_new_chat_dialog_new (GtkWindow *parent_window);
diff -pruN 0.1.17-1/src/dialogs/chatty-new-muc-dialog.c 0.2.0-1/src/dialogs/chatty-new-muc-dialog.c
--- 0.1.17-1/src/dialogs/chatty-new-muc-dialog.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-new-muc-dialog.c	2020-11-27 09:44:20.000000000 +0000
@@ -26,7 +26,7 @@ static void chatty_new_muc_name_check (C
 
 struct _ChattyNewMucDialog
 {
-  HdyDialog  parent_instance;
+  GtkDialog  parent_instance;
 
   GtkWidget *accounts_list;
   GtkWidget *button_join_chat;
@@ -40,7 +40,7 @@ struct _ChattyNewMucDialog
 };
 
 
-G_DEFINE_TYPE (ChattyNewMucDialog, chatty_new_muc_dialog, HDY_TYPE_DIALOG)
+G_DEFINE_TYPE (ChattyNewMucDialog, chatty_new_muc_dialog, GTK_TYPE_DIALOG)
 
 
 static void
@@ -172,7 +172,7 @@ chatty_new_muc_add_account_to_list (Chat
 
   g_return_if_fail (CHATTY_IS_NEW_MUC_DIALOG(self));
 
-  row = hdy_action_row_new ();
+  row = HDY_ACTION_ROW (hdy_action_row_new ());
   g_object_set_data (G_OBJECT(row),
                      "row-account",
                      (gpointer) account);
@@ -200,7 +200,7 @@ chatty_new_muc_add_account_to_list (Chat
                      (gpointer)prefix_radio_button);
 
   hdy_action_row_add_prefix (row, GTK_WIDGET(prefix_radio_button ));
-  hdy_action_row_set_title (row, chatty_account_get_username (CHATTY_ACCOUNT (account)));
+  hdy_preferences_row_set_title (HDY_PREFERENCES_ROW (row), chatty_account_get_username (CHATTY_ACCOUNT (account)));
 
   gtk_container_add (GTK_CONTAINER(self->accounts_list), GTK_WIDGET(row));
 
@@ -246,7 +246,7 @@ chatty_new_muc_dialog_class_init (Chatty
   GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-dialog-join-muc.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyNewMucDialog, accounts_list);
@@ -267,10 +267,6 @@ chatty_new_muc_dialog_init (ChattyNewMuc
 {
   gtk_widget_init_template (GTK_WIDGET(self));
 
-  gtk_list_box_set_header_func (GTK_LIST_BOX(self->accounts_list),
-                                hdy_list_box_separator_header,
-                                NULL, NULL);
-
   self->dummy_prefix_radio = gtk_radio_button_new_from_widget (GTK_RADIO_BUTTON(NULL));
 
   chatty_new_muc_populate_account_list (self);
diff -pruN 0.1.17-1/src/dialogs/chatty-new-muc-dialog.h 0.2.0-1/src/dialogs/chatty-new-muc-dialog.h
--- 0.1.17-1/src/dialogs/chatty-new-muc-dialog.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-new-muc-dialog.h	2020-11-27 09:44:20.000000000 +0000
@@ -7,13 +7,12 @@
 
 #pragma once
 
-#define HANDY_USE_UNSTABLE_API
 #include <handy.h>
 
 G_BEGIN_DECLS
 
 #define CHATTY_TYPE_NEW_MUC_DIALOG (chatty_new_muc_dialog_get_type())
-G_DECLARE_FINAL_TYPE (ChattyNewMucDialog, chatty_new_muc_dialog, CHATTY, NEW_MUC_DIALOG, HdyDialog)
+G_DECLARE_FINAL_TYPE (ChattyNewMucDialog, chatty_new_muc_dialog, CHATTY, NEW_MUC_DIALOG, GtkDialog)
 
 
 GtkWidget *chatty_new_muc_dialog_new (GtkWindow *parent_window);
diff -pruN 0.1.17-1/src/dialogs/chatty-settings-dialog.c 0.2.0-1/src/dialogs/chatty-settings-dialog.c
--- 0.1.17-1/src/dialogs/chatty-settings-dialog.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-settings-dialog.c	2020-11-27 09:44:20.000000000 +0000
@@ -44,7 +44,7 @@
  * which was written by Andrea Schäfer. */
 struct _ChattySettingsDialog
 {
-  HdyDialog       parent_instance;
+  GtkDialog       parent_instance;
 
   GtkWidget      *add_button;
   GtkWidget      *save_button;
@@ -61,8 +61,8 @@ struct _ChattySettingsDialog
   GtkWidget      *password_entry;
   GtkWidget      *edit_password_button;
 
+  GtkWidget      *protocol_list_group;
   GtkWidget      *protocol_list;
-  GtkWidget      *protocol_title_label;
   GtkWidget      *xmpp_radio_button;
   GtkWidget      *matrix_row;
   GtkWidget      *matrix_radio_button;
@@ -95,7 +95,7 @@ struct _ChattySettingsDialog
   gboolean visible;
 };
 
-G_DEFINE_TYPE (ChattySettingsDialog, chatty_settings_dialog, HDY_TYPE_DIALOG)
+G_DEFINE_TYPE (ChattySettingsDialog, chatty_settings_dialog, GTK_TYPE_DIALOG)
 
 
 static void
@@ -130,6 +130,11 @@ get_fp_list_own_cb (int         err,
       }
     }
 
+    gtk_container_foreach (GTK_CONTAINER (self->fingerprint_list),
+                           (GtkCallback)gtk_widget_destroy, NULL);
+    gtk_container_foreach (GTK_CONTAINER (self->fingerprint_device_list),
+                           (GtkCallback)gtk_widget_destroy, NULL);
+
     for (curr_p = filtered_list; curr_p; curr_p = curr_p->next) {
       fp = (char *) g_hash_table_lookup(id_fp_table, curr_p->data);
 
@@ -316,12 +321,14 @@ settings_update_new_account_view (Chatty
   if (gtk_widget_get_visible (self->matrix_row) ||
       gtk_widget_get_visible (self->telegram_row))
     {
-      gtk_label_set_text (GTK_LABEL (self->protocol_title_label), _("Select Protocol"));
+      hdy_preferences_group_set_title (HDY_PREFERENCES_GROUP (self->protocol_list_group),
+                                       _("Select Protocol"));
       gtk_widget_show (self->protocol_list);
     }
   else
     {
-      gtk_label_set_text (GTK_LABEL (self->protocol_title_label), _("Add XMPP account"));
+      hdy_preferences_group_set_title (HDY_PREFERENCES_GROUP (self->protocol_list_group),
+                                       _("Add XMPP account"));
       gtk_widget_hide (self->protocol_list);
     }
 
@@ -469,17 +476,23 @@ settings_avatar_button_clicked_cb (Chatt
 }
 
 static void
-settings_account_id_changed_cb (ChattySettingsDialog *self,
-                                GtkEntry             *account_id_entry)
+settings_account_id_changed_cb (ChattySettingsDialog *self)
 {
   const gchar *id;
+  ChattyProtocol protocol;
 
   g_assert (CHATTY_IS_SETTINGS_DIALOG (self));
-  g_assert (GTK_IS_ENTRY (account_id_entry));
 
-  id = gtk_entry_get_text (account_id_entry);
+  id = gtk_entry_get_text (GTK_ENTRY (self->new_account_id_entry));
+
+  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (self->matrix_radio_button)))
+    protocol = CHATTY_PROTOCOL_MATRIX;
+  else if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (self->telegram_radio_button)))
+    protocol = CHATTY_PROTOCOL_TELEGRAM;
+  else
+    protocol = CHATTY_PROTOCOL_XMPP;
 
-  gtk_widget_set_sensitive (self->add_button, id && *id);
+  gtk_widget_set_sensitive (self->add_button, chatty_utils_username_is_valid (id, protocol));
 }
 
 static void
@@ -547,7 +560,10 @@ settings_protocol_changed_cb (ChattySett
   else if (button == self->matrix_radio_button)
     gtk_entry_set_text (GTK_ENTRY (self->server_url_entry), "https://chat.librem.one");
 
-  gtk_widget_grab_focus (self->account_id_entry);
+  gtk_widget_grab_focus (self->new_account_id_entry);
+
+  /* Force re-check if id is valid */
+  settings_account_id_changed_cb (self);
 }
 
 static GtkWidget *
@@ -558,7 +574,8 @@ chatty_account_row_new (ChattyAccount *a
   GtkWidget      *spinner;
   ChattyProtocol protocol;
 
-  row = hdy_action_row_new ();
+  row = HDY_ACTION_ROW (hdy_action_row_new ());
+  gtk_list_box_row_set_activatable (GTK_LIST_BOX_ROW (row), TRUE);
   gtk_widget_show (GTK_WIDGET (row));
   g_object_set_data (G_OBJECT(row),
                      "row-account",
@@ -593,9 +610,9 @@ chatty_account_row_new (ChattyAccount *a
                           account_enabled_switch, "active",
                           G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE);
 
-  hdy_action_row_set_title (row, chatty_account_get_username (CHATTY_ACCOUNT (account)));
+  hdy_preferences_row_set_title (HDY_PREFERENCES_ROW (row), chatty_account_get_username (CHATTY_ACCOUNT (account)));
   hdy_action_row_set_subtitle (row, chatty_account_get_protocol_name (CHATTY_ACCOUNT (account)));
-  hdy_action_row_add_action (row, account_enabled_switch);
+  gtk_container_add (GTK_CONTAINER (row), account_enabled_switch);
   hdy_action_row_set_activatable_widget (row, NULL);
 
   return GTK_WIDGET (row);
@@ -706,7 +723,7 @@ chatty_settings_dialog_class_init (Chatt
   object_class->finalize = chatty_settings_dialog_finalize;
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-settings-dialog.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, add_button);
@@ -724,8 +741,8 @@ chatty_settings_dialog_class_init (Chatt
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, password_entry);
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, edit_password_button);
 
+  gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, protocol_list_group);
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, protocol_list);
-  gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, protocol_title_label);
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, xmpp_radio_button);
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, matrix_row);
   gtk_widget_class_bind_template_child (widget_class, ChattySettingsDialog, matrix_radio_button);
@@ -778,18 +795,6 @@ chatty_settings_dialog_init (ChattySetti
 
   gtk_widget_init_template (GTK_WIDGET (self));
 
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->accounts_list_box),
-                                hdy_list_box_separator_header, NULL, NULL);
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->fingerprint_list),
-                                hdy_list_box_separator_header, NULL, NULL);
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->fingerprint_device_list),
-                                hdy_list_box_separator_header, NULL, NULL);
-
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->protocol_list),
-                                hdy_list_box_separator_header, NULL, NULL);
-  gtk_list_box_set_header_func (GTK_LIST_BOX (self->new_account_settings_list),
-                                hdy_list_box_separator_header, NULL, NULL);
-
   gtk_widget_set_visible (self->message_carbons_row,
                           chatty_manager_has_carbons_plugin (manager));
 }
diff -pruN 0.1.17-1/src/dialogs/chatty-settings-dialog.h 0.2.0-1/src/dialogs/chatty-settings-dialog.h
--- 0.1.17-1/src/dialogs/chatty-settings-dialog.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-settings-dialog.h	2020-11-27 09:44:20.000000000 +0000
@@ -24,13 +24,12 @@
 
 #pragma once
 
-#define HANDY_USE_UNSTABLE_API
 #include <handy.h>
 
 G_BEGIN_DECLS
 
 #define CHATTY_TYPE_SETTINGS_DIALOG (chatty_settings_dialog_get_type())
-G_DECLARE_FINAL_TYPE (ChattySettingsDialog, chatty_settings_dialog, CHATTY, SETTINGS_DIALOG, HdyDialog)
+G_DECLARE_FINAL_TYPE (ChattySettingsDialog, chatty_settings_dialog, CHATTY, SETTINGS_DIALOG, GtkDialog)
 
 GtkWidget *chatty_settings_dialog_new (GtkWindow *parent_window);
 
diff -pruN 0.1.17-1/src/dialogs/chatty-user-info-dialog.c 0.2.0-1/src/dialogs/chatty-user-info-dialog.c
--- 0.1.17-1/src/dialogs/chatty-user-info-dialog.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-user-info-dialog.c	2020-11-27 09:44:20.000000000 +0000
@@ -25,7 +25,7 @@
 
 struct _ChattyUserInfoDialog
 {
-  HdyDialog  parent_instance;
+  GtkDialog  parent_instance;
 
   GtkWidget *label_alias;
   GtkWidget *label_jid;
@@ -48,7 +48,7 @@ struct _ChattyUserInfoDialog
 };
 
 
-G_DEFINE_TYPE (ChattyUserInfoDialog, chatty_user_info_dialog, HDY_TYPE_DIALOG)
+G_DEFINE_TYPE (ChattyUserInfoDialog, chatty_user_info_dialog, GTK_TYPE_DIALOG)
 
 
 /* Copied from chatty-dialogs.c written by Andrea Schäfer <mosibasu@me.com> */
@@ -273,7 +273,7 @@ chatty_user_info_dialog_class_init (Chat
   GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
 
   gtk_widget_class_set_template_from_resource (widget_class,
-                                               "/sm/puri/chatty/"
+                                               "/sm/puri/Chatty/"
                                                "ui/chatty-dialog-user-info.ui");
 
   gtk_widget_class_bind_template_child (widget_class, ChattyUserInfoDialog, button_avatar);
@@ -300,14 +300,6 @@ static void
 chatty_user_info_dialog_init (ChattyUserInfoDialog *self)
 {
   gtk_widget_init_template (GTK_WIDGET(self));
-
-  gtk_list_box_set_header_func (GTK_LIST_BOX(self->listbox_fps),
-                                hdy_list_box_separator_header,
-                                NULL, NULL);
-
-  gtk_list_box_set_header_func (GTK_LIST_BOX(self->listbox_prefs),
-                                hdy_list_box_separator_header,
-                                NULL, NULL);
 }
 
 
diff -pruN 0.1.17-1/src/dialogs/chatty-user-info-dialog.h 0.2.0-1/src/dialogs/chatty-user-info-dialog.h
--- 0.1.17-1/src/dialogs/chatty-user-info-dialog.h	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/dialogs/chatty-user-info-dialog.h	2020-11-27 09:44:20.000000000 +0000
@@ -7,13 +7,12 @@
 
 #pragma once
 
-#define HANDY_USE_UNSTABLE_API
 #include <handy.h>
 
 G_BEGIN_DECLS
 
 #define CHATTY_TYPE_USER_INFO_DIALOG (chatty_user_info_dialog_get_type())
-G_DECLARE_FINAL_TYPE (ChattyUserInfoDialog, chatty_user_info_dialog, CHATTY, USER_INFO_DIALOG, HdyDialog)
+G_DECLARE_FINAL_TYPE (ChattyUserInfoDialog, chatty_user_info_dialog, CHATTY, USER_INFO_DIALOG, GtkDialog)
 
 
 GtkWidget *chatty_user_info_dialog_new      (GtkWindow            *parent_window);
diff -pruN 0.1.17-1/src/icons/eye-not-looking-symbolic.svg 0.2.0-1/src/icons/eye-not-looking-symbolic.svg
--- 0.1.17-1/src/icons/eye-not-looking-symbolic.svg	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/src/icons/eye-not-looking-symbolic.svg	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,3 @@
+<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16">
+    <path d="M13.98 1.99a1 1 0 0 0-.687.303l-.984.984A8 8 0 0 0 8 2 8 8 0 0 0 .262 8.01a8 8 0 0 0 2.943 4.37l-.912.913a1 1 0 1 0 1.414 1.414l11-11a1 1 0 0 0-.727-1.717zM8 4a4 4 0 0 1 2.611.974l-1.42 1.42A2 2 0 0 0 8 6a2 2 0 0 0-2 2 2 2 0 0 0 .396 1.19l-1.42 1.42A4 4 0 0 1 4 8a4 4 0 0 1 4-4zm7.03 2.209l-3.344 3.343a4 4 0 0 1-2.127 2.127l-2.28 2.28a8 8 0 0 0 .721.04 8 8 0 0 0 7.738-6.01 8 8 0 0 0-.709-1.78zm-7.53.79a.5.5 0 0 1 .5.5.5.5 0 0 1-.5.5.5.5 0 0 1-.5-.5.5.5 0 0 1 .5-.5z" fill="#2e3436"/>
+</svg>
\ No newline at end of file
diff -pruN 0.1.17-1/src/icons/eye-open-negative-filled-symbolic.svg 0.2.0-1/src/icons/eye-open-negative-filled-symbolic.svg
--- 0.1.17-1/src/icons/eye-open-negative-filled-symbolic.svg	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/src/icons/eye-open-negative-filled-symbolic.svg	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg xmlns:osb="http://www.openswatchbook.org/uri/2009/osb" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:cc="http://creativecommons.org/ns#" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:svg="http://www.w3.org/2000/svg" xmlns="http://www.w3.org/2000/svg" width="16" viewBox="0 0 16 16" version="1.1" id="svg7384" height="16">
+  <metadata id="metadata90">
+    <rdf:RDF>
+      <cc:Work rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type rdf:resource="http://purl.org/dc/dcmitype/StillImage"/>
+        <dc:title>Gnome Symbolic Icon Theme</dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <title id="title9167">Gnome Symbolic Icon Theme</title>
+  <defs id="defs7386">
+    <linearGradient osb:paint="solid" id="linearGradient7212">
+      <stop style="stop-color:#000000;stop-opacity:1;" offset="0" id="stop7214"/>
+    </linearGradient>
+  </defs>
+  <g transform="translate(-341.0002,-13.000323)" style="display:inline" id="layer9"/>
+  <g transform="translate(-100,-380.00032)" id="layer1"/>
+  <g transform="translate(-100,-380.00032)" style="display:inline" id="layer10">
+    <path d="m 108,382 a 8,8 0 0 0 -7.73828,6.00977 A 8,8 0 0 0 108,394 8,8 0 0 0 115.73828,387.99023 8,8 0 0 0 108,382 Z m 0,2 a 4,4 0 0 1 4,4 4,4 0 0 1 -4,4 4,4 0 0 1 -4,-4 4,4 0 0 1 4,-4 z" id="path2314" style="opacity:1;vector-effect:none;fill:#2e3436;fill-opacity:1;stroke:none;stroke-width:1.5;stroke-linecap:butt;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;marker:none;marker-start:none;marker-mid:none;marker-end:none;paint-order:normal"/>
+    <path id="path2318" d="m 110,388.00003 a 2,2 0 0 1 -2,2 2,2 0 0 1 -2,-2 2,2 0 0 1 2,-2 2,2 0 0 1 2,2 z" style="vector-effect:none;fill:#2e3436;fill-opacity:1;stroke:none;stroke-width:1;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"/>
+  </g>
+  <g transform="translate(-100,-380.00032)" id="g6387"/>
+  <g transform="translate(-100,-380.00032)" id="layer11"/>
+</svg>
\ No newline at end of file
diff -pruN 0.1.17-1/src/icons/ui/eye-not-looking-symbolic.svg 0.2.0-1/src/icons/ui/eye-not-looking-symbolic.svg
--- 0.1.17-1/src/icons/ui/eye-not-looking-symbolic.svg	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/icons/ui/eye-not-looking-symbolic.svg	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16">
-    <path d="M13.98 1.99a1 1 0 0 0-.687.303l-.984.984A8 8 0 0 0 8 2 8 8 0 0 0 .262 8.01a8 8 0 0 0 2.943 4.37l-.912.913a1 1 0 1 0 1.414 1.414l11-11a1 1 0 0 0-.727-1.717zM8 4a4 4 0 0 1 2.611.974l-1.42 1.42A2 2 0 0 0 8 6a2 2 0 0 0-2 2 2 2 0 0 0 .396 1.19l-1.42 1.42A4 4 0 0 1 4 8a4 4 0 0 1 4-4zm7.03 2.209l-3.344 3.343a4 4 0 0 1-2.127 2.127l-2.28 2.28a8 8 0 0 0 .721.04 8 8 0 0 0 7.738-6.01 8 8 0 0 0-.709-1.78zm-7.53.79a.5.5 0 0 1 .5.5.5.5 0 0 1-.5.5.5.5 0 0 1-.5-.5.5.5 0 0 1 .5-.5z" fill="#2e3436"/>
-</svg>
\ No newline at end of file
diff -pruN 0.1.17-1/src/icons/ui/eye-open-negative-filled-symbolic.svg 0.2.0-1/src/icons/ui/eye-open-negative-filled-symbolic.svg
--- 0.1.17-1/src/icons/ui/eye-open-negative-filled-symbolic.svg	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/icons/ui/eye-open-negative-filled-symbolic.svg	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<svg xmlns:osb="http://www.openswatchbook.org/uri/2009/osb" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:cc="http://creativecommons.org/ns#" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:svg="http://www.w3.org/2000/svg" xmlns="http://www.w3.org/2000/svg" width="16" viewBox="0 0 16 16" version="1.1" id="svg7384" height="16">
-  <metadata id="metadata90">
-    <rdf:RDF>
-      <cc:Work rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type rdf:resource="http://purl.org/dc/dcmitype/StillImage"/>
-        <dc:title>Gnome Symbolic Icon Theme</dc:title>
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <title id="title9167">Gnome Symbolic Icon Theme</title>
-  <defs id="defs7386">
-    <linearGradient osb:paint="solid" id="linearGradient7212">
-      <stop style="stop-color:#000000;stop-opacity:1;" offset="0" id="stop7214"/>
-    </linearGradient>
-  </defs>
-  <g transform="translate(-341.0002,-13.000323)" style="display:inline" id="layer9"/>
-  <g transform="translate(-100,-380.00032)" id="layer1"/>
-  <g transform="translate(-100,-380.00032)" style="display:inline" id="layer10">
-    <path d="m 108,382 a 8,8 0 0 0 -7.73828,6.00977 A 8,8 0 0 0 108,394 8,8 0 0 0 115.73828,387.99023 8,8 0 0 0 108,382 Z m 0,2 a 4,4 0 0 1 4,4 4,4 0 0 1 -4,4 4,4 0 0 1 -4,-4 4,4 0 0 1 4,-4 z" id="path2314" style="opacity:1;vector-effect:none;fill:#2e3436;fill-opacity:1;stroke:none;stroke-width:1.5;stroke-linecap:butt;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;marker:none;marker-start:none;marker-mid:none;marker-end:none;paint-order:normal"/>
-    <path id="path2318" d="m 110,388.00003 a 2,2 0 0 1 -2,2 2,2 0 0 1 -2,-2 2,2 0 0 1 2,-2 2,2 0 0 1 2,2 z" style="vector-effect:none;fill:#2e3436;fill-opacity:1;stroke:none;stroke-width:1;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"/>
-  </g>
-  <g transform="translate(-100,-380.00032)" id="g6387"/>
-  <g transform="translate(-100,-380.00032)" id="layer11"/>
-</svg>
\ No newline at end of file
diff -pruN 0.1.17-1/src/icons/ui/matrix-logo.svg 0.2.0-1/src/icons/ui/matrix-logo.svg
--- 0.1.17-1/src/icons/ui/matrix-logo.svg	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/icons/ui/matrix-logo.svg	1970-01-01 00:00:00.000000000 +0000
@@ -1,153 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<!-- Generator: Adobe Illustrator 13.0.0, SVG Export Plug-In . SVG Version: 6.00 Build 14576)  -->
-<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
-<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
-	 width="793.322px" height="340.809px" viewBox="0 0 793.322 340.809" enable-background="new 0 0 793.322 340.809"
-	 xml:space="preserve">
-<path opacity="0.5" fill="#FFFFFF" d="M34.004,340.809H2c-1.104,0-2-0.896-2-2V2c0-1.104,0.896-2,2-2h32.004c1.104,0,2,0.896,2,2
-	v7.71c0,1.104-0.896,2-2,2h-21.13v317.386h21.13c1.104,0,2,0.896,2,2.001v7.712C36.004,339.913,35.108,340.809,34.004,340.809
-	L34.004,340.809z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M10.875,9.711v321.386h23.13v7.711H1.999V2.001h32.006v7.71H10.875z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M252.402,233.711h-32.993c-1.104,0-2-0.896-2-2v-68.073c0-3.949-0.154-7.722-0.457-11.213
-	c-0.289-3.282-1.074-6.153-2.332-8.53c-1.204-2.276-3.017-4.119-5.384-5.476c-2.393-1.362-5.775-2.056-10.042-2.056
-	c-4.238,0-7.674,0.798-10.213,2.371c-2.565,1.596-4.604,3.701-6.053,6.258c-1.498,2.643-2.51,5.694-3.013,9.067
-	c-0.526,3.513-0.793,7.125-0.793,10.741v66.91c0,1.104-0.896,2-2,2h-32.991c-1.104,0-2-0.896-2-2v-67.373
-	c0-3.435-0.078-6.964-0.228-10.485c-0.148-3.251-0.767-6.278-1.841-8.995c-1.018-2.571-2.667-4.584-5.047-6.153
-	c-2.372-1.552-6.029-2.341-10.865-2.341c-1.372,0-3.265,0.328-5.629,0.976c-2.28,0.624-4.536,1.826-6.705,3.577
-	c-2.152,1.732-4.036,4.306-5.605,7.655c-1.569,3.356-2.367,7.877-2.367,13.438v69.701c0,1.104-0.895,2-2,2H68.857
-	c-1.104,0-2-0.896-2-2V111.594c0-1.104,0.896-1.999,2-1.999h31.13c1.104,0,2,0.896,2,1.999v11.007
-	c3.834-4.499,8.248-8.152,13.173-10.896c6.396-3.559,13.799-5.362,22.002-5.362c7.846,0,15.127,1.548,21.642,4.604
-	c5.794,2.722,10.424,7.26,13.791,13.52c3.449-4.362,7.833-8.306,13.071-11.752c6.422-4.228,14.102-6.371,22.824-6.371
-	c6.499,0,12.625,0.807,18.209,2.399c5.686,1.628,10.635,4.271,14.712,7.857c4.088,3.605,7.318,8.357,9.601,14.123
-	c2.25,5.719,3.391,12.649,3.391,20.604v80.384C254.402,232.815,253.507,233.711,252.402,233.711L252.402,233.711z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M99.988,111.595v16.264h0.463c4.338-6.191,9.563-10.998,15.684-14.406
-	c6.117-3.402,13.129-5.11,21.027-5.11c7.588,0,14.521,1.475,20.793,4.415c6.274,2.945,11.038,8.131,14.291,15.567
-	c3.56-5.265,8.4-9.913,14.521-13.94c6.117-4.025,13.358-6.042,21.724-6.042c6.351,0,12.234,0.776,17.66,2.325
-	c5.418,1.549,10.065,4.027,13.938,7.434c3.869,3.41,6.889,7.863,9.062,13.357c2.167,5.504,3.253,12.122,3.253,19.869v80.385H219.41
-	v-68.074c0-4.025-0.154-7.82-0.465-11.385c-0.313-3.56-1.161-6.656-2.555-9.293c-1.395-2.631-3.45-4.724-6.157-6.274
-	c-2.711-1.543-6.391-2.322-11.037-2.322s-8.403,0.896-11.269,2.671c-2.868,1.784-5.112,4.109-6.737,6.971
-	c-1.626,2.869-2.711,6.12-3.252,9.762c-0.545,3.638-0.814,7.318-0.814,11.035v66.91h-32.991v-67.375c0-3.562-0.081-7.087-0.23-10.57
-	c-0.158-3.487-0.814-6.7-1.978-9.645c-1.162-2.94-3.099-5.304-5.809-7.088c-2.711-1.775-6.699-2.671-11.965-2.671
-	c-1.551,0-3.603,0.349-6.156,1.048c-2.556,0.697-5.036,2.016-7.435,3.949c-2.404,1.938-4.454,4.726-6.158,8.363
-	c-1.705,3.642-2.556,8.402-2.556,14.287v69.701h-32.99V111.595H99.988z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M304.909,236.733c-5.883,0-11.46-0.729-16.574-2.163c-5.192-1.464-9.806-3.774-13.713-6.871
-	c-3.944-3.117-7.068-7.111-9.282-11.871c-2.205-4.733-3.324-10.412-3.324-16.876c0-7.13,1.293-13.117,3.846-17.797
-	c2.542-4.674,5.877-8.464,9.912-11.263c3.97-2.752,8.556-4.842,13.63-6.209c4.901-1.322,9.937-2.394,14.961-3.184
-	c4.986-0.775,9.949-1.404,14.754-1.872c4.679-0.452,8.88-1.139,12.489-2.039c3.412-0.854,6.118-2.09,8.042-3.672
-	c1.666-1.37,2.416-3.384,2.292-6.151c-0.002-3.289-0.502-5.816-1.492-7.595c-0.998-1.798-2.283-3.15-3.927-4.138
-	c-1.703-1.02-3.725-1.713-6.012-2.062c-2.47-0.37-5.146-0.557-7.947-0.557c-6.034,0-10.789,1.271-14.135,3.783
-	c-3.233,2.424-5.155,6.64-5.714,12.527c-0.098,1.026-0.961,1.812-1.992,1.812h-32.992c-0.552,0-1.079-0.229-1.457-0.629
-	c-0.376-0.402-0.572-0.941-0.54-1.491c0.485-8.073,2.55-14.894,6.142-20.272c3.548-5.331,8.147-9.682,13.661-12.931
-	c5.424-3.191,11.612-5.498,18.392-6.857c6.684-1.335,13.5-2.013,20.26-2.013c6.096,0,12.365,0.437,18.626,1.296
-	c6.377,0.88,12.285,2.622,17.562,5.177c5.376,2.604,9.845,6.29,13.282,10.951c3.498,4.744,5.271,11.048,5.271,18.731v62.494
-	c0,5.307,0.306,10.462,0.915,15.319c0.576,4.64,1.572,8.116,2.963,10.338c0.385,0.616,0.407,1.395,0.055,2.031
-	c-0.353,0.635-1.022,1.03-1.75,1.03h-33.457c-0.861,0-1.624-0.55-1.898-1.367c-0.646-1.941-1.176-3.939-1.572-5.936
-	c-0.141-0.696-0.267-1.402-0.38-2.12c-4.825,4.184-10.349,7.24-16.474,9.105C320.033,235.609,312.489,236.733,304.909,236.733
-	L304.909,236.733z M341.941,176.661c-0.809,0.409-1.676,0.768-2.596,1.074c-2.161,0.72-4.511,1.326-6.988,1.807
-	c-2.442,0.475-5.033,0.872-7.699,1.186c-2.631,0.311-5.251,0.697-7.784,1.146c-2.329,0.433-4.705,1.035-7.051,1.792
-	c-2.194,0.711-4.114,1.667-5.699,2.842c-1.531,1.128-2.785,2.587-3.731,4.335c-0.917,1.709-1.385,3.97-1.385,6.719
-	c0,2.598,0.465,4.778,1.385,6.481c0.928,1.722,2.142,3.035,3.716,4.018c1.644,1.026,3.601,1.757,5.816,2.17
-	c2.344,0.439,4.799,0.663,7.297,0.663c6.105,0,10.836-0.996,14.063-2.961c3.244-1.973,5.666-4.349,7.199-7.062
-	c1.568-2.78,2.542-5.62,2.892-8.436c0.376-3.019,0.565-5.436,0.565-7.187V176.661L341.941,176.661z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M273.544,129.255c3.405-5.113,7.744-9.215,13.012-12.316
-	c5.264-3.097,11.186-5.303,17.771-6.621c6.582-1.315,13.205-1.976,19.865-1.976c6.042,0,12.158,0.428,18.354,1.277
-	c6.195,0.855,11.85,2.522,16.962,4.997c5.111,2.477,9.292,5.926,12.546,10.338c3.253,4.414,4.879,10.262,4.879,17.543v62.494
-	c0,5.428,0.31,10.611,0.931,15.567c0.615,4.959,1.701,8.676,3.251,11.153H347.66c-0.621-1.86-1.126-3.755-1.511-5.693
-	c-0.39-1.933-0.661-3.908-0.813-5.923c-5.267,5.422-11.465,9.217-18.585,11.386c-7.127,2.163-14.407,3.251-21.842,3.251
-	c-5.733,0-11.077-0.698-16.033-2.09c-4.958-1.395-9.293-3.562-13.01-6.51c-3.718-2.938-6.622-6.656-8.713-11.147
-	s-3.138-9.84-3.138-16.033c0-6.813,1.199-12.43,3.604-16.84c2.399-4.417,5.495-7.939,9.295-10.575
-	c3.793-2.632,8.129-4.607,13.01-5.923c4.878-1.315,9.795-2.358,14.752-3.137c4.957-0.772,9.835-1.393,14.638-1.857
-	c4.801-0.466,9.062-1.164,12.779-2.093c3.718-0.929,6.658-2.282,8.829-4.065c2.165-1.781,3.172-4.375,3.02-7.785
-	c0-3.56-0.58-6.389-1.742-8.479c-1.161-2.09-2.711-3.719-4.646-4.88c-1.937-1.161-4.183-1.936-6.737-2.325
-	c-2.557-0.382-5.309-0.58-8.248-0.58c-6.506,0-11.617,1.395-15.335,4.183c-3.716,2.788-5.889,7.437-6.506,13.94h-32.991
-	C268.199,140.794,270.132,134.363,273.544,129.255z M338.713,175.838c-2.09,0.696-4.337,1.275-6.736,1.741
-	c-2.402,0.465-4.918,0.853-7.551,1.161c-2.635,0.313-5.268,0.698-7.899,1.163c-2.48,0.461-4.919,1.086-7.317,1.857
-	c-2.404,0.779-4.495,1.822-6.274,3.138c-1.784,1.317-3.216,2.985-4.3,4.994c-1.085,2.014-1.626,4.571-1.626,7.668
-	c0,2.94,0.541,5.422,1.626,7.431c1.084,2.017,2.558,3.604,4.416,4.765s4.025,1.976,6.507,2.438c2.475,0.466,5.031,0.698,7.665,0.698
-	c6.505,0,11.537-1.082,15.103-3.253c3.561-2.166,6.192-4.762,7.899-7.785c1.702-3.019,2.749-6.072,3.137-9.174
-	c0.384-3.097,0.58-5.576,0.58-7.434v-12.316C342.547,174.173,340.805,175.14,338.713,175.838z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M444.542,234.874c-5.187,0-10.173-0.361-14.823-1.069c-4.802-0.732-9.104-2.183-12.779-4.313
-	c-3.789-2.185-6.821-5.341-9.006-9.375c-2.163-3.986-3.26-9.232-3.26-15.59v-68.859h-17.981c-1.104,0-2-0.896-2-1.999v-22.073
-	c0-1.104,0.896-1.999,2-1.999h17.981V75.582c0-1.104,0.896-2,2-2h32.992c1.104,0,2,0.896,2,2v34.014h22.162c1.104,0,2,0.896,2,1.999
-	v22.073c0,1.104-0.896,1.999-2,1.999h-22.162v57.479c0,6.229,1.198,8.731,2.202,9.733c1.004,1.007,3.506,2.205,9.738,2.205
-	c1.804,0,3.542-0.076,5.161-0.225c1.604-0.144,3.174-0.367,4.669-0.665c0.13-0.026,0.261-0.039,0.391-0.039
-	c0.458,0,0.907,0.159,1.27,0.454c0.463,0.379,0.73,0.946,0.73,1.546v25.555c0,0.979-0.707,1.813-1.672,1.974
-	c-2.834,0.472-6.041,0.794-9.527,0.957C451.015,234.798,447.718,234.874,444.542,234.874L444.542,234.874z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M463.825,111.595v22.072h-24.161v59.479c0,5.573,0.928,9.292,2.788,11.149
-	c1.856,1.859,5.576,2.788,11.152,2.788c1.859,0,3.638-0.076,5.343-0.232c1.703-0.152,3.33-0.388,4.878-0.696v25.557
-	c-2.788,0.465-5.887,0.773-9.293,0.931c-3.407,0.149-6.737,0.23-9.99,0.23c-5.111,0-9.953-0.35-14.521-1.048
-	c-4.571-0.695-8.597-2.047-12.081-4.063c-3.486-2.011-6.236-4.88-8.248-8.597c-2.016-3.714-3.021-8.595-3.021-14.639v-70.859h-19.98
-	v-22.072h19.98V75.583h32.992v36.012H463.825z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M512.613,233.711h-32.991c-1.104,0-2-0.896-2-2V111.594c0-1.104,0.896-1.999,2-1.999h31.366
-	c1.104,0,2,0.896,2,1.999v15.069c0.967-1.516,2.034-2.978,3.199-4.382c2.754-3.312,5.949-6.182,9.496-8.522
-	c3.545-2.332,7.385-4.169,11.415-5.462c4.056-1.298,8.327-1.954,12.691-1.954c2.341,0,4.953,0.418,7.766,1.243
-	c0.852,0.25,1.437,1.032,1.437,1.92v30.67c0,0.6-0.269,1.167-0.732,1.547c-0.361,0.296-0.808,0.452-1.265,0.452
-	c-0.133,0-0.265-0.013-0.398-0.039c-1.484-0.3-3.299-0.565-5.392-0.787c-2.098-0.224-4.136-0.339-6.062-0.339
-	c-5.706,0-10.572,0.95-14.467,2.823c-3.862,1.86-7.012,4.428-9.361,7.629c-2.389,3.263-4.115,7.12-5.127,11.47
-	c-1.043,4.479-1.574,9.409-1.574,14.647v54.132C514.613,232.815,513.717,233.711,512.613,233.711L512.613,233.711z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M510.988,111.595V133.9h0.465c1.546-3.72,3.636-7.163,6.272-10.341
-	c2.634-3.172,5.652-5.885,9.06-8.131c3.405-2.242,7.047-3.985,10.923-5.228c3.868-1.237,7.898-1.859,12.081-1.859
-	c2.168,0,4.566,0.39,7.202,1.163v30.67c-1.551-0.312-3.41-0.584-5.576-0.814c-2.17-0.233-4.26-0.35-6.274-0.35
-	c-6.041,0-11.152,1.01-15.332,3.021c-4.182,2.014-7.55,4.761-10.107,8.247c-2.555,3.487-4.379,7.55-5.462,12.198
-	c-1.083,4.645-1.625,9.682-1.625,15.102v54.133h-32.991V111.595H510.988z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M603.923,233.711H570.93c-1.104,0-2-0.896-2-2V111.594c0-1.104,0.896-1.999,2-1.999h32.994
-	c1.104,0,2,0.896,2,1.999v120.117C605.923,232.815,605.027,233.711,603.923,233.711L603.923,233.711z M603.923,95.006H570.93
-	c-1.104,0-2-0.896-2-1.999V65.825c0-1.104,0.896-2,2-2h32.994c1.104,0,2,0.896,2,2v27.182
-	C605.923,94.11,605.027,95.006,603.923,95.006L603.923,95.006z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M570.93,93.007V65.824h32.994v27.183H570.93z M603.924,111.595v120.117H570.93V111.595
-	H603.924z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M742.163,233.711h-37.64c-0.671,0-1.297-0.335-1.667-0.896l-23.426-35.352l-23.426,35.352
-	c-0.369,0.561-0.995,0.896-1.667,0.896h-36.938c-0.741,0-1.424-0.411-1.77-1.067c-0.345-0.654-0.3-1.449,0.118-2.061l42.435-62.055
-	l-38.71-55.793c-0.424-0.613-0.474-1.408-0.128-2.069c0.343-0.658,1.028-1.071,1.771-1.071h37.636c0.665,0,1.287,0.33,1.658,0.882
-	l19.477,28.893l19.255-28.884c0.372-0.556,0.996-0.891,1.665-0.891h36.475c0.746,0,1.43,0.415,1.776,1.078
-	c0.343,0.66,0.289,1.46-0.139,2.071l-38.69,55.082l43.578,62.744c0.424,0.61,0.474,1.408,0.128,2.066
-	C743.591,233.298,742.908,233.711,742.163,233.711L742.163,233.711z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M621.115,111.595h37.637l21.144,31.365l20.911-31.365h36.476l-39.496,56.226l44.377,63.892
-	h-37.64l-25.093-37.87l-25.094,37.87h-36.938l43.213-63.193L621.115,111.595z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M791.322,340.809h-32.008c-1.105,0-2-0.896-2-2v-7.712c0-1.105,0.896-2.001,2-2.001h21.13
-	V11.71h-21.13c-1.105,0-2-0.896-2-2V2c0-1.104,0.896-2,2-2h32.008c1.104,0,2,0.896,2,2v336.809
-	C793.322,339.913,792.426,340.809,791.322,340.809L791.322,340.809z"/>
-<path opacity="0.5" fill="#FFFFFF" d="M782.443,331.097V9.711h-23.13v-7.71h32.008v336.807h-32.008v-7.711H782.443z"/>
-<path d="M10.875,9.711v321.386h23.13v7.711H1.999V2.001h32.006v7.71H10.875z"/>
-<path d="M99.988,111.595v16.264h0.463c4.338-6.191,9.563-10.998,15.684-14.406c6.117-3.402,13.129-5.11,21.027-5.11
-	c7.588,0,14.521,1.475,20.793,4.415c6.274,2.945,11.038,8.131,14.291,15.567c3.56-5.265,8.4-9.913,14.521-13.94
-	c6.117-4.025,13.358-6.042,21.724-6.042c6.351,0,12.234,0.776,17.66,2.325c5.418,1.549,10.065,4.027,13.938,7.434
-	c3.869,3.41,6.889,7.863,9.062,13.357c2.167,5.504,3.253,12.122,3.253,19.869v80.385H219.41v-68.074
-	c0-4.025-0.154-7.82-0.465-11.385c-0.313-3.56-1.161-6.656-2.555-9.293c-1.395-2.631-3.45-4.724-6.157-6.274
-	c-2.711-1.543-6.391-2.322-11.037-2.322s-8.403,0.896-11.269,2.671c-2.868,1.784-5.112,4.109-6.737,6.971
-	c-1.626,2.869-2.711,6.12-3.252,9.762c-0.545,3.638-0.814,7.318-0.814,11.035v66.91h-32.991v-67.375c0-3.562-0.081-7.087-0.23-10.57
-	c-0.158-3.487-0.814-6.7-1.978-9.645c-1.162-2.94-3.099-5.304-5.809-7.088c-2.711-1.775-6.699-2.671-11.965-2.671
-	c-1.551,0-3.603,0.349-6.156,1.048c-2.556,0.697-5.036,2.016-7.435,3.949c-2.404,1.938-4.454,4.726-6.158,8.363
-	c-1.705,3.642-2.556,8.402-2.556,14.287v69.701h-32.99V111.595H99.988z"/>
-<path d="M273.544,129.255c3.405-5.113,7.744-9.215,13.012-12.316c5.264-3.097,11.186-5.303,17.771-6.621
-	c6.582-1.315,13.205-1.976,19.865-1.976c6.042,0,12.158,0.428,18.354,1.277c6.195,0.855,11.85,2.522,16.962,4.997
-	c5.111,2.477,9.292,5.926,12.546,10.338c3.253,4.414,4.879,10.262,4.879,17.543v62.494c0,5.428,0.31,10.611,0.931,15.567
-	c0.615,4.959,1.701,8.676,3.251,11.153H347.66c-0.621-1.86-1.126-3.755-1.511-5.693c-0.39-1.933-0.661-3.908-0.813-5.923
-	c-5.267,5.422-11.465,9.217-18.585,11.386c-7.127,2.163-14.407,3.251-21.842,3.251c-5.733,0-11.077-0.698-16.033-2.09
-	c-4.958-1.395-9.293-3.562-13.01-6.51c-3.718-2.938-6.622-6.656-8.713-11.147s-3.138-9.84-3.138-16.033
-	c0-6.813,1.199-12.43,3.604-16.84c2.399-4.417,5.495-7.939,9.295-10.575c3.793-2.632,8.129-4.607,13.01-5.923
-	c4.878-1.315,9.795-2.358,14.752-3.137c4.957-0.772,9.835-1.393,14.638-1.857c4.801-0.466,9.062-1.164,12.779-2.093
-	c3.718-0.929,6.658-2.282,8.829-4.065c2.165-1.781,3.172-4.375,3.02-7.785c0-3.56-0.58-6.389-1.742-8.479
-	c-1.161-2.09-2.711-3.719-4.646-4.88c-1.937-1.161-4.183-1.936-6.737-2.325c-2.557-0.382-5.309-0.58-8.248-0.58
-	c-6.506,0-11.617,1.395-15.335,4.183c-3.716,2.788-5.889,7.437-6.506,13.94h-32.991
-	C268.199,140.794,270.132,134.363,273.544,129.255z M338.713,175.838c-2.09,0.696-4.337,1.275-6.736,1.741
-	c-2.402,0.465-4.918,0.853-7.551,1.161c-2.635,0.313-5.268,0.698-7.899,1.163c-2.48,0.461-4.919,1.086-7.317,1.857
-	c-2.404,0.779-4.495,1.822-6.274,3.138c-1.784,1.317-3.216,2.985-4.3,4.994c-1.085,2.014-1.626,4.571-1.626,7.668
-	c0,2.94,0.541,5.422,1.626,7.431c1.084,2.017,2.558,3.604,4.416,4.765s4.025,1.976,6.507,2.438c2.475,0.466,5.031,0.698,7.665,0.698
-	c6.505,0,11.537-1.082,15.103-3.253c3.561-2.166,6.192-4.762,7.899-7.785c1.702-3.019,2.749-6.072,3.137-9.174
-	c0.384-3.097,0.58-5.576,0.58-7.434v-12.316C342.547,174.173,340.805,175.14,338.713,175.838z"/>
-<path d="M463.825,111.595v22.072h-24.161v59.479c0,5.573,0.928,9.292,2.788,11.149c1.856,1.859,5.576,2.788,11.152,2.788
-	c1.859,0,3.638-0.076,5.343-0.232c1.703-0.152,3.33-0.388,4.878-0.696v25.557c-2.788,0.465-5.887,0.773-9.293,0.931
-	c-3.407,0.149-6.737,0.23-9.99,0.23c-5.111,0-9.953-0.35-14.521-1.048c-4.571-0.695-8.597-2.047-12.081-4.063
-	c-3.486-2.011-6.236-4.88-8.248-8.597c-2.016-3.714-3.021-8.595-3.021-14.639v-70.859h-19.98v-22.072h19.98V75.583h32.992v36.012
-	H463.825z"/>
-<path d="M510.988,111.595V133.9h0.465c1.546-3.72,3.636-7.163,6.272-10.341c2.634-3.172,5.652-5.885,9.06-8.131
-	c3.405-2.242,7.047-3.985,10.923-5.228c3.868-1.237,7.898-1.859,12.081-1.859c2.168,0,4.566,0.39,7.202,1.163v30.67
-	c-1.551-0.312-3.41-0.584-5.576-0.814c-2.17-0.233-4.26-0.35-6.274-0.35c-6.041,0-11.152,1.01-15.332,3.021
-	c-4.182,2.014-7.55,4.761-10.107,8.247c-2.555,3.487-4.379,7.55-5.462,12.198c-1.083,4.645-1.625,9.682-1.625,15.102v54.133h-32.991
-	V111.595H510.988z"/>
-<path d="M570.93,93.007V65.824h32.994v27.183H570.93z M603.924,111.595v120.117H570.93V111.595H603.924z"/>
-<path d="M621.115,111.595h37.637l21.144,31.365l20.911-31.365h36.476l-39.496,56.226l44.377,63.892h-37.64l-25.093-37.87
-	l-25.094,37.87h-36.938l43.213-63.193L621.115,111.595z"/>
-<path d="M782.443,331.097V9.711h-23.13v-7.71h32.008v336.807h-32.008v-7.711H782.443z"/>
-</svg>
diff -pruN 0.1.17-1/src/icons/ui/send-symbolic.svg 0.2.0-1/src/icons/ui/send-symbolic.svg
--- 0.1.17-1/src/icons/ui/send-symbolic.svg	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/icons/ui/send-symbolic.svg	1970-01-01 00:00:00.000000000 +0000
@@ -1,104 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<svg
-   xmlns:osb="http://www.openswatchbook.org/uri/2009/osb"
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://creativecommons.org/ns#"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="16"
-   version="1.1"
-   id="svg7384"
-   height="16"
-   sodipodi:docname="send-symbolic.svg"
-   inkscape:version="0.92.3 (2405546, 2018-03-11)">
-  <sodipodi:namedview
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1"
-     objecttolerance="10"
-     gridtolerance="10"
-     guidetolerance="10"
-     inkscape:pageopacity="0"
-     inkscape:pageshadow="2"
-     inkscape:window-width="1920"
-     inkscape:window-height="1016"
-     id="namedview16"
-     showgrid="true"
-     inkscape:zoom="10.429825"
-     inkscape:cx="18.893512"
-     inkscape:cy="13.56938"
-     inkscape:window-x="1600"
-     inkscape:window-y="27"
-     inkscape:window-maximized="1"
-     inkscape:current-layer="g876"
-     inkscape:snap-page="true"
-     inkscape:object-paths="true"
-     inkscape:snap-intersection-paths="true"
-     inkscape:snap-bbox="true"
-     inkscape:bbox-paths="true"
-     inkscape:snap-bbox-edge-midpoints="true"
-     inkscape:snap-bbox-midpoints="true"
-     inkscape:bbox-nodes="true"
-     inkscape:snap-nodes="false">
-    <inkscape:grid
-       type="xygrid"
-       id="grid825" />
-  </sodipodi:namedview>
-  <metadata
-     id="metadata90">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-        <dc:title>Gnome Symbolic Icon Theme</dc:title>
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <title
-     id="title9167">Gnome Symbolic Icon Theme</title>
-  <defs
-     id="defs7386">
-    <linearGradient
-       osb:paint="solid"
-       id="linearGradient7212">
-      <stop
-         style="stop-color:#000000;stop-opacity:1;"
-         offset="0"
-         id="stop7214" />
-    </linearGradient>
-  </defs>
-  <g
-     transform="translate(-323.0002,125)"
-     style="display:inline"
-     id="layer9">
-    <g
-       transform="translate(311.00017,-893)"
-       id="g876"
-       style="enable-background:new">
-      <rect
-         inkscape:export-ydpi="90"
-         inkscape:export-xdpi="90"
-         inkscape:export-filename="/home/lapo.fedora/SparkleShare/gnome-mockups/content selection/content-selection.png"
-         ry="3"
-         rx="3"
-         y="760.17792"
-         x="-64.025452"
-         height="33.000122"
-         width="33"
-         id="rect19980"
-         style="color:#000000;display:inline;overflow:visible;visibility:visible;fill:#4a90d9;fill-opacity:1;fill-rule:nonzero;stroke:#1c5288;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;marker:none;enable-background:accumulate"
-         transform="scale(-1,1)" />
-      <path
-         style="fill:#241f31;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-         d="m 12.999904,769 14.000126,7.00002 -14.000126,6.99999 v -6 L 22.000471,776.00002 12.999904,775 Z"
-         id="path20012"
-         inkscape:connector-curvature="0"
-         sodipodi:nodetypes="ccccccc" />
-    </g>
-  </g>
-</svg>
Binary files 0.1.17-1/src/icons/ui/telegram-logo.png and 0.2.0-1/src/icons/ui/telegram-logo.png differ
diff -pruN 0.1.17-1/src/icons/ui/xmpp-logo.svg 0.2.0-1/src/icons/ui/xmpp-logo.svg
--- 0.1.17-1/src/icons/ui/xmpp-logo.svg	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/icons/ui/xmpp-logo.svg	1970-01-01 00:00:00.000000000 +0000
@@ -1,25 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Generator: Adobe Illustrator 13.0.2, SVG Export Plug-In . SVG Version: 6.00 Build 14948)  -->
-<!DOCTYPE svg  PUBLIC '-//W3C//DTD SVG 1.1//EN'  'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd'>
-<svg id="Layer_1" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" height="181.44px" viewBox="0 0 176.486 181.437" width="176.49px" version="1.1" y="0px" x="0px" xmlns:xlink="http://www.w3.org/1999/xlink" enable-background="new 0 0 176.486 181.437">
-<linearGradient id="SVGID_1_" y2=".00048828" gradientUnits="userSpaceOnUse" x2="-1807.2" gradientTransform="translate(1916)" y1="125.86" x1="-1807.2">
-	<stop stop-color="#1b3967" offset=".011"/>
-	<stop stop-color="#13b5ea" offset=".467"/>
-	<stop stop-color="#002b5c" offset=".9945"/>
-</linearGradient>
-<path d="m136.29 14.189c0.077 1.313-1.786 0.968-1.786 2.293 0 38.551-44.72 96.831-89.847 108.19v1.182c59.957-5.51 126.73-66.8 128.24-125.85l-36.6 14.189z" fill="url(#SVGID_1_)"/>
-<path d="m120.23 17.96c0.077 1.313 0.121 2.633 0.121 3.958 0 38.551-30.7 90.497-75.827 101.86v1.637c59.065-3.823 105.81-63.023 105.81-109.2 0-2.375-0.125-4.729-0.371-7.056l-29.73 8.796z" fill="#E96D1F"/>
-<linearGradient id="SVGID_2_" y2="1.279e-13" gradientUnits="userSpaceOnUse" x2="-1073.2" gradientTransform="matrix(-1 0 0 1 -1008.2 0)" y1="126.85" x1="-1073.2">
-	<stop stop-color="#1b3967" offset=".011"/>
-	<stop stop-color="#13b5ea" offset=".467"/>
-	<stop stop-color="#002b5c" offset=".9945"/>
-</linearGradient>
-<path d="m150.34 8.76l-7.833 2.625c0.041 0.963 0.191 2.203 0.191 3.173 0 41.219-37.272 98.205-87.274 107.12-3.243 1.089-7.538 2.077-10.93 2.932v1.639c68.344-8.66 111.18-71.719 105.84-117.49z" fill="#D9541E"/>
-<path d="m36.599 14.189c-0.077 1.313 1.787 0.968 1.787 2.293 0 38.551 46.558 97.366 91.688 108.73v1.639c-59.953-5.52-128.56-67.8-130.07-126.85l36.599 14.189z" fill="url(#SVGID_2_)"/>
-<path d="m54.731 18.932c-0.076 1.313-0.12 2.63-0.12 3.957 0 38.551 30.699 90.497 75.827 101.86v1.639c-59.044-2.79-105.81-63.024-105.81-109.2 0-2.375 0.128-4.729 0.371-7.056l29.73 8.798z" fill="#A0CE67"/>
-<path d="m24.713 9.583l7.617 2.722c-0.041 0.962-0.066 2.254-0.066 3.225 0 41.219 37.271 98.204 87.272 107.12 3.245 1.088 7.538 2.077 10.932 2.931v1.638c-65.254-5.56-111.1-71.866-105.76-117.64z" fill="#439639"/>
-	<path d="m14.576 166.71l-13.388-14.65h11.643l9.127 10.268 9.129-10.268h11.643l-13.387 14.646 14.401 14.728h-12.09l-9.697-10.67-9.693 10.67h-12.092l14.404-14.73z"/>
-	<path d="m47.096 152.06h13.836l10.183 18.905 10.183-18.905h13.832v29.374h-8.762v-21.096h-0.08l-11.807 21.096h-6.733l-11.807-21.096h-0.082v21.096h-8.764v-29.37z"/>
-	<path d="m101.25 152.06h24.546c8.559 0 10.628 4.302 10.628 10.063v2.516c0 4.381-1.908 9.41-8.275 9.41h-17.894v7.385h-9.005v-29.38zm9 14.69h13.997c2.109 0 2.924-1.377 2.924-3.123v-1.135c0-1.99-0.976-3.127-3.694-3.127h-13.227v7.38z"/>
-	<path d="m141.31 152.06h24.546c8.561 0 10.63 4.302 10.63 10.063v2.516c0 4.381-1.907 9.41-8.275 9.41h-17.893v7.385h-9.008v-29.38zm9.01 14.69h13.996c2.11 0 2.922-1.377 2.922-3.123v-1.135c0-1.99-0.974-3.127-3.693-3.127h-13.225v7.38z"/>
-</svg>
diff -pruN 0.1.17-1/src/meson.build 0.2.0-1/src/meson.build
--- 0.1.17-1/src/meson.build	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/meson.build	2020-11-27 09:44:20.000000000 +0000
@@ -18,6 +18,7 @@ libsrc = [
   'users/chatty-account.c',
   'users/chatty-pp-account.c',
   'chatty-list-row.c',
+  'chatty-avatar.c',
   'chatty-chat.c',
   'chatty-pp-chat.c',
   'chatty-contact-provider.c',
@@ -26,11 +27,24 @@ libsrc = [
   'chatty-icons.c',
   'chatty-history.c',
   'chatty-utils.c',
+  'chatty-phone-utils.cpp',
 ]
 
+ui_files = files (
+  'ui/chatty-chat-view.ui',
+  'ui/chatty-contact-row.ui',
+  'ui/chatty-dialog-join-muc.ui',
+  'ui/chatty-dialog-muc-info.ui',
+  'ui/chatty-dialog-new-chat.ui',
+  'ui/chatty-dialog-user-info.ui',
+  'ui/chatty-list-row.ui',
+  'ui/chatty-message-row.ui',
+  'ui/chatty-settings-dialog.ui',
+  'ui/chatty-window.ui',
+)
+
 chatty_sources = [
   'main.c',
-  'chatty-avatar.c',
   'chatty-chat-view.c',
   'chatty-manager.c',
   'chatty-application.c',
@@ -52,6 +66,7 @@ chatty_sources = [
   version_h,
 ]
 
+libphonenumber_dep = cc.find_library('phonenumber', required: true)
 purple = dependency('purple')
 purple_plugdir = purple.get_pkgconfig_variable('plugindir')
 jabber = meson.get_compiler('c').find_library('jabber', dirs: purple_plugdir)
@@ -61,7 +76,7 @@ chatty_deps = [
   dependency('gio-2.0', version: '>= 2.50'),
   dependency('gtk+-3.0', version: '>= 3.22'),
   purple, jabber,
-  dependency('libhandy-0.0'),
+  dependency('libhandy-1'),
   dependency('sqlite3', version: '>=3.0.0'),
   dependency('libebook-contacts-1.2'),
   dependency('libebook-1.2'),
@@ -69,25 +84,36 @@ chatty_deps = [
   libebook_dep,
   libfeedback_dep,
   libm_dep,
+  libphonenumber_dep,
 ]
 
 gnome = import('gnome')
 
-chatty_sources += gnome.compile_resources('chatty-resources',
+resources = gnome.compile_resources('chatty-resources',
   'chatty.gresource.xml',
   c_name: 'chatty'
 )
 
-libchatty = static_library(
-  'libchatty', libsrc,
+libchatty = both_libraries(
+  'chatty', libsrc, resources,
   install: false,
   dependencies: chatty_deps,
 )
 
-executable('chatty', chatty_sources,
+gtk_builder_tool = find_program('gtk-builder-tool', required: false)
+if gtk_builder_tool.found()
+  preload_env = 'LD_PRELOAD=@0@:libhandy-1.so'.format(libchatty.get_shared_lib().full_path())
+  foreach file: ui_files
+    test('Validate @0@'.format(file), gtk_builder_tool,
+         env: [preload_env],
+         args: ['validate', file])
+  endforeach
+endif
+
+executable('chatty', chatty_sources, resources,
   include_directories: jabber_incdir,
   dependencies: chatty_deps,
-  link_with: libchatty,
+  link_with: libchatty.get_static_lib(),
   install: true,
   install_rpath: purple_plugdir,
 )
diff -pruN 0.1.17-1/src/ui/chatty-chat-view.ui 0.2.0-1/src/ui/chatty-chat-view.ui
--- 0.1.17-1/src/ui/chatty-chat-view.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-chat-view.ui	2020-11-27 09:44:20.000000000 +0000
@@ -15,12 +15,10 @@
          <class name="view"/>
         </style>
         <child>
-          <object class="HdyColumn">
+          <object class="HdyClamp">
             <property name="visible">True</property>
             <property name="margin-start">12</property>
             <property name="margin-end">12</property>
-            <property name="maximum-width">640</property>
-            <property name="linear-growth-width">640</property>
             <child>
               <object class="GtkBox" id="property">
                 <property name="visible">True</property>
@@ -69,11 +67,9 @@
     </child>
 
     <child>
-      <object class="HdyColumn">
+      <object class="HdyClamp">
         <property name="visible">True</property>
         <property name="margin">6</property>
-        <property name="maximum-width">600</property>
-        <property name="linear-growth-width">600</property>
         <child>
           <object class="GtkBox">
             <property name="visible">True</property>
@@ -169,7 +165,7 @@
 
           </object>
         </child>
-      </object> <!-- ./HdyColumn -->
+      </object> <!-- ./HdyClamp -->
     </child>
   </template>
 
diff -pruN 0.1.17-1/src/ui/chatty-dialog-join-muc.ui 0.2.0-1/src/ui/chatty-dialog-join-muc.ui
--- 0.1.17-1/src/ui/chatty-dialog-join-muc.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-dialog-join-muc.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
   <requires lib="gtk+" version="3.16"/>
-  <template class="ChattyNewMucDialog" parent="HdyDialog">
+  <template class="ChattyNewMucDialog" parent="GtkDialog">
     <property name="modal">True</property>
     <property name="can_focus">False</property>
     <property name="default_width">360</property>
@@ -55,7 +55,7 @@
                 <property name="orientation">vertical</property>
                 <property name="visible">True</property>
                 <child>
-                  <object class="HdyColumn">
+                  <object class="HdyClamp">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
                     <property name="halign">fill</property>
@@ -65,7 +65,6 @@
                     <property name="margin-end">12</property>
                     <property name="margin-top">32</property>
                     <property name="expand">True</property>
-                    <property name="maximum-width">600</property>
                     <child>
                       <object class="GtkBox">
                         <property name="visible">True</property>
@@ -88,19 +87,15 @@
                           </object>
                         </child>
                         <child>
-                          <object class="GtkFrame">
+                          <object class="GtkListBox" id="accounts_list">
                             <property name="visible">True</property>
                             <property name="can_focus">False</property>
                             <property name="expand">True</property>
-                            <child>
-                              <object class="GtkListBox" id="accounts_list">
-                                <property name="visible">True</property>
-                                <property name="can_focus">False</property>
-                                <property name="expand">True</property>
-                                <property name="selection-mode">none</property>
-                                <signal name="row-activated" handler="account_list_row_activated_cb" swapped="yes"/>
-                              </object>
-                            </child>
+                            <property name="selection-mode">none</property>
+                            <signal name="row-activated" handler="account_list_row_activated_cb" swapped="yes"/>
+                            <style>
+                              <class name="content"/>
+                            </style>
                           </object>
                         </child>
                         <child>
diff -pruN 0.1.17-1/src/ui/chatty-dialog-muc-info.ui 0.2.0-1/src/ui/chatty-dialog-muc-info.ui
--- 0.1.17-1/src/ui/chatty-dialog-muc-info.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-dialog-muc-info.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
   <requires lib="gtk+" version="3.16"/>
-  <template class="ChattyMucInfoDialog" parent="HdyDialog">
+  <template class="ChattyMucInfoDialog" parent="GtkDialog">
     <property name="modal">True</property>
     <property name="can_focus">False</property>
     <property name="default_width">360</property>
@@ -105,7 +105,7 @@
                 <property name="vhomogeneous">False</property>
                 <property name="transition_type">slide-left-right</property>
                 <child>
-                  <object class="HdyColumn">
+                  <object class="HdyClamp">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
                     <property name="halign">fill</property>
@@ -115,7 +115,6 @@
                     <property name="margin-end">12</property>
                     <property name="margin-top">12</property>
                     <property name="expand">True</property>
-                    <property name="maximum-width">600</property>
                     <child>
                       <object class="GtkBox">
                         <property name="visible">True</property>
@@ -232,49 +231,45 @@
                           </object>
                         </child>
                         <child>
-                          <object class="GtkFrame">
+                          <object class="GtkListBox" id="list_muc_settings">
                             <property name="visible">True</property>
                             <property name="can_focus">False</property>
                             <property name="expand">True</property>
+                            <property name="selection-mode">none</property>
                             <property name="margin-bottom">32</property>
+                            <style>
+                              <class name="content"/>
+                            </style>
                             <child>
-                              <object class="GtkListBox" id="list_muc_settings">
+                              <object class="HdyActionRow">
+                                <property name="title" translatable="yes">Notifications</property>
+                                <property name="subtitle" translatable="yes">Show notification badge</property>
                                 <property name="visible">True</property>
-                                <property name="can_focus">False</property>
-                                <property name="expand">True</property>
-                                <property name="selection-mode">none</property>
+                                <property name="selectable">False</property>
+                                <property name="activatable-widget">switch_prefs_notifications</property>
                                 <child>
-                                  <object class="HdyActionRow">
-                                    <property name="title" translatable="yes">Notifications</property>
-                                    <property name="subtitle" translatable="yes">Show notification badge</property>
+                                  <object class="GtkSwitch" id="switch_prefs_notifications">
+                                    <property name="can_focus">True</property>
+                                    <property name="valign">center</property>
                                     <property name="visible">True</property>
-                                    <property name="selectable">False</property>
-                                    <property name="activatable">False</property>
-                                    <child type="action">
-                                      <object class="GtkSwitch" id="switch_prefs_notifications">
-                                        <property name="can_focus">True</property>
-                                        <property name="valign">center</property>
-                                        <property name="visible">True</property>
-                                        <signal name="notify::active" handler="switch_prefs_notify_changed_cb" swapped="yes"/>
-                                      </object>
-                                    </child>
+                                    <signal name="notify::active" handler="switch_prefs_notify_changed_cb" swapped="yes"/>
                                   </object>
                                 </child>
+                              </object>
+                            </child>
+                            <child>
+                              <object class="HdyActionRow">
+                                <property name="title" translatable="yes">Status Messages</property>
+                                <property name="subtitle" translatable="yes">Show status messages in chat</property>
+                                <property name="visible">True</property>
+                                <property name="selectable">False</property>
+                                <property name="activatable-widget">switch_prefs_status</property>
                                 <child>
-                                  <object class="HdyActionRow">
-                                    <property name="title" translatable="yes">Status Messages</property>
-                                    <property name="subtitle" translatable="yes">Show status messages in chat</property>
+                                  <object class="GtkSwitch" id="switch_prefs_status">
+                                    <property name="can_focus">True</property>
+                                    <property name="valign">center</property>
                                     <property name="visible">True</property>
-                                    <property name="selectable">False</property>
-                                    <property name="activatable">False</property>
-                                    <child type="action">
-                                      <object class="GtkSwitch" id="switch_prefs_status">
-                                        <property name="can_focus">True</property>
-                                        <property name="valign">center</property>
-                                        <property name="visible">True</property>
-                                        <signal name="notify::active" handler="switch_prefs_state_changed_cb" swapped="yes"/>
-                                      </object>
-                                    </child>
+                                    <signal name="notify::active" handler="switch_prefs_state_changed_cb" swapped="yes"/>
                                   </object>
                                 </child>
                               </object>
@@ -316,7 +311,7 @@
                     <property name="orientation">vertical</property>
                     <property name="visible">True</property>
                     <child>
-                      <object class="HdyColumn">
+                      <object class="HdyClamp">
                         <property name="visible">True</property>
                         <property name="can_focus">False</property>
                         <property name="halign">fill</property>
@@ -326,7 +321,6 @@
                         <property name="margin-end">12</property>
                         <property name="margin-top">32</property>
                         <property name="expand">True</property>
-                        <property name="maximum-width">600</property>
                         <child>
                           <object class="GtkBox">
                             <property name="visible">True</property>
diff -pruN 0.1.17-1/src/ui/chatty-dialog-new-chat.ui 0.2.0-1/src/ui/chatty-dialog-new-chat.ui
--- 0.1.17-1/src/ui/chatty-dialog-new-chat.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-dialog-new-chat.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
   <requires lib="gtk+" version="3.16"/>
-  <template class="ChattyNewChatDialog" parent="HdyDialog">
+  <template class="ChattyNewChatDialog" parent="GtkDialog">
     <property name="modal">True</property>
     <property name="can_focus">False</property>
     <property name="default_width">360</property>
@@ -125,7 +125,7 @@
                     <property name="can_focus">False</property>
                     <property name="hexpand">True</property>
                     <property name="orientation">vertical</property>
-                    <property name="valign">start</property>
+                    <property name="valign">fill</property>
                     <child>
                       <object class="HdySearchBar" id="contacts_search_bar">
                         <property name="visible">True</property>
@@ -136,10 +136,9 @@
                         <property name="show-close-button">False</property>
                         <property name="search-mode-enabled">True</property>
                         <child>
-                          <object class="HdyColumn">
+                          <object class="HdyClamp">
                             <property name="visible">True</property>
                             <property name="hexpand">True</property>
-                            <property name="maximum-width">600</property>
                             <child>
                               <object class="GtkSearchEntry" id="contacts_search_entry">
                                 <property name="visible">True</property>
@@ -160,29 +159,90 @@
                     </child>
 
                     <child>
-                      <object class="GtkListBox" id="chats_listbox">
+                      <object class="GtkStack" id="contact_list_stack">
                         <property name="visible">True</property>
-                        <property name="can_focus">False</property>
-                        <property name="expand">True</property>
-                        <property name="selection-mode">none</property>
-                        <signal name="row-activated" handler="contact_row_activated_cb" swapped="yes"/>
-                        <style>
-                          <class name="frame"/>
-                        </style>
-                      </object>
-                    </child>
 
-                    <child>
-                      <object class="GtkListBox" id="new_contact_listbox">
-                        <property name="visible" bind-source="new_contact_row" bind-property="visible"/>
-                        <property name="selection-mode">none</property>
-                        <signal name="row-activated" handler="contact_row_activated_cb" swapped="yes"/>
+                        <!-- Search results view -->
+                        <child>
+                          <object class="GtkBox" id="contact_list_view">
+                            <property name="visible">True</property>
+                            <property name="can_focus">False</property>
+                            <property name="hexpand">True</property>
+                            <property name="orientation">vertical</property>
+                            <property name="valign">start</property>
+
+                            <child>
+                              <object class="GtkListBox" id="chats_listbox">
+                                <property name="visible">True</property>
+                                <property name="can_focus">False</property>
+                                <property name="expand">True</property>
+                                <property name="selection-mode">none</property>
+                                <signal name="row-activated" handler="contact_row_activated_cb" swapped="yes"/>
+                                <style>
+                                 <class name="frame"/>
+                                </style>
+                              </object>
+                            </child>
+
+                            <child>
+                              <object class="GtkListBox" id="new_contact_listbox">
+                                <property name="visible" bind-source="new_contact_row" bind-property="visible"/>
+                                <property name="selection-mode">none</property>
+                                <signal name="row-activated" handler="contact_row_activated_cb" swapped="yes"/>
+                                <child>
+                                  <object class="ChattyListRow" id="new_contact_row"/>
+                                </child>
+                                <style>
+                                 <class name="frame"/>
+                                </style>
+                              </object>
+                            </child>
+
+                          </object>
+                        </child>
+
+                        <!-- Empty search results view -->
                         <child>
-                          <object class="ChattyListRow" id="new_contact_row"/>
+                          <object class="GtkBox" id="empty_search_view">
+                            <property name="visible">True</property>
+                            <property name="valign">center</property>
+                            <property name="halign">center</property>
+                            <property name="hexpand">False</property>
+                            <property name="margin-bottom">18</property>
+                            <property name="orientation">vertical</property>
+                            <property name="spacing">6</property>
+                            <child>
+                              <object class="GtkImage">
+                                <property name="visible">True</property>
+                                <property name="icon-name">system-search-symbolic</property>
+                                <property name="pixel-size">64</property>
+                              </object>
+                            </child>
+                            <child>
+                              <object class="GtkLabel">
+                                <property name="visible">True</property>
+                                <property name="label" translatable="yes">No Search Results</property>
+                                <attributes>
+                                  <attribute name="weight" value="bold"/>
+                                  <attribute name="scale" value="1.2"/>
+                                </attributes>
+                              </object>
+                            </child>
+                            <child>
+                              <object class="GtkLabel">
+                                <property name="visible">True</property>
+                                <property name="wrap">True</property>
+                                <property name="max-width-chars">24</property>
+                                <property name="justify">center</property>
+                                <property name="label" translatable="yes">Try different search, or type a valid number to create new chat</property>
+                                <style>
+                                 <class name="dim-label"/>
+                                </style>
+                              </object>
+                            </child>
+                          </object>
                         </child>
-                        <style>
-                          <class name="frame"/>
-                        </style>
+
                       </object>
                     </child>
 
@@ -196,7 +256,7 @@
                     <property name="orientation">vertical</property>
                     <property name="visible">True</property>
                     <child>
-                      <object class="HdyColumn">
+                      <object class="HdyClamp">
                         <property name="visible">True</property>
                         <property name="can_focus">False</property>
                         <property name="halign">fill</property>
@@ -206,7 +266,6 @@
                         <property name="margin-end">12</property>
                         <property name="margin-top">32</property>
                         <property name="expand">True</property>
-                        <property name="maximum-width">600</property>
                         <child>
                           <object class="GtkBox">
                             <property name="visible">True</property>
@@ -244,20 +303,16 @@
                               </object>
                             </child>
                             <child>
-                              <object class="GtkFrame">
+                              <object class="GtkListBox" id="accounts_list">
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
                                 <property name="expand">True</property>
+                                <property name="selection-mode">none</property>
                                 <property name="margin-bottom">32</property>
-                                <child>
-                                  <object class="GtkListBox" id="accounts_list">
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="expand">True</property>
-                                    <property name="selection-mode">none</property>
-                                    <signal name="row-activated" handler="account_list_row_activated_cb" swapped="yes"/>
-                                  </object>
-                                </child>
+                                <signal name="row-activated" handler="account_list_row_activated_cb" swapped="yes"/>
+                                <style>
+                                  <class name="content"/>
+                                </style>
                               </object>
                             </child>
                             <child>
diff -pruN 0.1.17-1/src/ui/chatty-dialog-user-info.ui 0.2.0-1/src/ui/chatty-dialog-user-info.ui
--- 0.1.17-1/src/ui/chatty-dialog-user-info.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-dialog-user-info.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
   <requires lib="gtk+" version="3.16"/>
-  <template class="ChattyUserInfoDialog" parent="HdyDialog">
+  <template class="ChattyUserInfoDialog" parent="GtkDialog">
     <property name="modal">True</property>
     <property name="can_focus">False</property>
     <property name="default_width">360</property>
@@ -30,7 +30,7 @@
                 <property name="orientation">vertical</property>
                 <property name="visible">True</property>
                 <child>
-                  <object class="HdyColumn">
+                  <object class="HdyClamp">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
                     <property name="halign">fill</property>
@@ -40,7 +40,7 @@
                     <property name="margin-end">12</property>
                     <property name="margin-top">24</property>
                     <property name="expand">True</property>
-                    <property name="maximum-width">400</property>
+                    <property name="maximum-size">400</property>
                     <child>
                       <object class="GtkBox">
                         <property name="visible">True</property>
@@ -202,7 +202,7 @@
                             <property name="expand">True</property>
                             <property name="selection-mode">none</property>
                             <style>
-                              <class name="frame"/>
+                              <class name="content"/>
                             </style>
                             <child>
                               <object class="HdyActionRow">
@@ -210,7 +210,7 @@
                                 <property name="visible">True</property>
                                 <property name="selectable">False</property>
                                 <property name="activatable">False</property>
-                                <child type="action">
+                                <child>
                                   <object class="GtkSwitch" id="switch_notify">
                                     <property name="can_focus">True</property>
                                     <property name="valign">center</property>
@@ -228,7 +228,7 @@
                                 <property name="selectable">False</property>
                                 <property name="activatable">False</property>
                                 <property name="visible" bind-source="listbox_fps" bind-property="visible" bind-flags="sync-create"/>
-                                <child type="action">
+                                <child>
                                   <object class="GtkSwitch" id="switch_encrypt">
                                     <property name="can_focus">True</property>
                                     <property name="valign">center</property>
@@ -264,7 +264,7 @@
                             <signal name="add" handler="list_fps_changed_cb" swapped="yes"/>
                             <signal name="remove" handler="list_fps_changed_cb" swapped="yes"/>
                             <style>
-                              <class name="frame"/>
+                              <class name="content"/>
                             </style>
                           </object>
                         </child>
diff -pruN 0.1.17-1/src/ui/chatty-settings-dialog.ui 0.2.0-1/src/ui/chatty-settings-dialog.ui
--- 0.1.17-1/src/ui/chatty-settings-dialog.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-settings-dialog.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
-  <template class="ChattySettingsDialog" parent="HdyDialog">
+  <template class="ChattySettingsDialog" parent="GtkDialog">
     <property name="default-height">480</property>
     <property name="default-width">360</property>
     <signal name="delete-event" handler="gtk_widget_hide_on_delete"/>
@@ -97,12 +97,13 @@
                         <property name="selection-mode">none</property>
                         <signal name="row-activated" handler="account_list_row_activated_cb" swapped="yes"/>
                         <style>
-                          <class name="frame"/>
+                          <class name="content"/>
                         </style>
                         <child>
                           <object class="HdyActionRow" id="add_account_row">
                             <property name="visible">True</property>
                             <property name="title" translatable="yes">Add new account…</property>
+                            <property name="activatable">True</property>
                           </object>
                         </child>
                       </object>
@@ -122,7 +123,7 @@
                         <property name="title" translatable="yes">Message Receipts</property>
                         <property name="subtitle" translatable="yes">Confirm received messages</property>
                         <property name="activatable-widget">send_receipts_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="send_receipts_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -137,7 +138,7 @@
                         <property name="title" translatable="yes">Message Archive Management</property>
                         <property name="subtitle" translatable="yes">Sync conversations with chat server</property>
                         <property name="activatable-widget">message_archive_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="message_archive_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -152,7 +153,7 @@
                         <property name="title" translatable="yes">Message Carbon Copies</property>
                         <property name="subtitle" translatable="yes">Share chat history among devices</property>
                         <property name="activatable-widget">message_carbons_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="message_carbons_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -167,7 +168,7 @@
                         <property name="title" translatable="yes">Typing Notification</property>
                         <property name="subtitle" translatable="yes">Send typing messages</property>
                         <property name="activatable-widget">typing_notification_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="typing_notification_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -190,7 +191,7 @@
                         <property name="title" translatable="yes">Indicate Offline Contacts</property>
                         <property name="subtitle" translatable="yes">Grey out avatars from offline contacts</property>
                         <property name="activatable-widget">indicate_offline_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="indicate_offline_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -205,7 +206,7 @@
                         <property name="title" translatable="yes">Indicate Idle Contacts</property>
                         <property name="subtitle" translatable="yes">Blur avatars from idle contacts</property>
                         <property name="activatable-widget">indicate_idle_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="indicate_idle_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -220,7 +221,7 @@
                         <property name="title" translatable="yes">Indicate Unknown Contacts</property>
                         <property name="subtitle" translatable="yes">Color unknown contact ID red</property>
                         <property name="activatable-widget">indicate_unknown_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="indicate_unknown_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -243,7 +244,7 @@
                         <property name="title" translatable="yes">Graphical Emoticons</property>
                         <property name="subtitle" translatable="yes">Convert ASCII emoticons</property>
                         <property name="activatable-widget">convert_smileys_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="convert_smileys_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -258,7 +259,7 @@
                         <property name="title" translatable="yes">Return = Send Message</property>
                         <property name="subtitle" translatable="yes">Send message with return key</property>
                         <property name="activatable-widget">return_sends_switch</property>
-                        <child type="action">
+                        <child>
                           <object class="GtkSwitch" id="return_sends_switch">
                             <property name="visible">True</property>
                             <property name="valign">center</property>
@@ -275,233 +276,206 @@
             </child>
 
             <child>
-              <object class="GtkScrolledWindow">
+              <object class="HdyPreferencesPage">
                 <property name="visible">True</property>
-                <property name="propagate_natural_height">True</property>
-                <property name="kinetic-scrolling">True</property>
-                <property name="hscrollbar_policy">never</property>
-                <property name="expand">True</property>
                 <child>
-                  <object class="HdyColumn">
+                  <object class="HdyPreferencesGroup">
                     <property name="visible">True</property>
-                    <property name="can_focus">False</property>
-                    <property name="margin-bottom">32</property>
-                    <property name="margin-start">32</property>
-                    <property name="margin-end">32</property>
-                    <property name="margin-top">24</property>
-                    <property name="expand">True</property>
-                    <property name="maximum-width">400</property>
                     <child>
-                      <object class="GtkBox">
+                      <object class="GtkButton" id="avatar_button">
                         <property name="visible">True</property>
-                        <property name="orientation">vertical</property>
+                        <property name="halign">center</property>
                         <property name="can_focus">False</property>
-                        <property name="valign">start</property>
-                        <property name="expand">True</property>
+                        <property name="focus_on_click">False</property>
+                        <property name="receives_default">False</property>
+                        <property name="margin_bottom">24</property>
+                        <signal name="clicked" handler="settings_avatar_button_clicked_cb" swapped="yes"/>
                         <child>
-                          <object class="GtkButton" id="avatar_button">
+                          <object class="ChattyAvatar" id="avatar_image">
                             <property name="visible">True</property>
-                            <property name="halign">center</property>
-                            <property name="can_focus">False</property>
-                            <property name="focus_on_click">False</property>
-                            <property name="receives_default">False</property>
-                            <property name="margin_bottom">24</property>
-                            <signal name="clicked" handler="settings_avatar_button_clicked_cb" swapped="yes"/>
-                            <child>
-                              <object class="ChattyAvatar" id="avatar_image">
-                                <property name="visible">True</property>
-                                <property name="pixel_size">96</property>
-                              </object>
-                            </child>
+                            <property name="pixel_size">96</property>
                           </object>
                         </child>
+                      </object>
+                    </child>
+                    <child>
+                      <object class="GtkGrid">
+                        <property name="visible">True</property>
+                        <property name="can_focus">False</property>
+                        <property name="halign">start</property>
+                        <property name="margin_bottom">24</property>
+                        <property name="row_spacing">12</property>
+                        <property name="column_spacing">6</property>
                         <child>
-                          <object class="GtkGrid">
+                          <object class="GtkLabel">
+                            <property name="label" translatable="yes">Account ID</property>
+                            <property name="xalign">1</property>
                             <property name="visible">True</property>
-                            <property name="can_focus">False</property>
-                            <property name="halign">start</property>
-                            <property name="margin_bottom">24</property>
-                            <property name="row_spacing">12</property>
-                            <property name="column_spacing">6</property>
-                            <child>
-                              <object class="GtkLabel">
-                                <property name="label" translatable="yes">Account ID</property>
-                                <property name="xalign">1</property>
-                                <property name="visible">True</property>
-                                <style>
-                                  <class name="dim-label"/>
-                                </style>
-                              </object>
-                              <packing>
-                                <property name="left_attach">0</property>
-                                <property name="top_attach">0</property>
-                                <property name="width">1</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkEntry" id="account_id_entry">
-                                <property name="activates_default">True</property>
-                                <property name="hexpand">True</property>
-                                <property name="visible">True</property>
-                                <property name="sensitive">False</property>
-                                <style>
-                                  <class name="entry_hide"/>
-                                </style>
-                              </object>
-                              <packing>
-                                <property name="left_attach">1</property>
-                                <property name="top_attach">0</property>
-                                <property name="width">2</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel">
-                                <property name="label" translatable="yes">Protocol</property>
-                                <property name="xalign">1</property>
-                                <property name="visible">True</property>
-                                <style>
-                                  <class name="dim-label"/>
-                                </style>
-                              </object>
-                              <packing>
-                                <property name="left_attach">0</property>
-                                <property name="top_attach">1</property>
-                                <property name="width">1</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel" id="account_protocol_label">
-                                <property name="visible">True</property>
-                                <property name="xalign">0</property>
-                                <property name="ellipsize">end</property>
-                              </object>
-                              <packing>
-                                <property name="left_attach">1</property>
-                                <property name="top_attach">1</property>
-                                <property name="width">2</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel">
-                                <property name="label" translatable="yes">Status</property>
-                                <property name="xalign">1</property>
-                                <property name="visible">True</property>
-                                <style>
-                                  <class name="dim-label"/>
-                                </style>
-                              </object>
-                              <packing>
-                                <property name="left_attach">0</property>
-                                <property name="top_attach">2</property>
-                                <property name="width">1</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel" id="status_label">
-                                <property name="xalign">0</property>
-                                <property name="ellipsize">end</property>
-                                <property name="visible">True</property>
-                              </object>
-                              <packing>
-                                <property name="left_attach">1</property>
-                                <property name="top_attach">2</property>
-                                <property name="width">2</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel">
-                                <property name="label" translatable="yes">Password</property>
-                                <property name="xalign">1</property>
-                                <property name="visible">True</property>
-                                <style>
-                                  <class name="dim-label"/>
-                                </style>
-                              </object>
-                              <packing>
-                                <property name="left_attach">0</property>
-                                <property name="top_attach">3</property>
-                                <property name="width">1</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkEntry" id="password_entry">
-                                <property name="hexpand">True</property>
-                                <property name="input_purpose">password</property>
-                                <property name="sensitive">False</property>
-                                <property name="visible">True</property>
-                                <property name="visibility">False</property>
-                                <property name="primary_icon_sensitive">False</property>
-                                <property name="secondary_icon_activatable">True</property>
-                                <property name="secondary_icon_name">eye-not-looking-symbolic</property>
-                                <property name="secondary_icon_sensitive">True</property>
-                                <signal name="icon-press" handler="settings_pw_entry_icon_clicked_cb" swapped="yes"/>
-                              </object>
-                              <packing>
-                                <property name="left_attach">1</property>
-                                <property name="top_attach">3</property>
-                                <property name="width">1</property>
-                                <property name="height">1</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkButton" id="edit_password_button">
-                                <property name="can-focus">False</property>
-                                <property name="margin-right">12</property>
-                                <property name="valign">center</property>
-                                <property name="visible">True</property>
-                                <signal name="clicked" handler="settings_edit_password_clicked_cb" swapped="yes"/>
-                                <child>
-                                  <object class="GtkImage">
-                                    <property name="icon-name">document-edit-symbolic</property>
-                                    <property name="icon-size">1</property>
-                                    <property name="visible">True</property>
-                                  </object>
-                                </child>
-                              </object>
-                              <packing>
-                                <property name="left_attach">2</property>
-                                <property name="top_attach">3</property>
-                              </packing>
-                            </child>
+                            <style>
+                             <class name="dim-label"/>
+                            </style>
+                          </object>
+                          <packing>
+                            <property name="left_attach">0</property>
+                            <property name="top_attach">0</property>
+                            <property name="width">1</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkEntry" id="account_id_entry">
+                            <property name="activates_default">True</property>
+                            <property name="hexpand">True</property>
+                            <property name="visible">True</property>
+                            <property name="sensitive">False</property>
+                            <style>
+                             <class name="entry_hide"/>
+                            </style>
+                          </object>
+                          <packing>
+                            <property name="left_attach">1</property>
+                            <property name="top_attach">0</property>
+                            <property name="width">2</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkLabel">
+                            <property name="label" translatable="yes">Protocol</property>
+                            <property name="xalign">1</property>
+                            <property name="visible">True</property>
+                            <style>
+                             <class name="dim-label"/>
+                            </style>
+                          </object>
+                          <packing>
+                            <property name="left_attach">0</property>
+                            <property name="top_attach">1</property>
+                            <property name="width">1</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkLabel" id="account_protocol_label">
+                            <property name="visible">True</property>
+                            <property name="xalign">0</property>
+                            <property name="ellipsize">end</property>
+                          </object>
+                          <packing>
+                            <property name="left_attach">1</property>
+                            <property name="top_attach">1</property>
+                            <property name="width">2</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkLabel">
+                            <property name="label" translatable="yes">Status</property>
+                            <property name="xalign">1</property>
+                            <property name="visible">True</property>
+                            <style>
+                             <class name="dim-label"/>
+                            </style>
+                          </object>
+                          <packing>
+                            <property name="left_attach">0</property>
+                            <property name="top_attach">2</property>
+                            <property name="width">1</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkLabel" id="status_label">
+                            <property name="xalign">0</property>
+                            <property name="ellipsize">end</property>
+                            <property name="visible">True</property>
+                          </object>
+                          <packing>
+                            <property name="left_attach">1</property>
+                            <property name="top_attach">2</property>
+                            <property name="width">2</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkLabel">
+                            <property name="label" translatable="yes">Password</property>
+                            <property name="xalign">1</property>
+                            <property name="visible">True</property>
+                            <style>
+                              <class name="dim-label"/>
+                            </style>
+                          </object>
+                          <packing>
+                            <property name="left_attach">0</property>
+                            <property name="top_attach">3</property>
+                            <property name="width">1</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkEntry" id="password_entry">
+                            <property name="hexpand">True</property>
+                            <property name="input_purpose">password</property>
+                            <property name="sensitive">False</property>
+                            <property name="visible">True</property>
+                            <property name="visibility">False</property>
+                            <property name="primary_icon_sensitive">False</property>
+                            <property name="secondary_icon_activatable">True</property>
+                            <property name="secondary_icon_name">eye-not-looking-symbolic</property>
+                            <property name="secondary_icon_sensitive">True</property>
+                            <signal name="icon-press" handler="settings_pw_entry_icon_clicked_cb" swapped="yes"/>
+                          </object>
+                          <packing>
+                            <property name="left_attach">1</property>
+                            <property name="top_attach">3</property>
+                            <property name="width">1</property>
+                            <property name="height">1</property>
+                          </packing>
+                        </child>
+                        <child>
+                          <object class="GtkButton" id="edit_password_button">
+                            <property name="can-focus">False</property>
+                            <property name="margin-right">12</property>
+                            <property name="valign">center</property>
+                            <property name="visible">True</property>
+                            <signal name="clicked" handler="settings_edit_password_clicked_cb" swapped="yes"/>
                             <child>
-                              <object class="GtkButton" id="delete_account_button">
-                                <property name="halign">start</property>
-                                <property name="margin_top">12</property>
-                                <property name="label" translatable="yes">Delete Account</property>
+                              <object class="GtkImage">
+                                <property name="icon-name">document-edit-symbolic</property>
+                                <property name="icon-size">1</property>
                                 <property name="visible">True</property>
-                                <property name="can_focus">True</property>
-                                <signal name="clicked" handler="settings_delete_account_clicked_cb" swapped="yes"/>
                               </object>
-                              <packing>
-                                <property name="left_attach">1</property>
-                                <property name="top_attach">4</property>
-                              </packing>
                             </child>
                           </object>
+                          <packing>
+                            <property name="left_attach">2</property>
+                            <property name="top_attach">3</property>
+                          </packing>
                         </child>
                         <child>
-                          <object class="GtkLabel">
-                            <property name="visible">False</property>
-                            <property name="can_focus">False</property>
-                            <property name="expand">True</property>
-                            <property name="label" translatable="yes">Own Fingerprint</property>
-                            <property name="justify">left</property>
+                          <object class="GtkButton" id="delete_account_button">
                             <property name="halign">start</property>
-                            <property name="margin-top">24</property>
-                            <property name="margin-bottom">12</property>
-                            <property name="visible" bind-source="fingerprint_list" bind-property="visible" bind-flags="sync-create"/>
-                            <attributes>
-                              <attribute name="weight" value="bold"/>
-                            </attributes>
+                            <property name="margin_top">12</property>
+                            <property name="label" translatable="yes">Delete Account</property>
+                            <property name="visible">True</property>
+                            <property name="can_focus">True</property>
+                            <signal name="clicked" handler="settings_delete_account_clicked_cb" swapped="yes"/>
                           </object>
+                          <packing>
+                            <property name="left_attach">1</property>
+                            <property name="top_attach">4</property>
+                          </packing>
                         </child>
+                      </object>
+                    </child>
+                  </object>
+                </child>
+
+                    <child>
+                      <object class="HdyPreferencesGroup">
+                        <property name="visible" bind-source="fingerprint_list" bind-property="visible" bind-flags="sync-create"/>
+                        <property name="title" translatable="yes">Own Fingerprint</property>
                         <child>
                           <object class="GtkListBox" id="fingerprint_list">
                             <property name="visible">False</property>
@@ -509,25 +483,15 @@
                             <property name="expand">True</property>
                             <property name="selection-mode">none</property>
                             <style>
-                              <class name="frame"/>
+                              <class name="content"/>
                             </style>
                           </object>
                         </child>
-                        <child>
-                          <object class="GtkLabel">
-                            <property name="visible">False</property>
-                            <property name="expand">True</property>
-                            <property name="label" translatable="yes">Other Devices</property>
-                            <property name="justify">left</property>
-                            <property name="halign">start</property>
-                            <property name="margin-top">24</property>
-                            <property name="margin-bottom">12</property>
-                            <property name="visible" bind-source="fingerprint_device_list" bind-property="visible" bind-flags="sync-create"/>
-                            <attributes>
-                              <attribute name="weight" value="bold"/>
-                            </attributes>
-                          </object>
-                        </child>
+                      </object>
+                    </child>
+                    <child>
+                      <object class="HdyPreferencesGroup">
+                        <property name="visible" bind-source="fingerprint_device_list" bind-property="visible" bind-flags="sync-create"/>
                         <child>
                           <object class="GtkListBox" id="fingerprint_device_list">
                             <property name="visible">False</property>
@@ -535,14 +499,12 @@
                             <property name="expand">True</property>
                             <property name="selection-mode">none</property>
                             <style>
-                              <class name="frame"/>
+                              <class name="content"/>
                             </style>
                           </object>
                         </child>
                       </object>
                     </child>
-                  </object>
-                </child>
               </object>
               <packing>
                 <property name="name">edit-account-view</property>
@@ -550,191 +512,160 @@
             </child>
 
             <child>
-              <object class="GtkScrolledWindow">
-                <property name="propagate_natural_height">True</property>
-                <property name="kinetic-scrolling">True</property>
-                <property name="hscrollbar_policy">never</property>
-                <property name="expand">True</property>
+              <object class="HdyPreferencesPage">
                 <property name="visible">True</property>
                 <child>
-                  <object class="HdyColumn">
-                    <property name="visible">True</property>
-                    <property name="can_focus">False</property>
-                    <property name="halign">fill</property>
-                    <property name="valign">fill</property>
-                    <property name="margin-bottom">24</property>
-                    <property name="margin-start">32</property>
-                    <property name="margin-end">24</property>
-                    <property name="margin-top">32</property>
-                    <property name="expand">True</property>
-                    <property name="maximum-width">600</property>
+                  <object class="HdyPreferencesGroup" id="protocol_list_group">
+                    <property name="visible">true</property>
                     <child>
-                      <object class="GtkBox">
-                        <property name="visible">True</property>
-                        <property name="orientation">vertical</property>
+                      <object class="GtkListBox" id="protocol_list">
+                        <property name="visible">False</property>
                         <property name="can_focus">False</property>
-                        <property name="valign">start</property>
-                        <property name="expand">True</property>
+                        <property name="selection-mode">none</property>
+                        <property name="margin-bottom">24</property>
+                        <style>
+                          <class name="content"/>
+                        </style>
                         <child>
-                          <object class="GtkLabel" id="protocol_title_label">
+                          <object class="HdyActionRow">
+                            <property name="activatable_widget">xmpp_radio_button</property>
+                            <property name="title" translatable="yes">XMPP</property>
                             <property name="visible">True</property>
-                            <property name="can_focus">False</property>
-                            <property name="expand">True</property>
-                            <property name="justify">left</property>
-                            <property name="halign">start</property>
-                            <property name="margin-bottom">12</property>
-                            <attributes>
-                              <attribute name="weight" value="bold"/>
-                            </attributes>
+                            <child type="prefix">
+                              <object class="GtkRadioButton" id="xmpp_radio_button">
+                                <property name="visible">True</property>
+                                <property name="can_focus">True</property>
+                                <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
+                              </object>
+                            </child>
                           </object>
                         </child>
                         <child>
-                          <object class="GtkListBox" id="protocol_list">
+                          <object class="HdyActionRow" id="matrix_row">
+                            <property name="activatable_widget">matrix_radio_button</property>
+                            <property name="title" translatable="yes">Matrix</property>
                             <property name="visible">False</property>
+                            <child type="prefix">
+                              <object class="GtkRadioButton" id="matrix_radio_button">
+                                <property name="visible">True</property>
+                                <property name="can_focus">True</property>
+                                <property name="group">xmpp_radio_button</property>
+                                <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
+                              </object>
+                            </child>
+                          </object>
+                        </child>
+                        <child>
+                          <object class="HdyActionRow" id="telegram_row">
+                            <property name="activatable_widget">telegram_radio_button</property>
+                            <property name="title" translatable="yes">Telegram</property>
+                            <property name="visible">False</property>
+                            <child type="prefix">
+                              <object class="GtkRadioButton" id="telegram_radio_button">
+                                <property name="visible">True</property>
+                                <property name="can_focus">True</property>
+                                <property name="group">xmpp_radio_button</property>
+                                <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
+                              </object>
+                            </child>
+                          </object>
+                        </child>
+                      </object>
+                    </child>
+                  </object>
+                </child>
+                <child>
+                  <object class="HdyPreferencesGroup">
+                    <property name="visible">true</property>
+                    <child>
+                      <object class="GtkListBox" id="new_account_settings_list">
+                        <property name="visible">True</property>
+                        <property name="can_focus">False</property>
+                        <property name="expand">True</property>
+                        <property name="selection-mode">none</property>
+                        <property name="margin-bottom">24</property>
+                        <style>
+                          <class name="content"/>
+                        </style>
+                        <child>
+                          <object class="HdyActionRow">
+                            <property name="selectable">False</property>
+                            <property name="activatable">False</property>
+                            <property name="visible">True</property>
                             <property name="can_focus">False</property>
-                            <property name="expand">True</property>
-                            <property name="selection-mode">none</property>
-                            <property name="margin-bottom">24</property>
-                            <style>
-                              <class name="frame"/>
-                            </style>
-                            <child>
-                              <object class="HdyActionRow">
-                                <property name="activatable_widget">xmpp_radio_button</property>
-                                <property name="title" translatable="yes">XMPP</property>
+                            <child type="prefix">
+                              <object class="GtkLabel">
+                                <property name="label" translatable="no">User ID</property>
+                                <property name="xalign">1</property>
                                 <property name="visible">True</property>
-                                <child type="prefix">
-                                  <object class="GtkRadioButton" id="xmpp_radio_button">
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
-                                  </object>
-                                </child>
+                                <property name="halign">start</property>
                               </object>
                             </child>
                             <child>
-                              <object class="HdyActionRow" id="matrix_row">
-                                <property name="activatable_widget">matrix_radio_button</property>
-                                <property name="title" translatable="yes">Matrix</property>
-                                <property name="visible">False</property>
-                                <child type="prefix">
-                                  <object class="GtkRadioButton" id="matrix_radio_button">
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="group">xmpp_radio_button</property>
-                                    <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
-                                  </object>
-                                </child>
+                              <object class="GtkEntry" id="new_account_id_entry">
+                                <property name="activates_default">True</property>
+                                <property name="hexpand">False</property>
+                                <property name="visible">True</property>
+                                <property name="halign">end</property>
+                                <property name="valign">center</property>
+                                <signal name="changed" handler="settings_account_id_changed_cb" swapped="yes"/>
+                              </object>
+                            </child>
+                          </object>
+                        </child>
+                        <child>
+                          <object class="HdyActionRow">
+                            <property name="selectable">False</property>
+                            <property name="activatable">False</property>
+                            <property name="visible" bind-source="server_url_entry" bind-property="visible" bind-flags="sync-create"/>
+                            <property name="can_focus">False</property>
+                            <child type="prefix">
+                              <object class="GtkLabel">
+                                <property name="label" translatable="yes">Provider</property>
+                                <property name="xalign">1</property>
+                                <property name="visible">True</property>
+                                <property name="halign">start</property>
                               </object>
                             </child>
                             <child>
-                              <object class="HdyActionRow" id="telegram_row">
-                                <property name="activatable_widget">telegram_radio_button</property>
-                                <property name="title" translatable="yes">Telegram</property>
+                              <object class="GtkEntry" id="server_url_entry">
+                                <property name="activates_default">True</property>
+                                <property name="hexpand">False</property>
                                 <property name="visible">False</property>
-                                <child type="prefix">
-                                  <object class="GtkRadioButton" id="telegram_radio_button">
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="group">xmpp_radio_button</property>
-                                    <signal name="toggled" handler="settings_protocol_changed_cb" swapped="yes"/>
-                                  </object>
-                                </child>
+                                <property name="halign">end</property>
+                                <property name="valign">center</property>
                               </object>
                             </child>
                           </object>
                         </child>
                         <child>
-                          <object class="GtkListBox" id="new_account_settings_list">
+                          <object class="HdyActionRow">
+                            <property name="selectable">False</property>
+                            <property name="activatable">False</property>
                             <property name="visible">True</property>
                             <property name="can_focus">False</property>
-                            <property name="expand">True</property>
-                            <property name="selection-mode">none</property>
-                            <property name="margin-bottom">24</property>
-                            <style>
-                              <class name="frame"/>
-                            </style>
-                            <child>
-                              <object class="HdyActionRow">
-                                <property name="selectable">False</property>
-                                <property name="activatable">False</property>
+                            <child type="prefix">
+                              <object class="GtkLabel">
+                                <property name="label" translatable="yes">Password</property>
+                                <property name="xalign">1</property>
                                 <property name="visible">True</property>
-                                <property name="can_focus">False</property>
-                                <child type="prefix">
-                                  <object class="GtkLabel">
-                                    <property name="label" translatable="no">User ID</property>
-                                    <property name="xalign">1</property>
-                                    <property name="visible">True</property>
-                                    <property name="halign">start</property>
-                                  </object>
-                                </child>
-                                <child type="action">
-                                  <object class="GtkEntry" id="new_account_id_entry">
-                                    <property name="activates_default">True</property>
-                                    <property name="hexpand">False</property>
-                                    <property name="visible">True</property>
-                                    <property name="halign">end</property>
-                                    <property name="valign">center</property>
-                                    <signal name="changed" handler="settings_account_id_changed_cb" swapped="yes"/>
-                                  </object>
-                                </child>
-                              </object>
-                            </child>
-                            <child>
-                              <object class="HdyActionRow">
-                                <property name="selectable">False</property>
-                                <property name="activatable">False</property>
-                                <property name="visible" bind-source="server_url_entry" bind-property="visible" bind-flags="sync-create"/>
-                                <property name="can_focus">False</property>
-                                <child type="prefix">
-                                  <object class="GtkLabel">
-                                    <property name="label" translatable="yes">Provider</property>
-                                    <property name="xalign">1</property>
-                                    <property name="visible">True</property>
-                                    <property name="halign">start</property>
-                                  </object>
-                                </child>
-                                <child type="action">
-                                  <object class="GtkEntry" id="server_url_entry">
-                                    <property name="activates_default">True</property>
-                                    <property name="hexpand">False</property>
-                                    <property name="visible">False</property>
-                                    <property name="halign">end</property>
-                                    <property name="valign">center</property>
-                                  </object>
-                                </child>
+                                <property name="halign">start</property>
                               </object>
                             </child>
                             <child>
-                              <object class="HdyActionRow">
-                                <property name="selectable">False</property>
-                                <property name="activatable">False</property>
+                              <object class="GtkEntry" id="new_password_entry">
                                 <property name="visible">True</property>
-                                <property name="can_focus">False</property>
-                                <child type="prefix">
-                                  <object class="GtkLabel">
-                                    <property name="label" translatable="yes">Password</property>
-                                    <property name="xalign">1</property>
-                                    <property name="visible">True</property>
-                                    <property name="halign">start</property>
-                                  </object>
-                                </child>
-                                <child type="action">
-                                  <object class="GtkEntry" id="new_password_entry">
-                                    <property name="visible">True</property>
-                                    <property name="halign">end</property>
-                                    <property name="valign">center</property>
-                                    <property name="input_purpose">password</property>
-                                    <property name="activates_default">True</property>
-                                    <property name="hexpand">False</property>
-                                    <property name="visibility">False</property>
-                                    <property name="primary_icon_sensitive">False</property>
-                                    <property name="secondary_icon_activatable">True</property>
-                                    <property name="secondary_icon_name">eye-not-looking-symbolic</property>
-                                    <property name="secondary_icon_sensitive">True</property>
-                                    <signal name="icon-press" handler="settings_pw_entry_icon_clicked_cb" swapped="yes"/>
-                                  </object>
-                                </child>
+                                <property name="halign">end</property>
+                                <property name="valign">center</property>
+                                <property name="input_purpose">password</property>
+                                <property name="activates_default">True</property>
+                                <property name="hexpand">False</property>
+                                <property name="visibility">False</property>
+                                <property name="primary_icon_sensitive">False</property>
+                                <property name="secondary_icon_activatable">True</property>
+                                <property name="secondary_icon_name">eye-not-looking-symbolic</property>
+                                <property name="secondary_icon_sensitive">True</property>
+                                <signal name="icon-press" handler="settings_pw_entry_icon_clicked_cb" swapped="yes"/>
                               </object>
                             </child>
                           </object>
@@ -748,7 +679,6 @@
                 <property name="name">add-account-view</property>
               </packing>
             </child>
-
           </object>
         </child>
 
diff -pruN 0.1.17-1/src/ui/chatty-window.ui 0.2.0-1/src/ui/chatty-window.ui
--- 0.1.17-1/src/ui/chatty-window.ui	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/ui/chatty-window.ui	2020-11-27 09:44:20.000000000 +0000
@@ -1,7 +1,6 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <interface>
   <requires lib="gtk+" version="3.16"/>
-  <requires lib="libhandy" version="0.0"/>
   <object class="GtkPopoverMenu" id="header_view_chat_list_popover">
     <property name="can_focus">False</property>
     <child>
@@ -212,11 +211,8 @@
         <child>
           <object class="HdyLeaflet" id="header_box">
             <property name="visible">True</property>
-            <property name="mode-transition-type">slide</property>
-            <property name="child-transition-type">slide</property>
             <property name="visible-child-name" bind-source="content_box" bind-property="visible-child-name" bind-flags="sync-create"/>
-            <signal name="notify::visible-child" handler="header_visible_child_cb" swapped="no"/>
-            <signal name="notify::fold" handler="notify_fold_cb" after="yes" swapped="no"/>
+            <signal name="notify::folded" handler="notify_fold_cb" after="yes" swapped="no"/>
             <child>
               <object class="GtkHeaderBar" id="header_bar">
                 <property name="visible">True</property>
@@ -397,8 +393,7 @@
       <object class="HdyLeaflet" id="content_box">
         <property name="visible">True</property>
         <property name="can_focus">False</property>
-        <property name="mode_transition_type">slide</property>
-        <property name="child_transition_type">slide</property>
+        <property name="transition-type">slide</property>
         <child>
           <object class="GtkScrolledWindow" id="sidebar">
             <property name="hscrollbar_policy">never</property>
@@ -495,10 +490,9 @@
                         <property name="show-close-button">False</property>
                         <property name="search-mode-enabled">False</property>
                         <child>
-                          <object class="HdyColumn">
+                          <object class="HdyClamp">
                             <property name="visible">True</property>
                             <property name="hexpand">True</property>
-                            <property name="maximum-width">600</property>
                             <child>
                               <object class="GtkSearchEntry" id="chats_search_entry">
                                 <property name="visible">True</property>
@@ -572,6 +566,7 @@
     </widgets>
   </object>
   <object class="HdyHeaderGroup" id="header_group">
+    <property name="decorate-all" bind-source="content_box" bind-property="folded" bind-flags="sync-create"/>
     <headerbars>
       <headerbar name="header_bar"/>
       <headerbar name="sub_header_bar"/>
diff -pruN 0.1.17-1/src/users/chatty-contact.c 0.2.0-1/src/users/chatty-contact.c
--- 0.1.17-1/src/users/chatty-contact.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/users/chatty-contact.c	2020-11-27 09:44:20.000000000 +0000
@@ -49,7 +49,6 @@ struct _ChattyContact
 G_DEFINE_TYPE (ChattyContact, chatty_contact, CHATTY_TYPE_ITEM)
 
 
-/* Always assume it’s a phone number, we create only such contacts */
 static ChattyProtocol
 chatty_contact_get_protocols (ChattyItem *item)
 {
@@ -57,7 +56,10 @@ chatty_contact_get_protocols (ChattyItem
 
   g_assert (CHATTY_IS_CONTACT (self));
 
-  return self->protocol;
+  if (self->protocol != CHATTY_PROTOCOL_NONE)
+    return self->protocol;
+
+  return CHATTY_ITEM_CLASS (chatty_contact_parent_class)->get_protocols (item);
 }
 
 
diff -pruN 0.1.17-1/src/users/chatty-item.c 0.2.0-1/src/users/chatty-item.c
--- 0.1.17-1/src/users/chatty-item.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/users/chatty-item.c	2020-11-27 09:44:20.000000000 +0000
@@ -246,7 +246,7 @@ chatty_item_class_init (ChattyItemClass
                       CHATTY_PROTOCOL_NONE,
                       CHATTY_PROTOCOL_LAST,
                       CHATTY_PROTOCOL_NONE,
-                      G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_STATIC_STRINGS);
+                      G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS);
 
   g_object_class_install_properties (object_class, N_PROPS, properties);
 
diff -pruN 0.1.17-1/src/users/chatty-pp-buddy.c 0.2.0-1/src/users/chatty-pp-buddy.c
--- 0.1.17-1/src/users/chatty-pp-buddy.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/users/chatty-pp-buddy.c	2020-11-27 09:44:20.000000000 +0000
@@ -186,6 +186,9 @@ chatty_pp_buddy_get_name (ChattyItem *it
 
   g_assert (CHATTY_IS_PP_BUDDY (self));
 
+  if (self->contact)
+    return chatty_item_get_name (CHATTY_ITEM (self->contact));
+
   if (self->chat_buddy) {
     const char *name;
 
@@ -566,7 +569,8 @@ chatty_pp_buddy_set_contact (ChattyPpBud
   g_return_if_fail (CHATTY_IS_PP_BUDDY (self));
   g_return_if_fail (!contact || CHATTY_IS_CONTACT (contact));
 
-  g_set_object (&self->contact, contact);
+  if (g_set_object (&self->contact, contact))
+    g_object_notify (G_OBJECT (self), "name");
 }
 
 
diff -pruN 0.1.17-1/src/xeps/chatty-xep-0313.c 0.2.0-1/src/xeps/chatty-xep-0313.c
--- 0.1.17-1/src/xeps/chatty-xep-0313.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/src/xeps/chatty-xep-0313.c	2020-11-27 09:44:20.000000000 +0000
@@ -18,6 +18,7 @@
 #include "chatty-xep-0313.h"
 #include "chatty-utils.h"
 #include "chatty-history.h"
+#include "chatty-pp-chat.h"
 #include "chatty-manager.h"
 #include "chatty-settings.h"
 
@@ -28,6 +29,7 @@
 #define NS_RSM "http://jabber.org/protocol/rsm"
 
 typedef struct {
+  PurpleConversation *conv;
   PurpleConvMessage p;
   char *id;
   PurpleConversationType type;
@@ -563,10 +565,12 @@ cb_chatty_mam_enabled_notify (GObject *o
  *
  */
 static void
-cb_chatty_mam_msg_wrote(PurpleAccount *pa, PurpleConvMessage *pcm,
+cb_chatty_mam_msg_wrote(PurpleConversation *conv,
+                        PurpleConvMessage *pcm,
                         char **uuid, PurpleConversationType type,
                         void *ctx)
 {
+  PurpleAccount *pa = conv->account;
   MamCtx *mamc = chatty_mam_ctx_get(pa);
   if(mamc == NULL)
     return;
@@ -594,6 +598,7 @@ cb_chatty_mam_msg_wrote(PurpleAccount *p
     mamc->cur_msg->p.flags = pcm->flags;
     pcm->flags |= PURPLE_MESSAGE_NO_LOG;
   }
+  mamc->cur_msg->conv = conv;
   mamc->cur_msg->type = type;
   mamc->cur_msg->p.alias = g_strdup(pcm->alias);
   mamc->cur_msg->p.when = pcm->when;
@@ -766,9 +771,33 @@ cb_chatty_mam_msg_received (PurpleConnec
   jabber_message_parse (js, message);
   if(stanza_id != NULL || mamc->cur_msg->p.what != NULL) {
     PurpleConvMessage *pcm = &(mamc->cur_msg->p);
-
-    chatty_history_add_message (pc->account->username, pcm->alias, pcm->who, pcm->what,
-                                (char**)&stanza_id, pcm->flags, pcm->when,  mamc->cur_msg->type);
+    PurpleConversation *conv = mamc->cur_msg->conv;
+    g_autoptr(ChattyMessage) chat_message = NULL;
+    g_autofree char *who = NULL;
+
+    if (!conv)
+      conv = purple_find_conversation_with_account (PURPLE_CONV_TYPE_ANY,
+                                                    pcm->alias ? pcm->alias : pcm->who,
+                                                    pc->account);
+
+    /* conv shall be missing only for IM chats */
+    if (!conv && !pcm->alias)
+        conv = purple_conversation_new (PURPLE_CONV_TYPE_IM,
+                                        pc->account, pcm->who);
+    if (pcm->who) {
+      if (chatty_chat_is_im (conv->ui_data) ||
+          !g_str_has_prefix (pcm->who, conv->name))
+        who = chatty_utils_jabber_id_strip (pcm->who);
+    }
+
+    if (!stanza_id)
+      stanza_id = g_uuid_string_random ();
+
+    chat_message = chatty_message_new (NULL, NULL, pcm->what, stanza_id, pcm->when,
+                                       chatty_utils_direction_from_flag (pcm->flags), 0);
+    if (chat_message && pcm->who && !(flags & PURPLE_MESSAGE_SEND))
+      chatty_message_set_user_name (chat_message, who ? who : pcm->who);
+    chatty_history_add_message (conv->ui_data, chat_message);
   }
   // Update last timestamp for account's archive
   if(mamq != NULL && mamq->to == NULL)
diff -pruN 0.1.17-1/tests/history.c 0.2.0-1/tests/history.c
--- 0.1.17-1/tests/history.c	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/tests/history.c	2020-11-27 09:44:20.000000000 +0000
@@ -21,35 +21,22 @@
 #include <sqlite3.h>
 
 #include "purple-init.h"
+#include "chatty-settings.h"
+#include "chatty-utils.h"
 #include "chatty-history.h"
 
 typedef struct Message {
   ChattyChat *chat;
+  ChattyMessage *message;
   char *account;
   char *room;
   char *who;
   char *what;
   char *uuid;
   PurpleMessageFlags flags;
-  PurpleConversationType type;
   time_t when;
 } Message;
 
-static ChattyMsgDirection
-chatty_direction_for_flag (PurpleMessageFlags flag)
-{
-  if (flag & PURPLE_MESSAGE_RECV)
-    return CHATTY_DIRECTION_IN;
-
-  if (flag & PURPLE_MESSAGE_SEND)
-    return CHATTY_DIRECTION_OUT;
-
-  if (flag & PURPLE_MESSAGE_SYSTEM)
-    return CHATTY_DIRECTION_SYSTEM;
-
-  g_return_val_if_reached (CHATTY_DIRECTION_SYSTEM);
-}
-
 static PurpleMessageFlags
 flag_for_direction (int direction)
 {
@@ -70,6 +57,7 @@ free_message (Message *msg)
 {
   g_assert_true (msg);
   g_clear_object (&msg->chat);
+  g_clear_object (&msg->message);
   g_free (msg->account);
   g_free (msg->who);
   g_free (msg->what);
@@ -112,6 +100,139 @@ finish_bool_cb (GObject      *object,
   g_task_return_boolean (task, status);
 }
 
+static int
+history_db_get_int (sqlite3    *db,
+                    const char *statement)
+{
+  sqlite3_stmt *stmt;
+  int value, status;
+
+  g_assert (db);
+
+  status = sqlite3_prepare_v2 (db, statement, -1, &stmt, NULL);
+  g_assert_cmpint (status, ==, SQLITE_OK);
+
+  status = sqlite3_step (stmt);
+  g_assert_cmpint (status, ==, SQLITE_ROW);
+
+  value = sqlite3_column_int (stmt, 0);
+
+  sqlite3_finalize (stmt);
+
+  return value;
+}
+
+static void
+compare_table (sqlite3    *db,
+               const char *sql,
+               int         expected_count,
+               int         count)
+{
+  sqlite3_stmt *stmt;
+  int status;
+
+  status = sqlite3_prepare_v2 (db, sql, -1, &stmt, NULL);
+  if (status != SQLITE_OK)
+    g_warning ("sql: %s", sql);
+
+  g_assert_cmpint (status, ==, SQLITE_OK);
+
+  if (expected_count != count)
+    g_warning ("%d %d sql: %s", expected_count, count, sql);
+  status = sqlite3_step (stmt);
+  g_assert_cmpint (status, ==, SQLITE_ROW);
+  g_assert_cmpint (expected_count, ==, count);
+
+  count = sqlite3_column_int (stmt, 0);
+  if (expected_count != count)
+    g_warning ("%d %d sql: %s", expected_count, count, sql);
+
+  g_assert_cmpint (expected_count, ==, count);
+
+  sqlite3_finalize (stmt);
+}
+
+static void
+compare_history_db (sqlite3 *db)
+{
+  /* Pragma version should match */
+  g_assert_cmpint (history_db_get_int (db, "PRAGMA main.user_version;"), ==,
+                   history_db_get_int (db, "PRAGMA test.user_version;"));
+
+  /* Each db should have the same count of table rows */
+  g_assert_cmpint (history_db_get_int (db, "SELECT COUNT(*) FROM main.sqlite_master;"),
+                   ==,
+                   history_db_get_int (db, "SELECT COUNT(*) FROM test.sqlite_master;"));
+
+  /* As duplicate rows are removed, SELECT count should match the size of one table. */
+  compare_table (db,
+                 "SELECT COUNT (*) FROM ("
+                 "SELECT username,alias,type FROM main.users "
+                 "UNION "
+                 "SELECT username,alias,type FROM test.users "
+                 ");",
+                 history_db_get_int (db, "SELECT COUNT(*) FROM main.users;"),
+                 history_db_get_int (db, "SELECT COUNT(*) FROM test.users;"));
+
+  /* sqlite doesn't guarantee `id` to be always incremented by one.  It
+   * may depend on the order they are updated in chatty-history.  And so
+   * compare by values.
+   */
+  compare_table (db,
+                 "SELECT COUNT (*) FROM ("
+                 "SELECT username,protocol FROM main.accounts "
+                 "INNER JOIN main.users ON users.id=accounts.user_id "
+                 "UNION "
+                 "SELECT username,protocol  FROM test.accounts "
+                 "INNER JOIN test.users ON users.id=accounts.user_id "
+                 ");",
+                 history_db_get_int (db, "SELECT COUNT(*) FROM main.accounts;"),
+                 history_db_get_int (db, "SELECT COUNT(*) FROM test.accounts;"));
+
+  compare_table (db,
+                 "SELECT COUNT (*) FROM ("
+                 "SELECT name,threads.alias,users.username,protocol,threads.type FROM main.threads "
+                 "INNER JOIN main.accounts ON accounts.id=threads.account_id "
+                 "INNER JOIN main.users ON users.id=accounts.user_id "
+                 "UNION "
+                 "SELECT name,threads.alias,users.username,protocol,threads.type FROM test.threads "
+                 "INNER JOIN test.accounts ON accounts.id=threads.account_id "
+                 "INNER JOIN test.users ON users.id=accounts.user_id "
+                 ");",
+                 history_db_get_int (db, "SELECT COUNT(*) FROM main.threads;"),
+                 history_db_get_int (db, "SELECT COUNT(*) FROM test.threads;"));
+
+  compare_table (db,
+                 "SELECT COUNT (*) FROM ("
+                 "SELECT threads.name,a.username,u.username FROM main.thread_members "
+                 "INNER JOIN main.users AS u ON u.id=thread_members.user_id "
+                 "INNER JOIN main.threads ON threads.id=thread_id "
+                 "INNER JOIN main.accounts ON accounts.id=threads.account_id "
+                 "INNER JOIN main.users As a ON a.id=accounts.user_id "
+                 "UNION "
+                 "SELECT threads.name,a.username,u.username FROM test.thread_members "
+                 "INNER JOIN test.users AS u ON u.id=thread_members.user_id "
+                 "INNER JOIN test.threads ON threads.id=thread_id "
+                 "INNER JOIN test.accounts ON accounts.id=threads.account_id "
+                 "INNER JOIN test.users As a ON a.id=accounts.user_id "
+                 ");",
+                 history_db_get_int (db, "SELECT COUNT(*) FROM main.thread_members;"),
+                 history_db_get_int (db, "SELECT COUNT(*) FROM test.thread_members;"));
+
+  compare_table (db,
+                 "SELECT COUNT (*) FROM ("
+                 "SELECT uid,threads.name,users.username,body,body_type,direction,time FROM main.messages "
+                 "LEFT JOIN main.users ON users.id=sender_id "
+                 "INNER JOIN main.threads ON threads.id=thread_id "
+                 "UNION "
+                 "SELECT uid,threads.name,users.username,body,body_type,direction,time FROM test.messages "
+                 "LEFT JOIN test.users ON users.id=sender_id "
+                 "INNER JOIN test.threads ON threads.id=thread_id "
+                 ");",
+                 history_db_get_int (db, "SELECT COUNT(*) FROM main.messages;"),
+                 history_db_get_int (db, "SELECT COUNT(*) FROM test.messages;"));
+}
+
 static Message *
 new_message (const char         *account,
              const char         *buddy,
@@ -121,11 +242,21 @@ new_message (const char         *account
              time_t              time_stamp,
              const char         *room)
 {
+  g_autoptr(ChattyContact) contact = NULL;
   ChattyChat *chat;
   Message *message;
+  ChattyMsgDirection direction = CHATTY_DIRECTION_UNKNOWN;
 
+  direction = chatty_utils_direction_from_flag (flags);
   chat = chatty_chat_new (account, room ? room : buddy, room == NULL);
+  g_object_set (G_OBJECT (chat), "protocols", CHATTY_PROTOCOL_XMPP, NULL);
   message = g_new (Message, 1);
+  contact = g_object_new (CHATTY_TYPE_CONTACT,
+                          "protocols", CHATTY_PROTOCOL_XMPP,
+                          NULL);
+  chatty_contact_set_value (contact, buddy);
+  message->message = chatty_message_new (CHATTY_ITEM (contact), NULL, msg_text,
+                                         uuid, time_stamp, direction, 0);
   message->account = g_strdup (account);
   message->who = g_strdup (buddy);
   message->what = g_strdup (msg_text);
@@ -150,7 +281,7 @@ compare_message (Message       *message,
   if (message == NULL)
     return;
 
-  direction = chatty_direction_for_flag (message->flags);
+  direction = chatty_utils_direction_from_flag (message->flags);
   g_assert_cmpstr (message->what, ==, chatty_message_get_text (chatty_message));
   g_assert_cmpstr (message->uuid, ==, chatty_message_get_uid (chatty_message));
   g_assert_cmpint (message->when, ==, chatty_message_get_time (chatty_message));
@@ -229,20 +360,17 @@ add_message (ChattyHistory      *history
   GTask *task;
   char *uid;
   int time_stamp;
-  PurpleConversationType type;
   gboolean success;
 
   g_assert_true (CHATTY_IS_HISTORY (history));
   g_assert_nonnull (account);
 
-  if (room)
-    type = PURPLE_CONV_TYPE_CHAT;
-  else
-    type = PURPLE_CONV_TYPE_IM;
+  if (!uuid)
+    uuid = g_uuid_string_random ();
 
   uid = g_strdup (uuid);
   msg = new_message (account, who, message, uid, flags, when, room);
-  success = chatty_history_add_message (account, room, who, message, &uid, flags, when, type);
+  success = chatty_history_add_message (msg->chat, msg->message);
   g_assert_true (success);
   g_assert_nonnull (uid);
   g_ptr_array_add (test_msg_array, msg);
@@ -261,7 +389,7 @@ add_message (ChattyHistory      *history
   g_assert_nonnull (msg_array);
   g_assert_cmpint (test_msg_array->len, ==, msg_array->len);
 
-  if (type == PURPLE_CONV_TYPE_CHAT) {
+  if (!chatty_chat_is_im (msg->chat)) {
     g_assert_true (chatty_history_chat_exists (account, room));
 
     time_stamp = chatty_history_get_chat_timestamp (uid, room);
@@ -405,6 +533,7 @@ test_history_message (void)
   who = "buddy@example.org";
   chat = chatty_chat_new (account, who, TRUE);
   g_assert (CHATTY_IS_CHAT (chat));
+  g_object_set (G_OBJECT (chat), "protocols", CHATTY_PROTOCOL_XMPP, NULL);
 
   when = time (NULL);
   add_chatty_message (history, chat, msg_array, "Random message", when, CHATTY_DIRECTION_OUT, 0);
@@ -419,6 +548,7 @@ test_history_message (void)
 
   chat = chatty_chat_new (account, who, FALSE);
   g_assert (CHATTY_IS_CHAT (chat));
+  g_object_set (G_OBJECT (chat), "protocols", CHATTY_PROTOCOL_XMPP, NULL);
   add_chatty_message (history, chat, msg_array, "Random message", when, CHATTY_DIRECTION_SYSTEM, 0);
   add_chatty_message (history, chat, msg_array, "Another message", when + 1, CHATTY_DIRECTION_IN, 0);
   add_chatty_message (history, chat, msg_array, "And more message", when + 1, CHATTY_DIRECTION_IN, 0);
@@ -454,7 +584,7 @@ test_history_raw_message (void)
   when = time (NULL);
 
   add_message (history, msg_array, account, room, who, uuid,
-               "Random message", when, PURPLE_MESSAGE_SYSTEM);
+               "Random message", when, PURPLE_MESSAGE_SYSTEM | PURPLE_MESSAGE_RECV);
   g_clear_pointer (&uuid, g_free);
   g_ptr_array_free (msg_array, TRUE);
 
@@ -587,7 +717,6 @@ test_value (sqlite3    *db,
   g_autofree char *uuid = NULL;
   sqlite3_stmt *stmt;
   int status, time_stamp;
-  PurpleConversationType type;
   PurpleMessageFlags flags;
 
   status = sqlite3_prepare_v2 (db, statement, -1, &stmt, NULL);
@@ -596,16 +725,24 @@ test_value (sqlite3    *db,
   uuid = g_uuid_string_random ();
   time_stamp = time (NULL) + g_random_int_range (1, 1000);
 
-  if (room)
-    type = PURPLE_CONV_TYPE_CHAT;
-  else
-    type = PURPLE_CONV_TYPE_IM;
-
   flags = flag_for_direction (direction);
   if (statement_status == SQLITE_ROW) {
+    g_autoptr(ChattyChat) chat = NULL;
+    g_autoptr(ChattyMessage) chat_message = NULL;
+    ChattyMsgDirection chat_direction;
     gboolean success;
 
-    success = chatty_history_add_message (account, room, who, message, &uuid, flags, time_stamp, type);
+    chat = chatty_chat_new (account, room ? room : who, room == NULL);
+    g_object_set (G_OBJECT (chat), "protocols", CHATTY_PROTOCOL_XMPP, NULL);
+
+    if (!uuid)
+      uuid = g_uuid_string_random ();
+
+    chat_direction = chatty_utils_direction_from_flag (flags);
+    chat_message = chatty_message_new (NULL, NULL, message, uuid, time_stamp, chat_direction, 0);
+    if (chat_direction != CHATTY_DIRECTION_OUT)
+      chatty_message_set_user_name (chat_message, who);
+    success = chatty_history_add_message (chat, chat_message);
     g_assert_true (success);
   }
 
@@ -613,18 +750,26 @@ test_value (sqlite3    *db,
   g_assert_cmpint (status, ==, statement_status);
 
   if (statement_status != SQLITE_ROW)
-    return;
+    goto end;
 
   g_assert_cmpint (id, ==, sqlite3_column_int (stmt, 0));
-  g_assert_cmpint (time_stamp, ==, sqlite3_column_int (stmt, 1));
-  g_assert_cmpint (direction, ==, sqlite3_column_int (stmt, 2));
-  g_assert_cmpstr (account, ==, (char *)sqlite3_column_text (stmt, 3));
-  g_assert_cmpstr (who, ==, (char *)sqlite3_column_text (stmt, 4));
-  g_assert_cmpstr (uuid, ==, (char *)sqlite3_column_text (stmt, 5));
-  g_assert_cmpstr (message, ==, (char *)sqlite3_column_text (stmt, 6));
+  g_assert_cmpstr (uuid, ==, (char *)sqlite3_column_text (stmt, 1));
+  g_assert_cmpstr (message, ==, (char *)sqlite3_column_text (stmt, 2));
+  g_assert_cmpint (direction, ==, sqlite3_column_int (stmt, 3));
+  g_debug ("%s %s", sqlite3_column_text (stmt, 4), sqlite3_column_text (stmt, 5));
+  g_assert_cmpstr (account, ==, (char *)sqlite3_column_text (stmt, 4));
+
+  if (direction == -1)
+    g_assert_cmpstr (account, ==, (char *)sqlite3_column_text (stmt, 5));
+  else
+    g_assert_cmpstr (who, ==, (char *)sqlite3_column_text (stmt, 5));
+
   if (room)
-    g_assert_cmpstr (room, ==, (char *)sqlite3_column_text (stmt, 7));
+    g_assert_cmpstr (room, ==, (char *)sqlite3_column_text (stmt, 6));
+  else
+    g_assert_cmpstr (who, ==, (char *)sqlite3_column_text (stmt, 6));
 
+ end:
   sqlite3_finalize (stmt);
 }
 
@@ -632,6 +777,7 @@ static void
 test_history_db (void)
 {
   const char *file_name, *account, *who, *message, *room;
+  const char *statement;
   sqlite3 *db;
   int status;
 
@@ -649,34 +795,127 @@ test_history_db (void)
   message = "Random messsage";
   room = "room@test";
 
-  test_value (db, "SELECT id,timestamp,direction,account,who,uid,message FROM chatty_im LIMIT 1",
-              SQLITE_DONE, 0, 0, NULL, NULL, NULL, NULL);
-  test_value (db, "SELECT id,timestamp,direction,account,who,uid,message FROM chatty_chat LIMIT 1",
-              SQLITE_DONE, 0, 0, NULL, NULL, NULL, NULL);
-  test_value (db, "SELECT max(id),timestamp,direction,account,who,uid,message FROM chatty_im LIMIT 1",
-              SQLITE_ROW, 1, -1, account, who, message, NULL);
-  test_value (db, "SELECT id,timestamp,direction,account,who,uid,message FROM chatty_chat LIMIT 1",
-              SQLITE_DONE, 0, 0, NULL, NULL, NULL, NULL);
-  test_value (db, "SELECT max(id),timestamp,direction,account,who,uid,message FROM chatty_im LIMIT 1",
-              SQLITE_ROW, 2, -1, account, who, message, NULL);
-  test_value (db, "SELECT max(id),timestamp,direction,account,who,uid,message,room FROM chatty_chat LIMIT 1",
-              SQLITE_ROW, 1, -1, account, who, message, room);
-  test_value (db, "SELECT max(id),timestamp,direction,account,who,uid,message,room FROM chatty_chat LIMIT 1",
-              SQLITE_ROW, 2, -1, account, who, message, room);
+  statement = "SELECT max(messages.id),uid,body,direction,a.username,s.username,threads.name "
+    "FROM messages "
+    "INNER JOIN threads "
+    "ON threads.id=thread_id "
+    "INNER JOIN accounts "
+    "ON threads.account_id=accounts.id "
+    "INNER JOIN users as a "
+    "ON accounts.user_id=a.id "
+    "INNER JOIN users as s "
+    "ON sender_id=s.id;";
+
+  test_value (db, statement, SQLITE_ROW, 1, -1, account, who, message, NULL);
+  test_value (db, statement, SQLITE_ROW, 2, 1, account, who, message, NULL);
+  test_value (db, statement, SQLITE_ROW, 3, -1, account, who, message, room);
+  test_value (db, statement, SQLITE_ROW, 4, 1, account, who, message, room);
 
+  sqlite3_close (db);
   chatty_history_close ();
 }
 
+static void
+export_sql_file (const char  *sql_path,
+                 const char  *file_name,
+                 sqlite3    **db)
+{
+  g_autofree char *export_file = NULL;
+  g_autofree char *input_file = NULL;
+  g_autofree char *content = NULL;
+  g_autoptr(GError) err = NULL;
+  char *error = NULL;
+  int status;
+
+  g_assert (sql_path && *sql_path);
+  g_assert (file_name && *file_name);
+  g_assert (db);
+
+  input_file = g_build_filename (sql_path, file_name, NULL);
+  export_file = g_test_build_filename (G_TEST_BUILT, file_name, NULL);
+  strcpy (export_file + strlen (export_file) - strlen ("sql"), "db");
+  g_remove (export_file);
+  status = sqlite3_open (export_file, db);
+  g_assert_cmpint (status, ==, SQLITE_OK);
+  g_file_get_contents (input_file, &content, NULL, &err);
+  g_assert_no_error (err);
+
+  status = sqlite3_exec (*db, content, NULL, NULL, &error);
+  if (error)
+    g_warning ("%s error: %s", G_STRLOC, error);
+  g_assert_cmpint (status, ==, SQLITE_OK);
+}
+
+static void
+test_history_migration_db (void)
+{
+  g_autoptr(GDir) dir = NULL;
+  g_autofree char *path = NULL;
+  g_autoptr(GError) error = NULL;
+  const char *name;
+
+  path = g_test_build_filename (G_TEST_DIST, "history-db", NULL);
+  dir = g_dir_open (path, 0, &error);
+  g_assert_no_error (error);
+
+  while ((name = g_dir_read_name (dir)) != NULL) {
+    g_autofree char *expected_file = NULL;
+    g_autofree char *input_file = NULL;
+    g_autofree char *input = NULL;
+    sqlite3 *db = NULL;
+    int status;
+
+    if (g_str_has_suffix (name, "v1.db"))
+      continue;
+
+    g_assert_true (g_str_has_suffix (name, "sql"));
+
+    if (strstr (name, "DE"))
+      chatty_settings_set_country_iso_code (chatty_settings_get_default (), "DE");
+    else if (strstr (name, "IN"))
+      chatty_settings_set_country_iso_code (chatty_settings_get_default (), "IN");
+    else
+      chatty_settings_set_country_iso_code (chatty_settings_get_default (), "US");
+
+    /* Export old version sql file */
+    export_sql_file (path, name, &db);
+    sqlite3_close (db);
+
+    /* Export migrated version sql file */
+    expected_file = g_strdelimit (g_strdup (name), "0", '1');
+    export_sql_file (path, expected_file, &db);
+
+    /* Open history with old db, which will result in db migration */
+    input_file = g_strdup (name);
+    strcpy (input_file + strlen (input_file) - strlen ("sql"), "db");
+    chatty_history_open (g_test_get_dir (G_TEST_BUILT), input_file);
+    chatty_history_close ();
+    g_free (input_file);
+
+    /* Attach old (now migrated) db with expected migrated db */
+    input_file = g_test_build_filename (G_TEST_BUILT, name, NULL);
+    strcpy (input_file + strlen (input_file) - strlen ("sql"), "db");
+    input = g_strconcat ("ATTACH '", input_file, "' as test;", NULL);
+    status = sqlite3_exec (db, input, NULL, NULL, NULL);
+    g_assert_cmpint (status, ==, SQLITE_OK);
+
+    compare_history_db (db);
+    sqlite3_close (db);
+  }
+}
+
 int
 main (int   argc,
       char *argv[])
 {
   g_test_init (&argc, &argv, NULL);
+  g_setenv ("GSETTINGS_BACKEND", "memory", TRUE);
 
   g_test_add_func ("/history/new", test_history_new);
   g_test_add_func ("/history/message", test_history_message);
   g_test_add_func ("/history/raw_message", test_history_raw_message);
   g_test_add_func ("/history/db", test_history_db);
+  g_test_add_func ("/history/db_migration", test_history_migration_db);
 
   return g_test_run ();
 }
diff -pruN 0.1.17-1/tests/history-db/empty-v0.sql 0.2.0-1/tests/history-db/empty-v0.sql
--- 0.1.17-1/tests/history-db/empty-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/empty-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,26 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/empty-v1.sql 0.2.0-1/tests/history-db/empty-v1.sql
--- 0.1.17-1/tests/history-db/empty-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/empty-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,71 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/matrix-v0.sql 0.2.0-1/tests/history-db/matrix-v0.sql
--- 0.1.17-1/tests/history-db/matrix-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/matrix-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,36 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_chat VALUES(NULL,1586447316,1,'@alice:example.com','!VPWUCfyJyeVMxiHYGi:example.com','@bob:example.com','12107bfc-0f91-11eb-8501-2314b53187d5','Hi');
+INSERT INTO chatty_chat VALUES(NULL,1586447319,1,'@alice:example.com','!VPWUCfyJyeVMxiHYGi:example.com','@bob:example.com','2a5f6c4a-0f91-11eb-af2c-27e3777f4483','Are you there?');
+INSERT INTO chatty_chat VALUES(NULL,1586447320,1,'@bob:example.org','!CDFTfyJgtVMvsXDEi:example.com',NULL,'10600c18-ecc1-4d42-8f0a-5c5e563b1b3d','Another empty author message');
+INSERT INTO chatty_chat VALUES(NULL,1586447421,-1,'alice','!VPWUCfyJyeVMxiHYGi:example.com','@alice:example.com','3a383ec7-7566-457b-b561-2145b328459c','Why?');
+INSERT INTO chatty_chat VALUES(NULL,1586447419,-1,'@alice:example.com','!VPWUCfyJyeVMxiHYGi:example.com','@alice:example.com','6b67fa36-0f91-11eb-9714-af849160d937','Hi');
+INSERT INTO chatty_chat VALUES(NULL,1586448429,1,'@bob:example.org','!CDFTfyJgtVMvsXDEi:example.com','@alice:example.com','c73bbcbc-0f91-11eb-aab2-8b95affe5e24','Test');
+INSERT INTO chatty_chat VALUES(NULL,1586448432,1,'@bob:example.org','!CDFTfyJgtVMvsXDEi:example.com','@charlie:example.com','1dc29876-0f92-11eb-aeb4-d7486be58053','Failed');
+INSERT INTO chatty_chat VALUES(NULL,1586448435,1,'@alice:example.com','!CDFTfyJgtVMvsXDEi:example.com','@_freenode_hunter2:example.com','414d35fa-e50f-441f-a382-3cb8acd7a510','Weird.  All I see is *');
+INSERT INTO chatty_chat VALUES(NULL,1586448438,1,'@alice:example.com','!CDFTfyJgtVMvsXDEi:example.com',NULL,'f86768a5-d0fb-423c-9430-3d3b66d74a67','A message with no author');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/matrix-v1.sql 0.2.0-1/tests/history-db/matrix-v1.sql
--- 0.1.17-1/tests/history-db/matrix-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/matrix-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,104 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'alice',NULL,NULL,NULL,4);
+INSERT INTO users VALUES(4,'@charlie:example.com',NULL,NULL,NULL,4);
+INSERT INTO users VALUES(5,'@_freenode_hunter2:example.com',NULL,NULL,NULL,4);
+INSERT INTO users VALUES(7,'@bob:example.com',NULL,NULL,NULL,4);
+INSERT INTO users VALUES(8,'@bob:example.org',NULL,NULL,NULL,4);
+INSERT INTO users VALUES(9,'@alice:example.com',NULL,NULL,NULL,4);
+
+INSERT INTO accounts VALUES(3,3,NULL,0,4);
+INSERT INTO accounts VALUES(4,8,NULL,0,4);
+INSERT INTO accounts VALUES(5,9,NULL,0,4);
+
+INSERT INTO threads VALUES(1,'!CDFTfyJgtVMvsXDEi:example.com',NULL,4,1,0,NULL);
+INSERT INTO threads VALUES(2,'!CDFTfyJgtVMvsXDEi:example.com',NULL,5,1,0,NULL);
+INSERT INTO threads VALUES(3,'!VPWUCfyJyeVMxiHYGi:example.com',NULL,5,1,0,NULL);
+INSERT INTO threads VALUES(4,'!VPWUCfyJyeVMxiHYGi:example.com',NULL,3,1,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,4);
+INSERT INTO thread_members VALUES(2,1,9);
+INSERT INTO thread_members VALUES(3,2,5);
+INSERT INTO thread_members VALUES(4,3,7);
+INSERT INTO thread_members VALUES(5,3,9);
+INSERT INTO thread_members VALUES(6,4,9);
+
+INSERT INTO messages VALUES(NULL,'10600c18-ecc1-4d42-8f0a-5c5e563b1b3d',1,NULL,NULL,'Another empty author message',2,1,1586447320,NULL,0);
+INSERT INTO messages VALUES(NULL,'1dc29876-0f92-11eb-aeb4-d7486be58053',1,4,NULL,'Failed',2,1,1586448432,NULL,0);
+INSERT INTO messages VALUES(NULL,'c73bbcbc-0f91-11eb-aab2-8b95affe5e24',1,9,NULL,'Test',2,1,1586448429,NULL,0);
+INSERT INTO messages VALUES(NULL,'414d35fa-e50f-441f-a382-3cb8acd7a510',2,5,NULL,'Weird.  All I see is *',2,1,1586448435,NULL,0);
+INSERT INTO messages VALUES(NULL,'f86768a5-d0fb-423c-9430-3d3b66d74a67',2,NULL,NULL,'A message with no author',2,1,1586448438,NULL,0);
+INSERT INTO messages VALUES(NULL,'12107bfc-0f91-11eb-8501-2314b53187d5',3,7,NULL,'Hi',2,1,1586447316,NULL,0);
+INSERT INTO messages VALUES(NULL,'2a5f6c4a-0f91-11eb-af2c-27e3777f4483',3,7,NULL,'Are you there?',2,1,1586447319,NULL,0);
+INSERT INTO messages VALUES(NULL,'6b67fa36-0f91-11eb-9714-af849160d937',3,9,NULL,'Hi',2,-1,1586447419,NULL,0);
+INSERT INTO messages VALUES(NULL,'3a383ec7-7566-457b-b561-2145b328459c',4,9,NULL,'Why?',2,-1,1586447421,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-DE-v0.sql 0.2.0-1/tests/history-db/sms-DE-v0.sql
--- 0.1.17-1/tests/history-db/sms-DE-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-DE-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,41 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_im VALUES(NULL,1600074685,1,'SMS','+12133210011','259478cf-64b3-44e1-9b1c-5d1773edc601','Hi');
+INSERT INTO chatty_im VALUES(NULL,1600074687,-1,'SMS','+1 213 321 0011','af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d','How are you?');
+INSERT INTO chatty_im VALUES(NULL,1600074789,1,'SMS','+12133210011','1a1cbd44-7526-4032-9665-45aee085ab65','I''m fine');
+INSERT INTO chatty_im VALUES(NULL,1600074800,1,'SMS','Mobile@5G','601f2a66-e6a6-4083-9dce-e5d78fb57520','Get Unlimitted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600074802,1,'SMS','5555','4dafafd9-734c-4f86-b1ec-09aa327b8a88','Free unlimitted internet 4 99$');
+INSERT INTO chatty_im VALUES(NULL,1600074809,1,'SMS','Mobile@5G','271fe95c-5d47-4ffe-ae62-7f2f6b749711','Get Unlimmtted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600075652,1,'SMS','+919876121212','1218070f-c820-40e1-bd33-5099d894683a','Hello');
+INSERT INTO chatty_im VALUES(NULL,1600075658,-1,'SMS','+919876121212','9abcc777-5b06-4570-9b83-48603a49add2','Hi.');
+INSERT INTO chatty_im VALUES(NULL,1600075789,-1,'SMS','01511 2345678','c5b99952-5517-4620-8f28-fb97f5017cee','May I call you?');
+INSERT INTO chatty_im VALUES(NULL,1600075790,-1,'SMS','015112345678','fe352125-1772-4360-831e-e2d56bb73c73','Are you there?');
+INSERT INTO chatty_im VALUES(NULL,1600075791,-1,'SMS','+49 1511 2345678','c597bd6a-2e60-4df3-9c05-cc0c88861721','OK. Call me later');
+INSERT INTO chatty_im VALUES(NULL,1600075889,1,'SMS','0049 1511 2345678','f098e603-5ac1-4d5a-bcad-c7fe84c91252','Sure, you may call me');
+INSERT INTO chatty_im VALUES(NULL,1600075909,-1,'SMS','+919995123456','9d401342-3e30-4b25-859b-b56bd0ec2839','SMS to India');
+INSERT INTO chatty_im VALUES(NULL,1600075913,-1,'SMS','00919995123456','776a3885-5cb1-41ed-9423-dfe3d2ac772a','More SMS to India');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-DE-v1.sql 0.2.0-1/tests/history-db/sms-DE-v1.sql
--- 0.1.17-1/tests/history-db/sms-DE-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-DE-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,108 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+-- INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,2,NULL,'I''m fine',1,1,1600074789,NULL,0);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'+12133210011',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(4,'Mobile@5G',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(5,'5555',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(6,'+919876121212',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(7,'+919995123456',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(8,'+4915112345678',NULL,NULL,NULL,1);
+
+INSERT INTO threads VALUES(1,'+12133210011','+12133210011',1,0,0,NULL);
+INSERT INTO threads VALUES(2,'Mobile@5G','Mobile@5G',1,0,0,NULL);
+INSERT INTO threads VALUES(3,'5555','5555',1,0,0,NULL);
+INSERT INTO threads VALUES(4,'+919876121212','+919876121212',1,0,0,NULL);
+INSERT INTO threads VALUES(5,'+919995123456','+919995123456',1,0,0,NULL);
+INSERT INTO threads VALUES(6,'+4915112345678','01511 2345678',1,0,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,3);
+INSERT INTO thread_members VALUES(2,2,4);
+INSERT INTO thread_members VALUES(3,3,5);
+INSERT INTO thread_members VALUES(4,4,6);
+INSERT INTO thread_members VALUES(5,5,7);
+INSERT INTO thread_members VALUES(6,6,8);
+
+INSERT INTO messages VALUES(NULL,'259478cf-64b3-44e1-9b1c-5d1773edc601',1,3,NULL,'Hi',1,1,1600074685,NULL,0);
+INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,3,NULL,'I''m fine',1,1,1600074789,NULL,0);
+INSERT INTO messages VALUES(NULL,'af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d',1,3,NULL,'How are you?',1,-1,1600074687,NULL,0);
+INSERT INTO messages VALUES(NULL,'601f2a66-e6a6-4083-9dce-e5d78fb57520',2,4,NULL,'Get Unlimitted 5G',1,1,1600074800,NULL,0);
+INSERT INTO messages VALUES(NULL,'271fe95c-5d47-4ffe-ae62-7f2f6b749711',2,4,NULL,'Get Unlimmtted 5G',1,1,1600074809,NULL,0);
+INSERT INTO messages VALUES(NULL,'4dafafd9-734c-4f86-b1ec-09aa327b8a88',3,5,NULL,'Free unlimitted internet 4 99$',1,1,1600074802,NULL,0);
+INSERT INTO messages VALUES(NULL,'1218070f-c820-40e1-bd33-5099d894683a',4,6,NULL,'Hello',1,1,1600075652,NULL,0);
+INSERT INTO messages VALUES(NULL,'9abcc777-5b06-4570-9b83-48603a49add2',4,6,NULL,'Hi.',1,-1,1600075658,NULL,0);
+INSERT INTO messages VALUES(NULL,'c5b99952-5517-4620-8f28-fb97f5017cee',6,8,NULL,'May I call you?',1,-1,1600075789,NULL,0);
+INSERT INTO messages VALUES(NULL,'fe352125-1772-4360-831e-e2d56bb73c73',6,8,NULL,'Are you there?',1,-1,1600075790,NULL,0);
+INSERT INTO messages VALUES(NULL,'c597bd6a-2e60-4df3-9c05-cc0c88861721',6,8,NULL,'OK. Call me later',1,-1,1600075791,NULL,0);
+INSERT INTO messages VALUES(NULL,'f098e603-5ac1-4d5a-bcad-c7fe84c91252',6,8,NULL,'Sure, you may call me',1,1,1600075889,NULL,0);
+INSERT INTO messages VALUES(NULL,'9d401342-3e30-4b25-859b-b56bd0ec2839',5,7,NULL,'SMS to India',1,-1,1600075909,NULL,0);
+INSERT INTO messages VALUES(NULL,'776a3885-5cb1-41ed-9423-dfe3d2ac772a',5,7,NULL,'More SMS to India',1,-1,1600075913,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-IN-v0.sql 0.2.0-1/tests/history-db/sms-IN-v0.sql
--- 0.1.17-1/tests/history-db/sms-IN-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-IN-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,41 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_im VALUES(NULL,1600074685,1,'SMS','+12133210011','259478cf-64b3-44e1-9b1c-5d1773edc601','Hi');
+INSERT INTO chatty_im VALUES(NULL,1600074687,-1,'SMS','+1 213 321 0011','af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d','How are you?');
+INSERT INTO chatty_im VALUES(NULL,1600074789,1,'SMS','+12133210011','1a1cbd44-7526-4032-9665-45aee085ab65','I''m fine');
+INSERT INTO chatty_im VALUES(NULL,1600074800,1,'SMS','Mobile@5G','601f2a66-e6a6-4083-9dce-e5d78fb57520','Get Unlimitted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600074802,1,'SMS','5555','4dafafd9-734c-4f86-b1ec-09aa327b8a88','Free unlimitted internet 4 99$');
+INSERT INTO chatty_im VALUES(NULL,1600074809,1,'SMS','Mobile@5G','271fe95c-5d47-4ffe-ae62-7f2f6b749711','Get Unlimmtted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600075652,1,'SMS','+919876121212','1218070f-c820-40e1-bd33-5099d894683a','Hello');
+INSERT INTO chatty_im VALUES(NULL,1600075658,-1,'SMS','+919876121212','9abcc777-5b06-4570-9b83-48603a49add2','Hi.');
+INSERT INTO chatty_im VALUES(NULL,1600075789,-1,'SMS','9995123456','c5b99952-5517-4620-8f28-fb97f5017cee','May I call you?');
+INSERT INTO chatty_im VALUES(NULL,1600075790,-1,'SMS','09995123456','fe352125-1772-4360-831e-e2d56bb73c73','Are you there?');
+INSERT INTO chatty_im VALUES(NULL,1600075791,-1,'SMS','00919995123456','c597bd6a-2e60-4df3-9c05-cc0c88861721','OK. Call me later');
+INSERT INTO chatty_im VALUES(NULL,1600075889,1,'SMS','+919995123456','f098e603-5ac1-4d5a-bcad-c7fe84c91252','Sure, you may call me');
+INSERT INTO chatty_im VALUES(NULL,1600075909,-1,'SMS','+4915112345678','9d401342-3e30-4b25-859b-b56bd0ec2839','SMS to Germany');
+INSERT INTO chatty_im VALUES(NULL,1600075913,-1,'SMS','004915112345678','776a3885-5cb1-41ed-9423-dfe3d2ac772a','More SMS to Germany');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-IN-v1.sql 0.2.0-1/tests/history-db/sms-IN-v1.sql
--- 0.1.17-1/tests/history-db/sms-IN-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-IN-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,109 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+-- INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,2,NULL,'I''m fine',1,1,1600074789,NULL,0);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'+12133210011',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(4,'Mobile@5G',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(5,'5555',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(6,'+919876121212',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(7,'+919995123456',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(8,'+4915112345678',NULL,NULL,NULL,1);
+
+INSERT INTO threads VALUES(1,'+12133210011','+12133210011',1,0,0,NULL);
+INSERT INTO threads VALUES(2,'Mobile@5G','Mobile@5G',1,0,0,NULL);
+INSERT INTO threads VALUES(3,'5555','5555',1,0,0,NULL);
+INSERT INTO threads VALUES(4,'+919876121212','+919876121212',1,0,0,NULL);
+INSERT INTO threads VALUES(5,'+919995123456','9995123456',1,0,0,NULL);
+INSERT INTO threads VALUES(6,'+4915112345678','+4915112345678',1,0,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,3);
+INSERT INTO thread_members VALUES(2,2,4);
+INSERT INTO thread_members VALUES(3,3,5);
+INSERT INTO thread_members VALUES(4,4,6);
+INSERT INTO thread_members VALUES(5,5,7);
+INSERT INTO thread_members VALUES(6,6,8);
+
+INSERT INTO messages VALUES(NULL,'259478cf-64b3-44e1-9b1c-5d1773edc601',1,3,NULL,'Hi',1,1,1600074685,NULL,0);
+INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,3,NULL,'I''m fine',1,1,1600074789,NULL,0);
+INSERT INTO messages VALUES(NULL,'af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d',1,3,NULL,'How are you?',1,-1,1600074687,NULL,0);
+INSERT INTO messages VALUES(NULL,'601f2a66-e6a6-4083-9dce-e5d78fb57520',2,4,NULL,'Get Unlimitted 5G',1,1,1600074800,NULL,0);
+INSERT INTO messages VALUES(NULL,'271fe95c-5d47-4ffe-ae62-7f2f6b749711',2,4,NULL,'Get Unlimmtted 5G',1,1,1600074809,NULL,0);
+INSERT INTO messages VALUES(NULL,'4dafafd9-734c-4f86-b1ec-09aa327b8a88',3,5,NULL,'Free unlimitted internet 4 99$',1,1,1600074802,NULL,0);
+INSERT INTO messages VALUES(NULL,'1218070f-c820-40e1-bd33-5099d894683a',4,6,NULL,'Hello',1,1,1600075652,NULL,0);
+INSERT INTO messages VALUES(NULL,'9abcc777-5b06-4570-9b83-48603a49add2',4,6,NULL,'Hi.',1,-1,1600075658,NULL,0);
+INSERT INTO messages VALUES(NULL,'c5b99952-5517-4620-8f28-fb97f5017cee',5,7,NULL,'May I call you?',1,-1,1600075789,NULL,0);
+INSERT INTO messages VALUES(NULL,'fe352125-1772-4360-831e-e2d56bb73c73',5,7,NULL,'Are you there?',1,-1,1600075790,NULL,0);
+INSERT INTO messages VALUES(NULL,'c597bd6a-2e60-4df3-9c05-cc0c88861721',5,7,NULL,'OK. Call me later',1,-1,1600075791,NULL,0);
+INSERT INTO messages VALUES(NULL,'f098e603-5ac1-4d5a-bcad-c7fe84c91252',5,7,NULL,'Sure, you may call me',1,1,1600075889,NULL,0);
+INSERT INTO messages VALUES(NULL,'9d401342-3e30-4b25-859b-b56bd0ec2839',6,8,NULL,'SMS to Germany',1,-1,1600075909,NULL,0);
+INSERT INTO messages VALUES(NULL,'776a3885-5cb1-41ed-9423-dfe3d2ac772a',6,8,NULL,'More SMS to Germany',1,-1,1600075913,NULL,0);
+
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-v0.sql 0.2.0-1/tests/history-db/sms-v0.sql
--- 0.1.17-1/tests/history-db/sms-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,38 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_im VALUES(NULL,1600074685,1,'SMS','+12133210011','259478cf-64b3-44e1-9b1c-5d1773edc601','Hi');
+INSERT INTO chatty_im VALUES(NULL,1600074686,-1,'SMS','(213) 321-0011','22be2899-8c1e-4501-ab33-979c356a6764','Hello');
+INSERT INTO chatty_im VALUES(NULL,1600074687,-1,'SMS','+1 213 321 0011','af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d','How are you?');
+INSERT INTO chatty_im VALUES(NULL,1600074789,1,'SMS','+12133210011','1a1cbd44-7526-4032-9665-45aee085ab65','I''m fine');
+INSERT INTO chatty_im VALUES(NULL,1600074800,1,'SMS','Mobile@5G','601f2a66-e6a6-4083-9dce-e5d78fb57520','Get Unlimitted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600074802,1,'SMS','5555','4dafafd9-734c-4f86-b1ec-09aa327b8a88','Free unlimitted internet 4 99$');
+INSERT INTO chatty_im VALUES(NULL,1600074809,1,'SMS','Mobile@5G','271fe95c-5d47-4ffe-ae62-7f2f6b749711','Get Unlimmtted 5G');
+INSERT INTO chatty_im VALUES(NULL,1600075652,1,'SMS','+919876121212','1218070f-c820-40e1-bd33-5099d894683a','Hello');
+INSERT INTO chatty_im VALUES(NULL,1600075658,-1,'SMS','+919876121212','9abcc777-5b06-4570-9b83-48603a49add2','Hi.');
+INSERT INTO chatty_im VALUES(NULL,1600075789,-1,'SMS','(213) 345-6789','c5b99952-5517-4620-8f28-fb97f5017cee','May I call you?');
+INSERT INTO chatty_im VALUES(NULL,1600075889,1,'SMS','+12133456789','f098e603-5ac1-4d5a-bcad-c7fe84c91252','Sure, you may call me');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/sms-v1.sql 0.2.0-1/tests/history-db/sms-v1.sql
--- 0.1.17-1/tests/history-db/sms-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/sms-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,102 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+-- INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,2,NULL,'I''m fine',1,1,1600074789,NULL,0);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'+12133210011',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(4,'Mobile@5G',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(5,'5555',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(6,'+919876121212',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(7,'+12133456789',NULL,NULL,NULL,1);
+
+INSERT INTO threads VALUES(1,'+12133210011','+12133210011',1,0,0,NULL);
+INSERT INTO threads VALUES(2,'Mobile@5G','Mobile@5G',1,0,0,NULL);
+INSERT INTO threads VALUES(3,'5555','5555',1,0,0,NULL);
+INSERT INTO threads VALUES(4,'+919876121212','+919876121212',1,0,0,NULL);
+INSERT INTO threads VALUES(5,'+12133456789','(213) 345-6789',1,0,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,3);
+INSERT INTO thread_members VALUES(2,2,4);
+INSERT INTO thread_members VALUES(3,3,5);
+INSERT INTO thread_members VALUES(4,4,6);
+INSERT INTO thread_members VALUES(5,5,7);
+
+INSERT INTO messages VALUES(NULL,'1a1cbd44-7526-4032-9665-45aee085ab65',1,3,NULL,'I''m fine',1,1,1600074789,NULL,0);
+INSERT INTO messages VALUES(NULL,'259478cf-64b3-44e1-9b1c-5d1773edc601',1,3,NULL,'Hi',1,1,1600074685,NULL,0);
+INSERT INTO messages VALUES(NULL,'22be2899-8c1e-4501-ab33-979c356a6764',1,3,NULL,'Hello',1,-1,1600074686,NULL,0);
+INSERT INTO messages VALUES(NULL,'af65adc0-2d80-4de8-83bb-9bf9ea4ebd5d',1,3,NULL,'How are you?',1,-1,1600074687,NULL,0);
+INSERT INTO messages VALUES(NULL,'271fe95c-5d47-4ffe-ae62-7f2f6b749711',2,4,NULL,'Get Unlimmtted 5G',1,1,1600074809,NULL,0);
+INSERT INTO messages VALUES(NULL,'601f2a66-e6a6-4083-9dce-e5d78fb57520',2,4,NULL,'Get Unlimitted 5G',1,1,1600074800,NULL,0);
+INSERT INTO messages VALUES(NULL,'4dafafd9-734c-4f86-b1ec-09aa327b8a88',3,5,NULL,'Free unlimitted internet 4 99$',1,1,1600074802,NULL,0);
+INSERT INTO messages VALUES(NULL,'1218070f-c820-40e1-bd33-5099d894683a',4,6,NULL,'Hello',1,1,1600075652,NULL,0);
+INSERT INTO messages VALUES(NULL,'9abcc777-5b06-4570-9b83-48603a49add2',4,6,NULL,'Hi.',1,-1,1600075658,NULL,0);
+INSERT INTO messages VALUES(NULL,'c5b99952-5517-4620-8f28-fb97f5017cee',5,7,NULL,'May I call you?',1,-1,1600075789,NULL,0);
+INSERT INTO messages VALUES(NULL,'f098e603-5ac1-4d5a-bcad-c7fe84c91252',5,7,NULL,'Sure, you may call me',1,1,1600075889,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/telegram-chat-v0.sql 0.2.0-1/tests/history-db/telegram-chat-v0.sql
--- 0.1.17-1/tests/history-db/telegram-chat-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/telegram-chat-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,37 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_chat VALUES(NULL,1502695424,1,'+19812121212','Random room',NULL,'c485ac17-513e-4e16-b049-dbc21e000ed8','Hi');
+INSERT INTO chatty_chat VALUES(NULL,1502695426,1,'+19812121212','Random room',NULL,'3f5f7d60-1510-4249-80f4-ad802fa9483f','Hello');
+INSERT INTO chatty_chat VALUES(NULL,1502695429,1,'+19812121212','Random room','New Person','26b5bd41-8f34-476a-bb03-9ed8f8129817','I''m New, Hi');
+INSERT INTO chatty_chat VALUES(NULL,1502695429,1,'+19876543210','Random room','New Person','4d3defa2-85a2-4cd5-9e1b-940b2c406351','New here');
+INSERT INTO chatty_chat VALUES(NULL,1502695432,1,'+19876543210','Random room','Random Person','955044fb-fc34-42a1-88c7-acdd0c45acc7','I''m random');
+INSERT INTO chatty_chat VALUES(NULL,1502695432,1,'+19876543210','Another Room@example.com','Random Person','53269985-89da-4e01-9914-fa053735d59f','Another me');
+INSERT INTO chatty_chat VALUES(NULL,1502695569,1,'+19876543210','Another Room@example.com','Bob','92a4e961-b3ac-487c-9dd6-c645944e5946','I''m bob');
+INSERT INTO chatty_chat VALUES(NULL,1502695572,1,'+19876543210','Another Room@example.com',NULL,'be6ca8bf-b5d9-4983-bbd3-3767eda52f4a','I''m empty');
+INSERT INTO chatty_chat VALUES(NULL,1502695573,-1,'+19876543210','Another Room@example.com',NULL,'1525c407-7c3d-4b02-8e26-a6e86183a8bc','Hello all');
+INSERT INTO chatty_chat VALUES(NULL,1502695587,1,'+1 981 212 1212','Random room','Random Person','21fb7985-c3c4-4292-ab84-1b7c637c727a','Let me know who is here?');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/telegram-chat-v1.sql 0.2.0-1/tests/history-db/telegram-chat-v1.sql
--- 0.1.17-1/tests/history-db/telegram-chat-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/telegram-chat-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,102 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'New Person','New Person',NULL,NULL,1);
+INSERT INTO users VALUES(4,'+19876543210',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(5,'+19812121212',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(6,'Random Person','Random Person',NULL,NULL,1);
+INSERT INTO users VALUES(7,'Bob','Bob',NULL,NULL,1);
+
+INSERT INTO accounts VALUES(3,4,NULL,0,5);
+INSERT INTO accounts VALUES(4,5,NULL,0,5);
+
+INSERT INTO threads VALUES(1,'Random room','Random room',4,1,0,NULL);
+INSERT INTO threads VALUES(2,'Random room','Random room',3,1,0,NULL);
+INSERT INTO threads VALUES(3,'Another Room@example.com','Another Room@example.com',3,1,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,3);
+INSERT INTO thread_members VALUES(2,2,3);
+INSERT INTO thread_members VALUES(3,2,6);
+INSERT INTO thread_members VALUES(4,3,6);
+INSERT INTO thread_members VALUES(5,3,7);
+INSERT INTO thread_members VALUES(6,1,6);
+
+INSERT INTO messages VALUES(NULL,'3f5f7d60-1510-4249-80f4-ad802fa9483f',1,NULL,NULL,'Hello',2,1,1502695426,NULL,0);
+INSERT INTO messages VALUES(NULL,'c485ac17-513e-4e16-b049-dbc21e000ed8',1,NULL,NULL,'Hi',2,1,1502695424,NULL,0);
+INSERT INTO messages VALUES(NULL,'26b5bd41-8f34-476a-bb03-9ed8f8129817',1,3,NULL,'I''m New, Hi',2,1,1502695429,NULL,0);
+INSERT INTO messages VALUES(NULL,'4d3defa2-85a2-4cd5-9e1b-940b2c406351',2,3,NULL,'New here',2,1,1502695429,NULL,0);
+INSERT INTO messages VALUES(NULL,'955044fb-fc34-42a1-88c7-acdd0c45acc7',2,6,NULL,'I''m random',2,1,1502695432,NULL,0);
+INSERT INTO messages VALUES(NULL,'1525c407-7c3d-4b02-8e26-a6e86183a8bc',3,4,NULL,'Hello all',2,-1,1502695573,NULL,0);
+INSERT INTO messages VALUES(NULL,'be6ca8bf-b5d9-4983-bbd3-3767eda52f4a',3,NULL,NULL,'I''m empty',2,1,1502695572,NULL,0);
+INSERT INTO messages VALUES(NULL,'53269985-89da-4e01-9914-fa053735d59f',3,6,NULL,'Another me',2,1,1502695432,NULL,0);
+INSERT INTO messages VALUES(NULL,'92a4e961-b3ac-487c-9dd6-c645944e5946',3,7,NULL,'I''m bob',2,1,1502695569,NULL,0);
+INSERT INTO messages VALUES(NULL,'21fb7985-c3c4-4292-ab84-1b7c637c727a',1,6,NULL,'Let me know who is here?',2,1,1502695587,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/telegram-im-v0.sql 0.2.0-1/tests/history-db/telegram-im-v0.sql
--- 0.1.17-1/tests/history-db/telegram-im-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/telegram-im-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,37 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_im VALUES(NULL,1502685271,1,'+351-123-456-789','Random Person','01241679-58e4-4e65-b88f-67e70d617594','Hi');
+INSERT INTO chatty_im VALUES(NULL,1502685274,1,'+351-123-456-789','Random Person','8a7ba154-9e09-4845-973e-cc6f8aedcdc5','Hello');
+INSERT INTO chatty_im VALUES(NULL,1502685280,-1,'+351-123-456-789','Random Person','b23a7a25-7bdf-44ac-8685-d6881f3eaf90','Yeah');
+INSERT INTO chatty_im VALUES(NULL,1502685282,-1,'+351123456789','Another Person','5a60ea9e-e6a0-4c5e-94bf-5e2330be4547','Hi');
+INSERT INTO chatty_im VALUES(NULL,1502685284,1,'+351123456789','Another Person','dd12cdf6-0d8c-4010-8138-9640237ccc15','I''m here');
+INSERT INTO chatty_im VALUES(NULL,1502685295,1,'+351123456789','Random Person','0887db8b-11f1-4167-9dfa-c8a4a0fad6d2','Can you call me @9:00?');
+INSERT INTO chatty_im VALUES(NULL,1502685300,1,'+19876543210','Alice','84406650-c4a6-435d-ba4f-ac193b59a975','Hi');
+INSERT INTO chatty_im VALUES(NULL,1502685303,-1,'+19876543210','Alice','e9d54317-9234-4de8-b345-c3a8e4d3b322','Hello');
+INSERT INTO chatty_im VALUES(NULL,1502685304,1,'+1 987 654 3210','Alice','a88e7db7-3d41-4e3e-8e21-d1e4e6466a01','How are you');
+INSERT INTO chatty_im VALUES(NULL,1502685403,-1,'+19876543210','Random Person','bf5b5a8c-e9bc-4c22-b215-bdb624c0524d','Hello Random');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/telegram-im-v1.sql 0.2.0-1/tests/history-db/telegram-im-v1.sql
--- 0.1.17-1/tests/history-db/telegram-im-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/telegram-im-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,101 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'+19876543210',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(4,'Alice','Alice',NULL,NULL,1);
+INSERT INTO users VALUES(5,'Random Person','Random Person',NULL,NULL,1);
+INSERT INTO users VALUES(6,'+351123456789',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(7,'Another Person','Another Person',NULL,NULL,1);
+
+INSERT INTO accounts VALUES(3,3,NULL,0,5);
+INSERT INTO accounts VALUES(4,6,NULL,0,5);
+
+INSERT INTO threads VALUES(1,'Alice','Alice',3,0,0,NULL);
+INSERT INTO threads VALUES(2,'Random Person','Random Person',3,0,0,NULL);
+INSERT INTO threads VALUES(3,'Random Person','Random Person',4,0,0,NULL);
+INSERT INTO threads VALUES(4,'Another Person','Another Person',4,0,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,4);
+INSERT INTO thread_members VALUES(2,2,5);
+INSERT INTO thread_members VALUES(3,3,5);
+INSERT INTO thread_members VALUES(4,4,7);
+
+INSERT INTO messages VALUES(NULL,'a88e7db7-3d41-4e3e-8e21-d1e4e6466a01',1,4,NULL,'How are you',2,1,1502685304,NULL,0);
+INSERT INTO messages VALUES(NULL,'84406650-c4a6-435d-ba4f-ac193b59a975',1,4,NULL,'Hi',2,1,1502685300,NULL,0);
+INSERT INTO messages VALUES(NULL,'e9d54317-9234-4de8-b345-c3a8e4d3b322',1,4,NULL,'Hello',2,-1,1502685303,NULL,0);
+INSERT INTO messages VALUES(NULL,'bf5b5a8c-e9bc-4c22-b215-bdb624c0524d',2,5,NULL,'Hello Random',2,-1,1502685403,NULL,0);
+INSERT INTO messages VALUES(NULL,'01241679-58e4-4e65-b88f-67e70d617594',3,5,NULL,'Hi',2,1,1502685271,NULL,0);
+INSERT INTO messages VALUES(NULL,'8a7ba154-9e09-4845-973e-cc6f8aedcdc5',3,5,NULL,'Hello',2,1,1502685274,NULL,0);
+INSERT INTO messages VALUES(NULL,'b23a7a25-7bdf-44ac-8685-d6881f3eaf90',3,5,NULL,'Yeah',2,-1,1502685280,NULL,0);
+INSERT INTO messages VALUES(NULL,'0887db8b-11f1-4167-9dfa-c8a4a0fad6d2',3,5,NULL,'Can you call me @9:00?',2,1,1502685295,NULL,0);
+INSERT INTO messages VALUES(NULL,'5a60ea9e-e6a0-4c5e-94bf-5e2330be4547',4,7,NULL,'Hi',2,-1,1502685282,NULL,0);
+INSERT INTO messages VALUES(NULL,'dd12cdf6-0d8c-4010-8138-9640237ccc15',4,7,NULL,'I''m here',2,1,1502685284,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/xmpp-im-v0.sql 0.2.0-1/tests/history-db/xmpp-im-v0.sql
--- 0.1.17-1/tests/history-db/xmpp-im-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/xmpp-im-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,34 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_im VALUES(NULL,1602158858,1,'account@example.com','buddy@example.com','NKkdrKrNSbYlZUZl','Some test message');
+INSERT INTO chatty_im VALUES(NULL,1602143858,-1,'account@example.com','user@example.com','NKkdrKrNSDsXDUZl','Another test message');
+INSERT INTO chatty_im VALUES(NULL,1602143838,1,'account@example.com','friend@example.com/resource','NKkdrK32DFDsXDUZl','Message with resource');
+INSERT INTO chatty_im VALUES(NULL,1602143858,0,'account@example.com','user@example.com','NKkdrKrNSDsXsdxZl','This is a system message');
+INSERT INTO chatty_im VALUES(NULL,1602143859,1,'alice@example.com','bob@example.com','e465e9da-0d1a-11eb-93ea-e30b7b9ae820','Hi');
+INSERT INTO chatty_im VALUES(NULL,1602143867,-1,'account@example.com','bob@example.com','2ebff02a-0d1b-11eb-aa37-5fdd4a70e5d0','Hi');
+INSERT INTO chatty_im VALUES(NULL,1602145677,-1,'alice@example.com','bob@example.com','4b58bb22-0d1b-11eb-b502-8b03cec4d745','Hi');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/xmpp-im-v1.sql 0.2.0-1/tests/history-db/xmpp-im-v1.sql
--- 0.1.17-1/tests/history-db/xmpp-im-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/xmpp-im-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,101 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'user@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(4,'buddy@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(5,'friend@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(6,'bob@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(7,'account@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(8,'alice@example.com',NULL,NULL,NULL,3);
+
+INSERT INTO accounts VALUES(3,7,NULL,0,3);
+INSERT INTO accounts VALUES(4,8,NULL,0,3);
+
+INSERT INTO threads VALUES(1,'bob@example.com',NULL,3,0,0,NULL);
+INSERT INTO threads VALUES(2,'friend@example.com',NULL,3,0,0,NULL);
+INSERT INTO threads VALUES(3,'user@example.com',NULL,3,0,0,NULL);
+INSERT INTO threads VALUES(4,'buddy@example.com',NULL,3,0,0,NULL);
+INSERT INTO threads VALUES(5,'bob@example.com',NULL,4,0,0,NULL);
+
+INSERT INTO thread_members VALUES(1,1,6);
+INSERT INTO thread_members VALUES(2,2,5);
+INSERT INTO thread_members VALUES(3,3,3);
+INSERT INTO thread_members VALUES(4,4,4);
+INSERT INTO thread_members VALUES(5,5,6);
+
+INSERT INTO messages VALUES(NULL,'2ebff02a-0d1b-11eb-aa37-5fdd4a70e5d0',1,6,NULL,'Hi',2,-1,1602143867,NULL,0);
+INSERT INTO messages VALUES(NULL,'NKkdrK32DFDsXDUZl',2,5,NULL,'Message with resource',2,1,1602143838,NULL,0);
+INSERT INTO messages VALUES(NULL,'NKkdrKrNSDsXDUZl',3,3,NULL,'Another test message',2,-1,1602143858,NULL,0);
+INSERT INTO messages VALUES(NULL,'NKkdrKrNSDsXsdxZl',3,3,NULL,'This is a system message',2,0,1602143858,NULL,0);
+INSERT INTO messages VALUES(NULL,'NKkdrKrNSbYlZUZl',4,4,NULL,'Some test message',2,1,1602158858,NULL,0);
+INSERT INTO messages VALUES(NULL,'4b58bb22-0d1b-11eb-b502-8b03cec4d745',5,6,NULL,'Hi',2,-1,1602145677,NULL,0);
+INSERT INTO messages VALUES(NULL,'e465e9da-0d1a-11eb-93ea-e30b7b9ae820',5,6,NULL,'Hi',2,1,1602143859,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/xmpp-muc-v0.sql 0.2.0-1/tests/history-db/xmpp-muc-v0.sql
--- 0.1.17-1/tests/history-db/xmpp-muc-v0.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/xmpp-muc-v0.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,35 @@
+BEGIN TRANSACTION;
+CREATE TABLE chatty_im(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT_NULL,
+  who TEXT NOT_NULL,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE TABLE chatty_chat(
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  timestamp INTEGER NOT_NULL,
+  direction INTEGER NOT NULL,
+  account TEXT NOT NULL,
+  room TEXT NOT_NULL,
+  who TEXT,
+  uid TEXT NOT_NULL,
+  message TEXT,
+  UNIQUE (timestamp, message)
+);
+CREATE UNIQUE INDEX chatty_im_acc_uid ON chatty_im(account, uid);
+CREATE UNIQUE INDEX chatty_chat_room_uid ON chatty_chat(room, uid);
+
+INSERT INTO chatty_chat VALUES(NULL,1587854453,1,'alice@example.org','room@conference.example.com','room@conference.example.com/bob','1fa48654-0eed-11eb-9110-b7542262f3bf','Hello everyone');
+INSERT INTO chatty_chat VALUES(NULL,1587854455,1,'alice@example.org','room@conference.example.com','room@conference.example.com/bob','40a341d8-0eed-11eb-91be-dbcbdfd6fab6','Good morning');
+INSERT INTO chatty_chat VALUES(NULL,1587854458,1,'alice@example.org','room@conference.example.com','bob@example.com','96001322-0eed-11eb-b943-ffb19c0eb13a','Hi');
+INSERT INTO chatty_chat VALUES(NULL,1587854459,1,'alice@example.org','room@conference.example.com',NULL,'1587644391694312','Is this good?');
+INSERT INTO chatty_chat VALUES(NULL,1587854658,1,'jhon@example.org','another-room@conference.example.com','bob@example.com/MY7yLBdJ','12c97d94-0eee-11eb-86e0-7fe0e99a74bb','Is this another room?');
+INSERT INTO chatty_chat VALUES(NULL,1587854658,-1,'jhon@example.org','another-room@conference.example.com',NULL,'43511f76-0eee-11eb-98fc-23b32f642943','Yes this is another room');
+INSERT INTO chatty_chat VALUES(NULL,1587854661,-1,'jhon@example.org','another-room@conference.example.com','jhon@example.org','7f21eca6-0eee-11eb-bdfd-5be4cafcdd69','Feel free to speak anything');
+INSERT INTO chatty_chat VALUES(NULL,1587854682,-1,'charlie@example.org','room@conference.example.com',NULL,'d4097d22-0efa-11eb-b349-9317bde881f6','Hello');
+
+COMMIT;
diff -pruN 0.1.17-1/tests/history-db/xmpp-muc-v1.sql 0.2.0-1/tests/history-db/xmpp-muc-v1.sql
--- 0.1.17-1/tests/history-db/xmpp-muc-v1.sql	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/history-db/xmpp-muc-v1.sql	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,98 @@
+BEGIN TRANSACTION;
+PRAGMA user_version = 1;
+PRAGMA foreign_keys = ON;
+CREATE TABLE files (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  url TEXT,
+  path TEXT,
+  mime_type TEXT,
+  size INTEGER
+);
+CREATE TABLE users (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  username TEXT NOT NULL,
+  alias TEXT, avatar_id INTEGER REFERENCES files(id),
+  thumbnail_id INTEGER REFERENCES files(id),
+  type INTEGER NOT NULL,
+  UNIQUE (username, type)
+);
+INSERT INTO users VALUES(1,'SMS',NULL,NULL,NULL,1);
+INSERT INTO users VALUES(2,'MMS',NULL,NULL,NULL,1);
+CREATE TABLE accounts (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  password TEXT,
+  enabled INTEGER DEFAULT 0,
+  protocol INTEGER NOT NULL,
+  UNIQUE (user_id, protocol)
+);
+INSERT INTO accounts VALUES(1,1,NULL,0,1);
+INSERT INTO accounts VALUES(2,2,NULL,0,2);
+CREATE TABLE threads (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  name TEXT NOT NULL,
+  alias TEXT,
+  account_id INTEGER NOT NULL REFERENCES accounts(id) ON DELETE CASCADE,
+  type INTEGER NOT NULL,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (name, account_id, type)
+);
+CREATE TABLE thread_members (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  user_id INTEGER NOT NULL REFERENCES users(id),
+  UNIQUE (thread_id, user_id)
+);
+CREATE TABLE messages (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  uid TEXT NOT NULL,
+  thread_id INTEGER NOT NULL REFERENCES threads(id) ON DELETE CASCADE,
+  sender_id INTEGER REFERENCES users(id),
+  user_alias TEXT,
+  body TEXT NOT NULL,
+  body_type INTEGER NOT NULL,
+  direction INTEGER NOT NULL,
+  time INTEGER NOT NULL,
+  status INTEGER,
+  encrypted INTEGER DEFAULT 0,
+  UNIQUE (uid, thread_id, body, time)
+);
+CREATE TABLE media (
+  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
+  file_id INTEGER NOT NULL UNIQUE,
+  thumbnail_id INTEGER REFERENCES media(id),
+  width INTEGER,
+  height INTEGER,
+  FOREIGN KEY(file_id) REFERENCES files(id)
+);
+ALTER TABLE threads ADD COLUMN last_read_id INTEGER REFERENCES messages(id);
+
+INSERT INTO users VALUES(3,'charlie@example.org',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(4,'room@conference.example.com/bob',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(5,'bob@example.com',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(6,'alice@example.org',NULL,NULL,NULL,3);
+INSERT INTO users VALUES(7,'jhon@example.org',NULL,NULL,NULL,3);
+
+INSERT INTO accounts VALUES(3,3,NULL,0,3);
+INSERT INTO accounts VALUES(4,6,NULL,0,3);
+INSERT INTO accounts VALUES(5,7,NULL,0,3);
+
+INSERT INTO threads VALUES(1,'another-room@conference.example.com',NULL,5,1,0,NULL);
+INSERT INTO threads VALUES(2,'room@conference.example.com',NULL,4,1,0,NULL);
+INSERT INTO threads VALUES(3,'room@conference.example.com',NULL,3,1,0,NULL);
+
+INSERT INTO thread_members VALUES(1,2,4);
+INSERT INTO thread_members VALUES(2,2,5);
+INSERT INTO thread_members VALUES(3,1,5);
+
+INSERT INTO messages VALUES(NULL,'43511f76-0eee-11eb-98fc-23b32f642943',1,7,NULL,'Yes this is another room',2,-1,1587854658,NULL,0);
+INSERT INTO messages VALUES(NULL,'12c97d94-0eee-11eb-86e0-7fe0e99a74bb',1,5,NULL,'Is this another room?',2,1,1587854658,NULL,0);
+INSERT INTO messages VALUES(NULL,'7f21eca6-0eee-11eb-bdfd-5be4cafcdd69',1,7,NULL,'Feel free to speak anything',2,-1,1587854661,NULL,0);
+INSERT INTO messages VALUES(NULL,'1fa48654-0eed-11eb-9110-b7542262f3bf',2,4,NULL,'Hello everyone',2,1,1587854453,NULL,0);
+INSERT INTO messages VALUES(NULL,'40a341d8-0eed-11eb-91be-dbcbdfd6fab6',2,4,NULL,'Good morning',2,1,1587854455,NULL,0);
+INSERT INTO messages VALUES(NULL,'96001322-0eed-11eb-b943-ffb19c0eb13a',2,5,NULL,'Hi',2,1,1587854458,NULL,0);
+INSERT INTO messages VALUES(NULL,'1587644391694312',2,NULL,NULL,'Is this good?',2,1,1587854459,NULL,0);
+INSERT INTO messages VALUES(NULL,'d4097d22-0efa-11eb-b349-9317bde881f6',3,3,NULL,'Hello',2,-1,1587854682,NULL,0);
+
+COMMIT;
diff -pruN 0.1.17-1/tests/meson.build 0.2.0-1/tests/meson.build
--- 0.1.17-1/tests/meson.build	2020-11-02 03:06:49.000000000 +0000
+++ 0.2.0-1/tests/meson.build	2020-11-27 09:44:20.000000000 +0000
@@ -13,6 +13,7 @@ test_items = [
   'account',
   'history',
   'settings',
+  'utils',
 ]
 
 foreach item: test_items
@@ -20,7 +21,7 @@ foreach item: test_items
     item,
     item + '.c',
     include_directories: tests_inc,
-    link_with: libchatty,
+    link_with: libchatty.get_static_lib(),
     dependencies: chatty_deps,
   )
   test(item, t, env: env)
diff -pruN 0.1.17-1/tests/utils.c 0.2.0-1/tests/utils.c
--- 0.1.17-1/tests/utils.c	1970-01-01 00:00:00.000000000 +0000
+++ 0.2.0-1/tests/utils.c	2020-11-27 09:44:20.000000000 +0000
@@ -0,0 +1,196 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*- */
+/* utils.c
+ *
+ * Copyright 2020 Purism SPC
+ *
+ * Author(s):
+ *   Mohammed Sadiq <sadiq@sadiqpk.org>
+ *
+ * SPDX-License-Identifier: GPL-3.0-or-later
+ */
+
+#undef NDEBUG
+#undef G_DISABLE_ASSERT
+#undef G_DISABLE_CHECKS
+#undef G_DISABLE_CAST_CHECKS
+#undef G_LOG_DOMAIN
+
+#include "chatty-settings.h"
+#include "chatty-phone-utils.h"
+#include "chatty-utils.h"
+
+const char *valid[][2] = {
+  {"9633123456", "IN"},
+  {"9633 123 456", "IN"},
+  {"+91 9633 123 456", "IN"},
+  {"+91 9633 123 456", "US"},
+  {"20 8759 9036", "GB"},
+};
+
+const char *invalid[][2] = {
+  {"9633123456", "US"},
+  {"20 8759 9036", "IN"},
+  {"123456", "IN"},
+  {"123456", "US"},
+  {"123456", NULL},
+  {"123456", ""},
+  {"", ""},
+  {NULL, ""},
+  {NULL, "US"},
+  {"INVALID", ""},
+  {"INVALID", "US"},
+};
+
+const char *phone[][3] = {
+  {"9633123456", "IN", "+919633123456"},
+  {"09633123456", "IN", "+919633123456"},
+  {"00919633123456", "IN", "+919633123456"},
+  {"+919633123456", "IN", "+919633123456"},
+  {"+919633123456", "US", "+919633123456"},
+  {"9633 123 456", "IN", "+919633123456"},
+  {"9633 123 456", "DE", "+499633123456"},
+  {"9633123456", "US", "(963) 312-3456"},
+  {"213-321-9876", "US", "+12133219876"},
+  {"(213) 321-9876", "US", "+12133219876"},
+  {"+1 213 321 9876", "US", "+12133219876"},
+  {"+1 213 321 9876", "DE", "+12133219876"},
+  {"+1 213 321 9876", "PL", "+12133219876"},
+  {"+1 213 321 9876", "GB", "+12133219876"},
+  {"+12133219876", "US", "+12133219876"},
+  {"00919633123456", "GB", "+919633123456"},
+  {"sms://00919633123456", "GB", "+919633123456"},
+  {"12345", "IN", "12345"},
+  {"12345", "US", "12345"},
+  {"12345", "DE", "12345"},
+  {"72404", "DE", "72404"},
+  {"5800678", "IN", "5800678"},
+  {"555555", "IN", "555555"},
+  {"5555", "PL", "5555"},
+  {"7126", "PL", "7126"},
+  {"80510", "PL", "80510"},
+  {"112", "DE", "112"},
+  {"112", "US", "112"},
+  {"112", "IN", "112"},
+  {"911", "US", "911"},
+  {"sms://911", "US", "911"},
+  {"BT-123", "IN", NULL},
+  {"123-BT", "IN", NULL},
+};
+
+static void
+test_phone_utils_valid (void)
+{
+  for (guint i = 0; i < G_N_ELEMENTS (valid); i++)
+    g_assert_true (chatty_phone_utils_is_valid (valid[i][0], valid[i][1]));
+
+  for (guint i = 0; i < G_N_ELEMENTS (invalid); i++)
+    g_assert_false (chatty_phone_utils_is_valid (invalid[i][0], invalid[i][1]));
+}
+
+static void
+test_phone_utils_check_phone (void)
+{
+  for (guint i = 0; i < G_N_ELEMENTS (phone); i++) {
+    g_autofree char *expected = NULL;
+
+    expected = chatty_utils_check_phonenumber (phone[i][0], phone[i][1]);
+    g_assert_cmpstr (expected, ==, phone[i][2]);
+  }
+}
+
+
+static void
+test_utils_username_valid (void)
+{
+  typedef struct data {
+    char *user_name;
+    ChattyProtocol protocol;
+    ChattyProtocol account_protocol;
+  } data;
+  data array[] = {
+    { "0123456789", CHATTY_PROTOCOL_SMS},
+    { "+1 (1234) 5678", CHATTY_PROTOCOL_SMS},
+    { "+91123456789", CHATTY_PROTOCOL_SMS},
+    { "+91-1234-56789", CHATTY_PROTOCOL_SMS},
+    { "+1 213 321 4567", CHATTY_PROTOCOL_SMS | CHATTY_PROTOCOL_TELEGRAM},
+    { "+12133214567", CHATTY_PROTOCOL_SMS | CHATTY_PROTOCOL_TELEGRAM},
+    { "+919995123456", CHATTY_PROTOCOL_SMS | CHATTY_PROTOCOL_TELEGRAM},
+    { "5555", CHATTY_PROTOCOL_SMS},
+    { "valid@xmpp.example.com", CHATTY_PROTOCOL_XMPP},
+    { "@valid:example.com", CHATTY_PROTOCOL_MATRIX},
+    { "@നല്ല:matrix.example.com", 0},
+    { "invalid", 0},
+    { "domain/resource", 0},
+    { "/invalid", 0},
+    { "invalid/", 0},
+    { "@invalid", 0},
+    { "invalid:", 0},
+    { "@invalid:", 0},
+    { "invalid@", 0},
+    { "in:valid@", 0},
+    { "#invalid:matrix.example.com", 0},
+    { "+9876543210A", 0},
+    { "", 0},
+    { NULL, 0}
+  };
+
+
+  for (int i = 0; i < G_N_ELEMENTS (array); i++) {
+    ChattyProtocol protocol;
+
+    protocol = chatty_utils_username_is_valid (array[i].user_name, array[i].protocol);
+    g_assert_cmpint (protocol, ==, array[i].protocol);
+
+    protocol = chatty_utils_username_is_valid (array[i].user_name, CHATTY_PROTOCOL_ANY);
+    g_assert_cmpint (protocol, ==, array[i].protocol);
+  }
+}
+
+static void
+test_utils_groupname_valid (void)
+{
+  typedef struct data {
+    char *group_name;
+    ChattyProtocol protocol;
+  } data;
+  data array[] = {
+    { "valid@xmpp.example.com", CHATTY_PROTOCOL_XMPP },
+    { "#valid:matrix.example.com", CHATTY_PROTOCOL_MATRIX },
+    { "!valid:matrix.example.com", CHATTY_PROTOCOL_MATRIX },
+    { "@invalid:matrix.example.com", 0 },
+    { "#:invalid", 0 },
+    { "@invalid", 0},
+    { "#invalid", 0},
+    { "invalid:", 0},
+    { "#invalid:", 0},
+    { "invalid#", 0},
+    { "in:valid#", 0},
+    { "#:", 0 },
+    { "", 0},
+    { NULL, 0}
+  };
+
+  for (int i = 0; i < G_N_ELEMENTS (array); i++) {
+    ChattyProtocol protocol;
+
+    protocol = chatty_utils_groupname_is_valid (array[i].group_name, array[i].protocol);
+    g_assert_cmpint (protocol, ==, array[i].protocol);
+
+    protocol = chatty_utils_groupname_is_valid (array[i].group_name, CHATTY_PROTOCOL_ANY);
+    g_assert_cmpint (protocol, ==, array[i].protocol);
+  }
+}
+
+int
+main (int   argc,
+      char *argv[])
+{
+  g_test_init (&argc, &argv, NULL);
+
+  g_test_add_func ("/phone-utils/valid", test_phone_utils_valid);
+  g_test_add_func ("/utils/check-phone", test_phone_utils_check_phone);
+  g_test_add_func ("/utils/username_valid", test_utils_username_valid);
+  g_test_add_func ("/utils/groupname_valid", test_utils_groupname_valid);
+
+  return g_test_run ();
+}
